<?php
	/*
	* GMapFP Component Google Map for Joomla! 1.7.x
	* Version 10.48pro
	* Creation date: Mai 2012
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPControllerChamps extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add'  , 	'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}

	function view()
	{
		JRequest::setVar( 'view', 'champs' );
		JRequest::setVar( 'layout', 'liste'  );

		parent::display();
	}

	function edit()
	{
		JRequest::setVar( 'view', 'champs' );
		JRequest::setVar( 'layout', 'detail'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	function save()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('champs');

		$returnid=$model->store($post);
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=view';
			$type ='message';
		} else {
			$msg = JText::_( $returnid['error'] );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&for_cat='.$returnid['for_cat'].'&catid='.$returnid['catid'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function apply()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('champs');

		$returnid=$model->store($post);
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&cid[]='.$returnid['id'];
			$type ='message';
		} else {
			$msg = $returnid['error'];
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function save2new()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('champs');

		$returnid=$model->store($post);
		if ($returnid['error'] == '') {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&cid[]=0';
			$type ='message';
		} else {
			$msg = $returnid['error'];
			$link = 'index.php?option=com_gmapfp&controller=champs&task=edit&nom='.$returnid['nom'].'&description='.$returnid['description'].'&filtrer='.$returnid['filtrer'].'&filtre_label='.$returnid['filtre_label'].'&recherche='.$returnid['recherche'].'&type='.$returnid['type'].'&parametres='.$returnid['parametres'].'&position='.$returnid['position'].'&form_separator='.$returnid['form_separator'].'&view_separator='.$returnid['view_separator'].'&published='.$returnid['published'].'&access='.$returnid['access'].'&ordering='.$returnid['ordering'];
			$type = 'error';
		}

		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg, $type);
	}

	function remove()
	{
		$model = $this->getModel('champs');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg );
	}

	function publish()
	{
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view' );

		// Initialize variables
		$db			=& JFactory::getDBO();
		$user		=& JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__gmapfp_extension_type'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $row->getError() );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );

	}
	
	function cancel()
	{
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg );
	}

	function orderup()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$mainframe = &JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',	'filter_order',	'ordering',	'cmd' );
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$model = $this->getModel('champs');
		
		if (($filter_order=='ordering')and(($filter_order_Dir=='asc')or(!($filter_order_Dir)))) {
			$model->move(-1);
		};
		if (($filter_order=='ordering')and($filter_order_Dir=='desc')) {
			$model->move(1);
		};

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view');
	}

	function orderdown()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$mainframe = &JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'ordering',	'cmd' );
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 	'filter_order_Dir', 	'', 											'word');
		$model = $this->getModel('champs');
		
		if (($filter_order=='ordering')and(($filter_order_Dir=='asc')or(!($filter_order_Dir)))) {
			$model->move(1);
		};
		if (($filter_order=='ordering')and($filter_order_Dir=='desc')) {
			$model->move(-1);
		};

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view');
	}

	function saveorder()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$cid 	= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$order 	= JRequest::getVar( 'order', array(), 'post', 'array' );
		JArrayHelper::toInteger($cid);
		JArrayHelper::toInteger($order);

		$model = $this->getModel('champs');
		$model->saveorder($cid, $order);

		$msg = JText::_( 'New ordering saved' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg );
	}
	
	function traduire()
	{
		JRequest::setVar( 'view', 'champs' );
		JRequest::setVar( 'layout', 'traduire'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	function traduire_delete()
	{
		$model = $this->getModel('champs');
		if(!$model->traduire_delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg, $type );
	}

	function traduire_save()
	{
		$model = $this->getModel('champs');
		if(!$model->traduire_save()) {
			$msg = JText::_( 'GMAPFP_TRADUCITON_LANGUE_EXISTE' );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=view', $msg, $type );
	}

	function traduire_apply()
	{
		$data = JRequest::get( 'post' );
		$model = $this->getModel('champs');
		if(!$model->traduire_save()) {
			$msg = JText::Sprintf( 'GMAPFP_TRADUCITON_LANGUE_EXISTE', $data["langue"] );
			$type = 'error';
		} else {
			$msg = JText::_( 'GMAPFP_SAVED' );
			$type ='message';
		}

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=champs&task=traduire&id='.$data["typeid"].'&langue='.$data["langue"], $msg, $type );
	}
}
?>
