<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Août 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPControllerConfiguration extends GMapFPController
{
	function configuration() {
	
		$model 			= $this->getModel('configuration');
		$view  			= $this->getView ( 'configuration','html');
		
		$results = $model->getParams();

		$view->assignRef('params', $results);		
	
		$view->display();
	
	}
	
	function saveconfiguration()
	{	
		$this->save_closeconfiguration();

		$link = 'index.php?option=com_gmapfp&controller=configuration&task=configuration';
		$this->setRedirect($link, $msg);
	}

	function save_closeconfiguration()
	{
		// Check for request forgeries
		JRequest::checkToken() or die( 'Invalid Token' );
		$db				= JFactory::getDBO();

		$post = JRequest::get( 'post' );
		
		$params = array();
		foreach ( $post['params'] as $key => $value ) {
			$params[] .= '"'.$key.'":"'.str_replace('"', '\"', $value).'"';
		}
		$parametres = implode (',', $params);
		unset ($params);
		$parametres = '{'.$parametres.'}';
		
		// Save the rules.

		$option = 'com_gmapfp';
		$data	= JRequest::getVar('jform', array(), 'post', 'array');
		// Check if the user is authorized to do this.
		if (!JFactory::getUser()->authorise('core.admin', $option))
		{
			JFactory::getApplication()->redirect('index.php', JText::_('JERROR_ALERTNOAUTHOR'));
			return;
		}
		$return = array();
			//die(print_r($data['rules']));
		foreach ($data['rules'] as $rules => $values) {
			$temps = array();
			foreach ($values as $key => $value) {
				if ($value != '') $temps[$key] = $value;
			}
			$return[$rules] = $temps;
		}
		$data	= array(
					'rules'	=> $return,
					'option'	=> $option
					);
		unset ($return);
		unset ($option);

		if (isset($data['rules'])) {
			jimport('joomla.access.rules');
			$rules	= new JRules($data['rules']);
			$asset	= JTable::getInstance('asset');

			if (!$asset->loadByName($data['option'])) {
				$root	= JTable::getInstance('asset');
				$root->loadByName('root.1');
				$asset->name = $data['option'];
				$asset->title = $data['option'];
				$asset->setLocation($root->id,'last-child');
			}
			$asset->rules = (string) $rules;

			if (!$asset->check() || !$asset->store()) {
				$this->setError($asset->getError());
				return false;
			}
			// We don't need this anymore
			unset($data['rules']);
		}

		$query = 'UPDATE #__extensions'.
				' SET params = '. $db->Quote( $parametres ).
				' WHERE ' . $db->nameQuote( 'element' ) . '=' . $db->Quote( 'com_gmapfp' ) ;
		$db->setQuery( $query );
		$db->query();

		// sauvegarde des noms de la gestion des champs en table pour multilangue avec JoomFish
		$query = 'UPDATE #__gmapfp_params_custom_fields'.
				' SET nom = '.$db->Quote($post['params']['gmapfp_nom']).
				' WHERE id = 7';
		$db->setQuery( $query );
		$db->query();

		$query = 'UPDATE #__gmapfp_params_custom_fields'.
				' SET nom = '.$db->Quote($post['params']['gmapfp_message']).
				' WHERE id = 11';
		$db->setQuery( $query );
		$db->query();

		$query = 'UPDATE #__gmapfp_params_custom_fields'.
				' SET nom = '.$db->Quote($post['params']['gmapfp_horaires_prix']).
				' WHERE id = 12';
		$db->setQuery( $query );
		$db->query();

		$query = 'UPDATE #__gmapfp_params_custom_fields'.
				' SET nom = '.$db->Quote($post['params']['gmapfp_nom_categorie']).
				' WHERE id = 13';
		$db->setQuery( $query );
		$db->query();

	}

}
?>