<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.89pro
	* Creation date: Aout 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

	jimport('joomla.filesystem.file');
	jimport('joomla.error.log');
	jimport('joomla.client.helper');


class GMapFPControllerGMapFP extends GMapFPController
{
	function __construct()
	{
		parent::__construct();

		// Register Extra tasks
		$this->registerTask( 'add', 'edit' );
		$this->registerTask( 'unpublish', 	'publish');
	}

	function edit()
	{
		$model = $this->getModel();
		$cid = JRequest::getVar('cid', array(0));
		$recordId = $cid[0];
		//$context = "$this->option.edit.$this->context";

		// Access check.
		if (!JFactory::getUser()->authorise('core.edit', 'com_gmapfp'))
		{
			$this->setError(JText::_('JLIB_APPLICATION_ERROR_EDIT_NOT_PERMITTED'));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gmapfp&task=view', false));
			return false;
		}

		if (!$model->checkout($recordId))
		{
			// Check-out failed, display a notice but allow the user to see the record.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKOUT_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gmapfp&task=view', false));
			return false;
		}
		else
		{
			JRequest::setVar( 'view', 'gmapfp' );
			JRequest::setVar( 'layout', 'edit'  );
			JRequest::setVar('hidemainmenu', 1);
	
			parent::display();
		}
	}

	function view()
	{
		JRequest::setVar( 'view', 'gmapfps' );
		JRequest::setVar( 'layout', 'default'  );

		parent::display();
	}

	function galerie()
	{
		JRequest::setVar( 'view', 'gmapfp' );
		JRequest::setVar( 'layout', 'medialist'  );

		parent::display();
	}

	function infos()
	{
		JRequest::setVar( 'view', 'gmapfp' );
		JRequest::setVar( 'layout', 'infos_form'  );

		parent::display();
	}

	function save()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('gmapfp');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$this->checkin($returnid);
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=view';
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function apply()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('gmapfp');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=edit&cid[]='.(int)$returnid;
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function remove()
	{
		$model = $this->getModel('gmapfp');
		if(!$model->delete()) {
			$msg = JText::_( 'Error: One or more GMapFPs could not be Deleted' );
		} else {
			$msg = JText::_( 'GMapFP(s) Deleted' );
		}
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view', $msg );
	}

	function publish()
	{
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view' );

		// Initialize variables
		$db			= JFactory::getDBO();
		$user		= JFactory::getUser();
		$cid		= JRequest::getVar( 'cid', array(), 'post', 'array' );
		$task		= JRequest::getCmd( 'task' );
		$publish	= ($task == 'publish');
		$n			= count( $cid );

		if (empty( $cid )) {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}

		JArrayHelper::toInteger( $cid );
		$cids = implode( ',', $cid );

		$query = 'UPDATE #__gmapfp'
		. ' SET published = ' . (int) $publish
		. ' WHERE id IN ( '. $cids .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->stderr() );
		}
		$this->setMessage( JText::sprintf( $publish ? 'Items published' : 'Items unpublished', $n ) );

	}

	function _modif_access($access)
	{
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view' );

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db		= & JFactory::getDBO();

		$cid	= JRequest::getVar( 'cid', array(0), 'post', 'array' );
		$cid	= $cid[0];

		$query = 'UPDATE #__gmapfp'
		. ' SET access = ' . (int) $access
		. ' WHERE id IN ( '. $cid .' )'
		;
		$db->setQuery( $query );
		if (!$db->query()) {
			return JError::raiseWarning( 500, $db->stderr() );
		}
	}

	function accesspublic()
	{
		$this->_modif_access(0);
	}
	
	function accessregistered()
	{
		$this->_modif_access(1);
	}
	
	function accessspecial()
	{
		$this->_modif_access(2);
	}
	
	function copy()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view' );

		$cid	= JRequest::getVar( 'cid', null, 'post', 'array' );
		$db		= JFactory::getDBO();
		$model  = $this->getModel('gmapfp');
		$table	= $model->getTable('GMapFP', 'GMapFPTable');
		$user	= JFactory::getUser();
		$n		= count( $cid );

		if ($n > 0)
		{
			foreach ($cid as $id)
			{
				if ($table->load( (int)$id ))
				{
					$table->id			= 0;
					$table->nom			= '('.JText::_( 'GMAPFP_COPIE_DE').') ' . $table->nom;
					$table->alias		= '';
					$table->published	= 0;
					$table->created_by	= $user->get('id');
			
					if (!$table->store()) {
						return JError::raiseWarning( $table->getError() );
					}
				}
				else {
					return JError::raiseWarning( 500, $table->getError() );
				}
				
				$query = 'SELECT * '.
					'FROM `#__gmapfp_extension_value` '.
					'WHERE id_gmapfp = '.(int)$id;
				$db->setQuery( $query );
				$valeurs = $db->LoadObjectList();
				
				foreach ($valeurs as $valeur) {
					$query = 'INSERT INTO `#__gmapfp_extension_value` (id_gmapfp, id_type, valeur) '.
						'VALUES ("'.$table->id.'", "'.$valeur->id_type.'", "'.$db->quote($valeur->valeur).'")';
					$db->setQuery( $query );
					if (!$db->query())
					{
						return JError::raiseWarning( $db->getErrorMsg() );
					}
				}
			}
		}
		else {
			return JError::raiseWarning( 500, JText::_( 'No items selected' ) );
		}
		$table->reorder();
		$this->setMessage( JText::sprintf( 'Items copied', $n ) );
	}
	
	function user()
	{
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		JRequest::setVar( 'view', 'auteur' );
		JRequest::setVar( 'layout', 'default'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}
	
	function checkin($recordId = ''){

		$model = $this->getModel();
		$return = true;
		
		if (!$recordId) {
				$recordId = JRequest::getVar( 'cid', null, 'post', 'array' );
				$recordId = $recordId[0];
			} else $return = false;

		if ($model->checkin($recordId) === false)
		{
			// Check-in failed, go back to the record and display a notice.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKIN_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gmapfp&task=view', false));

			return false;
		}
		if ($return) $this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view' );
			else return;
	}

	function cancel()
	{
		$model = $this->getModel();
		$recordId = JRequest::getInt('id');

		if ($model->checkin($recordId) === false)
		{
			// Check-in failed, go back to the record and display a notice.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKIN_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gmapfp&task=view', false));

			return false;
		}
		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( 'index.php?option=com_gmapfp&controller=gmapfp&task=view', $msg );
	}

	function resethits()
	{
		$post	= JRequest::get('post');
		$post['hits'] = 0;
		$model = $this->getModel('gmapfp');
		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'Successfully Reset Hit count' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=edit&cid[]='.(int)$returnid;
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function edit_upload()
	{
		JRequest::setVar( 'view', 'gmapfp' );
		JRequest::setVar( 'layout', 'upload_form'  );
		JRequest::setVar('hidemainmenu', 1);

		parent::display();
	}

	function upload_image() {
		$mainframe 	= &JFactory::getApplication(); 
		$config 	= &JComponentHelper::getParams('com_gmapfp');
		$log		= JLog::getInstance('upload.error.php');
		$user		= &JFactory::getUser();
		$userid		= $user->get('id');
		
		// Set FTP credentials, if given
		JClientHelper::setCredentialsFromRequest('ftp');

		$data = JRequest::get( 'post' );
        $type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
		$loaderror = false;
        $file = $_FILES['image1'];
        $file_name = $_FILES['image1']['name'];
		// Make the filename safe
		$file['name']	= JFile::makeSafe($file_name);

        $ext = strrchr($file_name,'.');
        $ext = strtolower($ext);
        if (!in_array( $ext, $type_image )) 
        {
            echo "<script> alert('".JText::_( 'GMAPFP_BAD_EXT')."'); window.history.go(-1); </script>";
            exit();
        }

		$folder = JPATH_ROOT.'/images/gmapfp/';
		$folder = JPath::clean($folder);
		
		if (strlen($_FILES['image1']['tmp_name']) > 0 and $_FILES['image1']['name'] != "none"){	
			//si je n'ai pas dj ce fichier, je le copie		
            if(!is_file($folder.strtolower($userid.'__'.$file['name'])))
				if (!$config->get('gmapfp_ajust_main', 0)) {
					if (!JFile::upload($_FILES['image1']['tmp_name'], $folder.strtolower($userid.'__'.$file['name'])))
					{
						// Error in upload
						$log->addEntry(array('comment' => 'Error on upload: '.$folder.strtolower($userid.'__'.$file['name'])));
						$response = array(
							'status' => '0',
							'error' => JText::_('GMAPFP_UPLOAD_NOK').'1'
						);
						$errorMsg = json_encode($response);
						return;
					}
				} else {
					require_once( JPATH_COMPONENT.'/libraries/imagemagic.php' );
					$miniature_ok = GMapFPImageMagic::imageMagic($file['tmp_name'], $folder.strtolower($userid.'__'.$file['name']), $config->get('gmapfp_largeur_img_main', 800), $config->get('gmapfp_hauteur_img_main', 600), 0, null, $errorMsg);
				}
			else $loaderror=true;				
			if($loaderror) {?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_NOK').' => '.strtolower($file['name']).JText::_( 'GMAPFP_EXIST');?>');
                        window.history.go(-1);
                    </script> <?php
			} else { 
				//creation des miniatures
				require_once( JPATH_COMPONENT.'/libraries/imagemagic.php' );
				$filein = $folder.strtolower($userid.'__'.$file['name']);
				$errorMsg = 'controller imageMagic not error line 320 !';

				//cre la miniature pour la carte
				if (!is_dir($folder.'thumbsGMap')){
					JFolder::create($folder.'thumbsGMap');
					@JFile::write($folder.'thumbsGMap/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsGMap/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img', 100), $config->get('gmapfp_hauteur_img', 100), $config->get('gmapfp_crop', 1), null, $errorMsg);
				
				//cre la miniature pour l'article
				if (!is_dir($folder.'thumbsArt')){
					JFolder::create($folder.'thumbsArt');
					@JFile::write($folder.'thumbsArt/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsArt/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_art', 250), $config->get('gmapfp_hauteur_img_art', 250), $config->get('gmapfp_crop', 1), null, $errorMsg);
				
				if ($miniature_ok) {
				?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_OK');?>');
                        window.opener.addphoto("<?php echo strtolower($userid.'__'.$file['name']);?>", "<?php echo strtolower($file['name']);?>");
						window.opener.changeDisplayImage("<?php echo JURI::base(true).'/../images/gmapfp/thumbsArt/';?>");
                        window.close();
                    </script> <?php
				}else{?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_NOK').' => '.strtolower($userid.'__'.$file['name']).', thumb error : '.$errorMsg;?>');
                        window.history.go(-1);
                    </script> <?php
				}
			}
		}
    }
	
	function file_upload_galerie() {
		$config 		=& JComponentHelper::getParams('com_gmapfp');
		$config_media 	=& JComponentHelper::getParams('com_media');

		// Check for request forgeries
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Set FTP credentials, if given
		JClientHelper::setCredentialsFromRequest('ftp');

		$file 		= JRequest::getVar( 'Filedata', '', 'files', 'array' );
		$id 		= (int)JRequest::getVar( 'cid');
		$path = COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/';
		$link = 'index.php?option=com_gmapfp&controller=gmapfp&task=galerie&tmpl=component&cid='.$id;

		$type_image = $config_media->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;
		
		if (empty($file)){
			$msg = '<p>'.JText::_('GMAPFP_SELECT_PICTURE').'</p>&nbsp;';
			$this->setRedirect($link, $msg, 'error');
			return;
		}
		
		// Vrifies si image
        $ext = strrchr($file['name'],'.');
        $ext = strtolower($ext);
        $ext = substr($ext, 1);
        if (!in_array( $ext, $type_image )) 
        {
			$msg = '<p>'.JText::_('GMAPFP_NOT_PICTURE').'</p>&nbsp;';
			$this->setRedirect($link, $msg, 'notice');
			return;
        }

		// Max size of image
		$maxSize = $config_media->get( 'upload_maxsize', 10 );
		if ((int)$maxSize > 0 && (int)$file['size'] > ((int)$maxSize)*1024*1024) {
			$msg = '<p>'.JText::_('GMAPFP_BAD_SIZE_PICTURE').'</p>&nbsp;';
			$this->setRedirect($link, $msg, 'notice');
			return;
		}

		// Make the filename safe
		$file['name']	= JFile::makeSafe($file['name']);

		if (isset($file['name'])) {
			$filepath = JPath::clean($path.strtolower($file['name']));

			if (JFile::exists($filepath)) {
				// REDIRECT
				$msg = '<p>'.JText::_('GMAPFP_FILE_EXIST').'</p>&nbsp;';
				$this->setRedirect($link, $msg, 'notice');
				return;
			}


			if ($config->get('gmapfp_ajust_main_gal', 0)) {
					require_once( JPATH_COMPONENT.'/libraries/imagemagic.php' );
					$miniature_ok = GMapFPImageMagic::imageMagic($file['tmp_name'], $filepath, $config->get('gmapfp_largeur_main_gal', 800), $config->get('gmapfp_hauteur_main_gal', 600), 0, null, $errorMsg);
			} else {
				if (!JFile::upload($file['tmp_name'], $filepath))
				{
					// Error in upload
					$log->addEntry(array('comment' => 'Error on upload: '.$folder.strtolower($userid.'__'.$file['name'])));
					$response = array(
						'status' => '0',
						'error' => JText::_('GMAPFP_UPLOAD_NOK').'1'
					);
					$errorMsg = json_encode($response);
					return;
				}
			}
				
			$msg = '<p>'.JText::_('GMAPFP_UPLOAD_OK').'</p>&nbsp;';
			//cre la miniature
			require_once( JPATH_COMPONENT.'/libraries/imagemagic.php' );
			$filein = $filepath;
			$fileout = $path.'thumbs/'.strtolower($file['name']);				
			$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_gal', 80), $config->get('gmapfp_hauteur_img_gal', 80), $config->get('gmapfp_crop', 1), null, $errorMsg);
			//**
			$msg = $msg.' thumbs: '.$errorMsg;
			$this->setRedirect($link, $msg, 'message');
			return;
		} else {
			$this->setRedirect($link, 'Invalid Request', 'error');
		}
    }

	function file_delete()
	{
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Get some data from the request
		$id 	= (int)JRequest::getVar('cid');
		$files	= JRequest::getVar( 'rm', array(), '', 'array' );
		// Initialize variables
		$ret = 'succes';

		if (count($files)) {
			foreach ($files as $file)
			{
				//efface image
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
				//efface miniature
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/thumbs/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
			}
		}
		$link="index.php?option=com_gmapfp&controller=gmapfp&task=galerie&tmpl=component&cid=".$id;
		$this->setRedirect($link, $ret, 'message');
	}

	function file_add_infos()
	{
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );
		$config 		=& JComponentHelper::getParams('com_gmapfp');

		// Get some data from the request
 		$post	= JRequest::get('post');

		$ret = JText::_('GMAPFP_SAVED');

		if ($post['id'] and $post['file']) {
			jimport( 'joomla.filesystem.file' );
			
			$folder = JPATH_ROOT.'/images/gmapfp/GA'.$post['id'].'/infos';

			if (!is_dir($folder)){
				JFolder::create($folder);
				$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
				@JFile::write($folder.'/index.html', $buffer);
			}

			$xml_file = substr($post['file'], 0, -(strlen(JFile::getExt($post['file']))+1));
			$xml_file .= '.xml';
			$buffer = "<infos>\n<titre>".htmlspecialchars($post['titre'])."</titre>\n<description>".htmlspecialchars($post['description'])."</description>\n</infos>";
			@JFile::write($folder.'/'.$xml_file, $buffer);
		} else {
			$ret ='def file_add_infos';
		}
		$link="index.php?option=com_gmapfp&controller=gmapfp&task=galerie&tmpl=component&cid=".$post['id'];
		$this->setRedirect($link, $ret, 'message');
	}

}
?>
