<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.109pro
	* Creation date: Mars 2014
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined( '_JEXEC' ) or die( 'Restricted access' );

jimport('joomla.application.component.model');

class GMapFPModelAccueil extends JModel
{

	function getPublishedTabs() {
	
		$config = JComponentHelper::getParams('com_gmapfp');

		$tabs = array();

		if ($config->get('gmapfp_news')) {
			$onglet = new stdClass();
			$onglet->title = 'News';
			$onglet->name = 'News';
			$onglet->alert = false;
			$tabs[] = $onglet;
		}

		if ($config->get('gmapfp_news')) {
			$onglet = new stdClass();
			$onglet->title = 'Bugs in progress';
			$onglet->name = 'Bugs_Progress';
			$onglet->alert = false;
			$tabs[] = $onglet;
		}

		if ($config->get('gmapfp_news')) {
			$onglet = new stdClass();
			$onglet->title = 'Bugs Solved';
			$onglet->name = 'Bugs_Solved';
			$onglet->alert = false;
			$tabs[] = $onglet;
		}

		return $tabs;
	}

	function getImages() {
		$query = 'SELECT DISTINCT img FROM #__gmapfp';		
		$this->_db->setQuery( $query );
		$result = $this->_db->loadResultArray();
		return $result;
	}
	
	function miniatures_create_gallerie()
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file' );

		$courent_folder = JRequest::getVar('courent_folder', 0, '', 'INT');
		$courent_file   = JRequest::getVar('courent_file', 0, '', 'INT');

		//rcupre les extentions images
		$config_media 	= JComponentHelper::getParams('com_media');
		$type_image = $config_media->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=miniatures_create_gallerie';

		//reconstruction des miniatures des galleries photos
		$folders = JFolder::listFolderTree(COM_GMAPFP_IMAGES_FOLDER, 'GA');
		//commence  analyser les rpertoires
		if (count($folders)){
			while ($courent_folder < count($folders)) {
				$files = JFolder::files($folders[$courent_folder]['fullname']);
				if (count($files)){
					while ($courent_file < count($files)) {
						$ext = strrchr($files[$courent_file],'.');
						$ext = strtolower($ext);
						$ext = substr($ext, 1);
						//test si fichier image
						if (in_array( $ext, $type_image )) {
							$erreur = $this->reconstruit_miniature($folders[$courent_folder]['fullname'], $files[$courent_file]);
							$courent_file ++;
							GMapFPRenderProcess::getProcessPage( $folders[$courent_folder]['relname'].DS.$files[$courent_file-1], $courent_folder, $courent_file, $link, count($folders), count($files), JText::_( 'GMAPFP_CREAT_THUMBS_GALLERIE' ), $erreur);exit;
						}else{
							$courent_file ++;
						}
					}
				}
				$courent_file = 0;
				$courent_folder ++;
			}
			$courent_file = 0;
			$courent_folder = 0;
		}
		return;
	}
	
	function miniatures_create_main()
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file' );

		$courent_file   = JRequest::getVar('courent_file', 0, '', 'INT');
		$courent_folder = 0;

		//rcupre les extentions images
		$config_media 	= JComponentHelper::getParams('com_media');
		$type_image = $config_media->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=miniatures_create_main';

		//reconstruction des miniatures principales
		$files = JFolder::files(COM_GMAPFP_IMAGES_FOLDER);
		if (count($files)){
			while ($courent_file < count($files)) {
				$ext = strrchr($files[$courent_file],'.');
				$ext = strtolower($ext);
				$ext = substr($ext, 1);
				//test si fichier image
				if (in_array( $ext, $type_image )) {
					$erreur = $this->reconstruit_main_miniature(COM_GMAPFP_IMAGES_FOLDER, $files[$courent_file]);
					$courent_file ++;
					GMapFPRenderProcess::getProcessPage( COM_GMAPFP_IMAGES_FOLDER.DS.$files[$courent_file-1], 0, $courent_file, $link, 1, count($files), JText::_( 'GMAPFP_CREAT_MAIN_THUMBS' ), $erreur);exit;
				}else{
					$courent_file ++;
				}
			}
			$courent_file = 0;
		}
		return;
	}
	
	function miniatures_del()
	{
		jimport( 'joomla.filesystem.folder' );
		jimport( 'joomla.filesystem.file' );

		//rcupre les extentions images
		$config_media 	= JComponentHelper::getParams('com_media');
		$type_image = $config_media->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=view';
		$html_content = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";

		//efface les miniatures des galleries photos : rpertoire GA
		$folders = JFolder::listFolderTree(COM_GMAPFP_IMAGES_FOLDER, 'GA');
		if (count($folders)){
			foreach ($folders as $folder) {
				$files = JFolder::files($folder['fullname']);
				if (count($files)){
					//efface les miniatures
					if (file_exists($folder['fullname'].DS.'thumbs')) {
						JFolder::delete($folder['fullname'].DS.'thumbs');
					}
					JFolder::create($folder['fullname'].DS.'thumbs');
					//reconstruit le fichier index.html
					JFile::write( $folder['fullname'].DS.'thumbs'.DS.'index.html', $html_content);
				}
			}
		}
		//efface les miniatures des images principales
		$files = JFolder::files(COM_GMAPFP_IMAGES_FOLDER);
		if (count($files)){
			//efface les miniatures
			if (file_exists(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsArt')) {
				JFolder::delete(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsArt');
			}
			if (file_exists(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsGMap')) {
				JFolder::delete(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsGMap');
			}
			//die(print_r('test model del miniatures'));
			JFolder::create(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsArt');
			JFolder::create(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsGMap');
			//reconstruit le fichier index.html
			JFile::write(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsArt'.DS."index.html", $html_content);
			JFile::write(COM_GMAPFP_IMAGES_FOLDER.DS.'thumbsGMap'.DS."index.html", $html_content);
		}
		return true;
	}
	
	function reconstruit_main_miniature($path, $file) {
		$config 		= JComponentHelper::getParams('com_gmapfp');
		$errorMsg = "";

		//cre la miniature
		require_once( JPATH_COMPONENT.DS.'libraries'.DS.'imagemagic.php' );
		$filein = $path.DS.$file;
		$fileout = $path.DS.'thumbsArt'.DS.$file;				
		GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_art', 250), $config->get('gmapfp_hauteur_img_art', 250), $config->get('gmapfp_crop', 1), null, $errorMsg);
		$fileout = $path.DS.'thumbsGMap'.DS.$file;				
		GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img', 100), $config->get('gmapfp_hauteur_img', 100), $config->get('gmapfp_crop', 1), null, $errorMsg);
		//**
		return $errorMsg;
    }

	function reconstruit_miniature($path, $file) {
		$config 		= JComponentHelper::getParams('com_gmapfp');
		$errorMsg = "";

		//cre la miniature
		require_once( JPATH_COMPONENT.DS.'libraries'.DS.'imagemagic.php' );
		$filein = $path.DS.$file;
		$fileout = $path.DS.'thumbs'.DS.$file;				
		GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_gal', 80), $config->get('gmapfp_hauteur_img_gal', 80), $config->get('gmapfp_crop', 1), null, $errorMsg);
		//**
		return $errorMsg;
    }

	function getDataChamp() {
		$db =  JFactory::getDBO();
		
		$query = 'SHOW COLUMNS FROM #__gmapfp';
		$db->setQuery( $query );
		$list['champs'] = $db->loadObjectList();
		
		$query = 'SELECT * FROM #__gmapfp_extension_type';
		$db->setQuery( $query );
		$list['customs'] = $db->loadObjectList('id');
		
		return $list;
	}

	function getCustoms_name()
	{
		$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
		$datacustom = $this->_getList( $query );

		return $datacustom;
	}

	public function getNonLatLng() {
		$db = JFactory::getDBO();
		
		$query = 'SELECT count(id) as count FROM #__gmapfp WHERE glat ="" OR glng ="" OR glat IS NULL OR glng IS NULL';
		$db->setQuery( $query );
		return $db->loadObject();
	}

	public function getCoordonner() {
		$db = JFactory::getDBO();
		$courent_id = JRequest::getVar('courent_id', 0, '', 'INT');
		$courent_count = JRequest::getVar('courent_count', 0, '', 'INT');
		$total_id = JRequest::getVar('total_id', 0, '', 'INT');
		$lat = JRequest::getVar('lat', 0, '', 'REAL');
		$lng = JRequest::getVar('lng', 0, '', 'REAL');
		$link = 'index.php?option=com_gmapfp&controller=accueil&task=getCoordonner';

		if ($courent_id and $lat and $lng) {
			$query = 'UPDATE #__gmapfp SET glat="'.(real)$lat.'", glng="'.(real)$lng.'" WHERE id ='.(int)$courent_id;
			$db->setQuery( $query );
			$db->query();
		}
		
		$query = 'SELECT id, nom, adresse, adresse2, ville, departement, codepostal, pay FROM #__gmapfp WHERE glat ="" OR glng ="" OR glat IS NULL OR glng IS NULL ORDER BY id';
		$db->setQuery( $query );
		$results = $db->loadObjectList();
		
		if (!$total_id) $total_id = count($results);

		foreach ($results as $result) {
			if ($courent_id < $result->id) {
				$courent_id = $result->id;
				$adresse = "";
				if (trim($result->adresse)) $adresse .= trim($result->adresse);
				if (trim($result->adresse2)) $adresse .= ' '.trim($result->adresse2);
				if (trim($result->codepostal)) $adresse .= ', '.trim($result->codepostal);
				if (trim($result->ville)) $adresse .= ' '.trim($result->ville);
				if (trim($result->pay)) $adresse .= ', '.trim($result->pay);

				$courent_count++;
				
				GMapFPRenderProcess::getProcessLatLng( $courent_id, $total_id, $courent_count, $link, $result->nom.'(id='.$result->id.')', $adresse, '');
				exit;
			}
		}

		return $courent_count;
	}
	
	private function CalculateCoordonner($adresse, $lieu, $id) {
		//2,500 requests per 24 hour period
		// initialisation
		$retour['latitude'] = "";
		$retour['longitude'] = "";
		$retour['erreur'] = "";

		$base_url = "http://maps.googleapis.com/maps/api/geocode/json";
		$request_url = $base_url . "?address=" . str_replace(' ', '+', $adresse) . "&sensor=false";

		$curl = curl_init();
        
        curl_setopt($curl, CURLOPT_URL, $request_url);
        curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
        curl_setopt($curl, CURLOPT_HEADER, false);
        curl_setopt($curl, CURLOPT_FOLLOWLOCATION, true);
       
        $output = curl_exec($curl);
        
        if($output === false) {
            $retour['erreur'] = 'Erreur cURL : '.curl_error($curl);
        } else {
			$data = json_decode($output);
			$status = $data->status;
			if($status == "OK") {
 				// Successful geocode
				$retour['latitude'] = (real)$data->results[0]->geometry->location->lat;
				$retour['longitude'] = (real)$data->results[0]->geometry->location->lng;
			} else {
				// failure to geocode
				$retour['erreur'] = JText::sprintf('GMAPFP_'.$status, $lieu.' => '.$adresse);
			}
		}
		curl_close($curl);
      
		return $retour;
	}

}
?>