<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Aot 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.modeladmin' );


class GMapFPModelChamps extends JModel
{
    var $_data;
    var $_list;
    var $_total;
    
    function __construct()
    {
        parent::__construct();

		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
        $controller = JRequest::getWord('controller');

        $array = JRequest::getVar('cid',  0, '', 'array');
        $this->setId((int)$array[0]);
            
        $limit      = $mainframe->getUserStateFromRequest( $option.$controller.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
        $limitstart = $mainframe->getUserStateFromRequest( $option.$controller.'limitstart', 'limitstart', 0, 'int' );

        // In case limit has been changed, adjust limitstart accordingly
        $limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

    
        $this->setState('limit', $limit);
        $this->setState('limitstart', $limitstart);
    }

    function _buildQuery()
    {
        $query = ' SELECT * '
            . ' FROM #__gmapfp_extension_type '
			. $this->_QueryOrder()
        ;

        return $query;
    }

    function setId($id)
    {
        $this->_id      = $id;
        $this->_data    = null;
    }

    function getList()
    {
        if (empty( $this->_list ))
        {
            $query = $this->_buildQuery();
            $results = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }
		foreach ($results as $result) {
			$query = ' SELECT langue '
				. ' FROM #__gmapfp_extension_lang '
				. 'WHERE typeid = '.$result->id;
            $this->_db->setQuery( $query );
			$lien = '';
            $langues = $this->_db->loadObjectList();
			//if ($langues) die(print_r($langues));
			if ($langues)
			foreach ($langues as $langue) {
				$lien .= '<a href="index.php?option=com_gmapfp&controller=champs&task=traduire&id='.$result->id.'&langue='.$langue->langue.'">'.$langue->langue.'</a> ; ';
			}
			$result->langue = $lien;
		}
		
		$this->_list = $results;
        return $results;
    }
    
    function getData()
    {
        if (empty( $this->_data )) {
            $query = ' SELECT * FROM #__gmapfp_extension_type '.
                    '  WHERE id = '.$this->_id;
            $this->_db->setQuery( $query );
            $this->_data = $this->_db->loadObject();
        }
        if (!$this->_data) {
            $this->_data = new stdClass();
            $this->_data->id = 0;
            $this->_data->nom = null;
            $this->_data->alias = null;
            $this->_data->description = null;
            $this->_data->filtrer = 0;
            $this->_data->filtre_label = null;
            $this->_data->rechercher = 0;
            $this->_data->type = null;
            $this->_data->parametres = null;
            $this->_data->position = null;
            $this->_data->for_cat = 0;
            $this->_data->catid = null;
            $this->_data->form_separator = null;
            $this->_data->view_separator = null;
            $this->_data->published = null;
            $this->_data->access = null;
            $this->_data->ordering = null;
        }

        return $this->_data;
    }
    
    function _QueryOrder() {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
        $controller = JRequest::getWord('controller');
        
        $filter_order       = $mainframe->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'string' );
        $filter_order_Dir   = $mainframe->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word' );
        
        if ( $filter_order == 'ordering') $filter_order = 'position , ordering';
		$order = 'ORDER BY '.$filter_order.' '.$filter_order_Dir;
		
        return $order;
    }

    function limitArray($array,$start,$limit) {
        $return = Array();
        for ($i=0;$i<count($array);$i++) {
            if ($i >= $start && $i < ($start+$limit)) {
                $return[] = $array[$i];
            }
        }
        return $return;
        }

    function getPagination()
    {
        if (empty($this->_pagination))
        {
            jimport('joomla.html.pagination');
            $this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
        }

        return $this->_pagination;
    }       
    
    function getTotal()
    {
        if (empty($this->_total))
        {
            $query = $this->_buildQuery();
            $this->_total = $this->_getListCount($query);
        }

        return $this->_total;
    }

    function getListChamps($selected = 0)
    {
		$nbre_type_champ = 8; // si ajout, ne pas oublier de voir fct "store"
		$items = array();
		
		for($i = 0; $i <= $nbre_type_champ; $i++) {
			$items[] = JHTML::_('select.option', $i, JText::_( 'GMAPFP_CHAMP_TYPE'.$i ) );
		}
		$list = JHTML::_('select.genericlist', $items, 'type', 'size="5" class="inputbox" onchange="ActualiseParametres();"', 'value', 'text', $selected);
        return $list;
    }

    function getPositionChamps($selected = 0)
    {
		$nbre_type_champ = 7;
		$items = array();
		
		for($i = 0; $i < $nbre_type_champ; $i++) {
			$items[] = JHTML::_('select.option', $i, JText::_( 'GMAPFP_CHAMP_POSITION'.$i ) );
		}
		$list = JHTML::_('select.genericlist', $items, 'position', 'size="1" class="inputbox"', 'value', 'text', $selected);
        return $list;
    }

    function store()
    {
        $row = $this->getTable('Champs', 'GMapFPTable');
        $data = JRequest::get( 'post' );
		$data['parametres'] = JRequest::getVar( 'parametres', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['form_separator'] = JRequest::getVar( 'form_separator', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['view_separator'] = JRequest::getVar( 'view_separator', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$data['catid'] = JRequest::getVar( 'catid', array(), 'post', 'array' );
		$data['catid'] = implode(',', $data['catid']);
		$data['error'] = '';

		if ($data['id']) {
			$query = ' SELECT * FROM #__gmapfp_extension_type '.
                    '  WHERE id = '.$data['id'];
            $this->_db->setQuery( $query );
            $old_value = $this->_db->loadObject();
		}

        if (!$row->bind($data)) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }

        if (!$row->check()) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }

        if (!$row->store()) {
			$data['error'] = $this->setError($this->_db->getErrorMsg());
			return $data;
        }
		
		//Insertion du champ dans la table gmapfp ou met  jour le type
		if (!$data['id']) {
			switch ($row->type) {
				case 0 :
				case 1 :
				case 2 :
				case 3 :
				case 6 :
				case 7 :
				case 8 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'TEXT NOT NULL';
					break;
				case 4 :
				case 5 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'VARCHAR( 250 ) NOT NULL';
					break;
				case 9 :
					$query = ' ALTER TABLE  `#__gmapfp` '.
							'ADD  `field_'.$row->id.'` '.
							'DATETIME NOT NULL';
					break;
			}
			$this->_db->setQuery( $query );
			$this->_db->query();
		} else {
			if ($old_value->type != $row->type) {
				if ($row->type == 9) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'DATETIME NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				if (($row->type == 4 or $row->type == 5) and ($old_value->type != 4 and $old_value->type != 5)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'VARCHAR( 250 ) NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				if (($row->type == 0 or $row->type == 1 or $row->type == 2 or $row->type == 3 or $row->type == 6 or $row->type == 7 or $row->type == 8) and ($old_value->type != 0 and $old_value->type != 1 and $old_value->type != 2 and $old_value->type != 3 and $old_value->type != 6 and $old_value->type != 7 and $old_value->type != 8)) {
					$query = ' ALTER TABLE `#__gmapfp` '.
							'CHANGE `field_'.$old_value->id.'` `field_'.$row->id.'` '.
							'TEXT NOT NULL';
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
				
			} 
		}
		$data['id'] = $row->id;

        return $data;
    }

    function delete()
    {
        $cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

        $row = $this->getTable('Champs', 'GMapFPTable');

        if (count( $cids ))
        {
            foreach($cids as $cid) {
                if (!$row->delete( $cid )) {
                    $this->setError( $row->getErrorMsg() );
                    return false;
                }
				$query = ' ALTER TABLE `#__gmapfp` '.
						'  DROP `field_'.$cid.'`';
				$this->_db->setQuery( $query );
				$this->_db->query();
            }                       
        }
        return true;
    }
            
	function move($direction)
	{
		$row = $this->getTable('Champs', 'GMapFPTable');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		if (!$row->move( $direction, ' position = '.(int) $row->position.' AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{

		JRequest::checkToken() or jexit( 'Invalid Token' );

		// Initialize variables
		$db			=  JFactory::getDBO();

		$total		= count($cid);
		$conditions	= array ();

		JArrayHelper::toInteger($cid, array(0));
		JArrayHelper::toInteger($order, array(0));

		// Instantiate an article table object
		$row = $this->getTable('Champs', 'GMapFPTable');

		// Update the ordering for items in the cid array
		for ($i = 0; $i < $total; $i ++)
		{
			$row->load( (int) $cid[$i] );
			if ($row->ordering != $i + 1) {
				$row->ordering = $i + 1;
				if (!$row->store()) {
					JError::raiseError( 500, $db->getErrorMsg() );
					return false;
				}
			}
		}

		return true;
	}
	
    function getTraductionChamp($id = '', $langue = '')
    {
		$query = ' SELECT * FROM #__gmapfp_extension_lang '.
				'  WHERE typeid = '.$id.
				" AND langue = '".$langue."'";
		$this->_db->setQuery( $query );
		$result = $this->_db->loadObject();

		if (!$result) {
            $result = new stdClass();
            $result->id = 0;
            $result->nom = null;
            $result->langue = $langue;
            $result->parametres = null;
			$result->filtre_label = null;
		}
			
		return $result;
	}
	
    function getDataChamp()
    {
		if (!$this->_id) $this->_id = JRequest::getInt('id');
		$query = ' SELECT nom, parametres, filtre_label, id FROM #__gmapfp_extension_type '.
				'  WHERE id = '.$this->_id;
		$this->_db->setQuery( $query );
		$result = $this->_db->loadObject();

		return $result;
	}

    function traduire_delete()
    {
		$data = JRequest::get( 'post' );

		$query = ' DELETE FROM #__gmapfp_extension_lang '.
				'  WHERE id = '.$data['id'];
		$this->_db->setQuery( $query );
		$this->_db->query();

        return true;
    }

    function traduire_save()
    {
		$data = JRequest::get( 'post' );
		
		$isNew = !$data['id'];
		
		if ($isNew) {
			$query = ' SELECT id FROM #__gmapfp_extension_lang '.
				' WHERE typeid = '.$data['typeid'].
				" AND langue = '".$data['langue']."'";
			$this->_db->setQuery( $query );
			$result = !$this->_db->loadObject();

			$query = ' INSERT INTO #__gmapfp_extension_lang (typeid, langue, nom, parametres, filtre_label)'.
					"  VALUES (".$data["typeid"].", '".$data["langue"]."', '".$data["nom"]."', '".$data["parametres"]."', '".$data["filtre_label"]."')";
		} else {
			$query = ' UPDATE #__gmapfp_extension_lang'.
					' SET typeid = '.$data["typeid"].", langue = '".$data["langue"]."', nom = '".$data["nom"]."', parametres = '".$data["parametres"]."', filtre_label = '".$data["filtre_label"]."'".
					' WHERE id = '.$data["id"];
			$result = true;
		}
		if ($result) {
			$this->_db->setQuery( $query );
			$this->_db->query();
		}

        return $result;
    }
}
