<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.106pro
	* Creation date: Fvrier 2014
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();
jimport('joomla.application.component.modeladmin');

class GMapFPModelGMapFP extends JModel
{
	var $_list;
	var $_label;
	var $_classement;
	var $_picto;
	
	var $_data;
	var $_id;
	var $_datacustom;
	
	function __construct()
	{
		parent::__construct();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
	}

	function _buildQuery()
	{
		$query = ' SELECT * '
			. ' FROM #__gmapfp_marqueurs where published = 1 '
		;

		return $query;
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
		$this->_datacustom = null;
	}

	function getChamps($id_lieu = '')
	{
		$champ = array ();
		$catid_field = array ();
		
		$query = ' SELECT * '.
				' FROM #__gmapfp_extension_type '.
				' WHERE published = 1'.
				' ORDER BY ordering';
		$this->_db->setQuery( $query );
		$fields = $this->_db->loadObjectList();
		
		if ($fields) {
			$query = ' SELECT * '.
					' FROM #__gmapfp '.
					' WHERE id = '.$id_lieu;
			$this->_db->setQuery( $query );
			$values = @$this->_db->loadAssoc();
			
			$editor = JFactory::getEditor();
			foreach ($fields as $field) {
				$hide = "";
				if ($field->for_cat) {
					$catids = explode(',', $field->catid);
					foreach ($catids as $catid)
						$catid_field['field_catid_'.$field->id][] = 'cat'.$catid;
					if (!in_array($values['catid'], $catids))
						$hide = 'style = "display: none;"';
				}
				
				switch ($field->type) {
					case 0 : // champ text
						$champ[$field->position][]='
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<input class="inputbox" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 1 : // champ textarea
						$champ[$field->position][]='
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<textarea rows="4" cols="32" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" >'.(@$values['field_'.$field->id]).'</textarea>
							</td>
						</tr>
						';
						break;
					case 2 : // champ editor
						$champ[$field->position][]='
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
							'.$editor->display('perso_field_'.$field->id, htmlspecialchars(@$values['field_'.$field->id], ENT_COMPAT, 'UTF-8'), '600', '300', '75', '20', false, 'perso_field_'.$field->id).'
							</td>
						</tr>
						';
						break;
					case 3 : // champ checkbox
						$temp = '
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'checked'; else $check = '';
							$temp .= '<input class="inputbox" style="float: none;" type="checkbox" name="perso_field_'.$field->id.'[]" id="perso_field_'.$field->id.'" value="'.strstr($parametre, '::', 1)."\n".'" '.$check.'>&nbsp;'.substr(strstr($parametre, '::', 0),2).$field->form_separator."\n";
						}
						$temp .= '
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 4 : // champ radiobuton
						$temp = '
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								';
						$parametres = explode("\n", $field->parametres);
						foreach($parametres as $parametre){
							if (strstr($parametre, '::', 1) == str_replace("\n", "", @$values['field_'.$field->id])) $check = 'checked'; else $check = '';
							$temp .= '<input class="inputbox" style="float: none;" type="radio" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" value="'.strstr($parametre, '::', 1).'" '.$check.'>&nbsp;'.substr(strstr($parametre, '::', 0),2).$field->form_separator."\n";
						}
						$temp .= '
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 5 : // champ list 1 choix
						$temp = '
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.' size="1">';
						$parametres = explode("\n", $field->parametres);
						foreach($parametres as $parametre){
							if (trim(strstr($parametre, '::', 1)) == str_replace("\n", "", @$values['field_'.$field->id])) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1).'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 6 : // champ list multi choix
						$temp = '
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'[]" id="perso_field_'.$field->id.'" multiple size="4">';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1)."\n".'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 7 : // champ text readonly
						$champ[$field->position][]='
						<tr class="disable" id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<input class="inputbox" readonly="readonly" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.$field->parametres.'" />
							</td>
						</tr>
						';
						break;
					case 8 : // champ text d'information
						$champ[$field->position][]='
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								'.$field->parametres.'
							</td>
						</tr>
						';
						break;
					case 9 : // champ date
						$champ[$field->position][]='
						<tr id="field_catid_'.$field->id.'" '.$hide.'>
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								'.JHtml::calendar( JHtml::date( @$values['field_'.$field->id], 'Y-m-d H:i:s'), 'perso_field_'.$field->id, 'perso_field_'.$field->id, '%Y-%m-%d %H:%M:%S', ' size="22"').'
							</td>
						</tr>
						';
						break;
				}
			}
		}
		$champ['json'] = json_encode($catid_field);
		return $champ;
	}
	
	function getData()
	{
		// Load the data
		if (empty( $this->_data )) {
			$query = ' SELECT c.*, v.name AS last_editor, w.name AS author_name, cat.params AS cat_params '.
					'  FROM #__gmapfp AS c '.
					'  LEFT JOIN #__users AS v ON v.id = c.modified_by' .
					'  LEFT JOIN #__users AS w ON w.id = c.created_by' .
					'  LEFT JOIN #__categories AS cat ON cat.id = c.catid' .
					'  WHERE c.id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$createdate = JFactory::getDate();
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->nom = null;
			$this->_data->alias = null;
			$this->_data->adresse = null;
			$this->_data->adresse2 = null;
			$this->_data->codepostal = null;
			$this->_data->ville = null;
			$this->_data->departement = null;
			$this->_data->pay = null;
			$this->_data->email = null;
			$this->_data->web = null;
			$this->_data->img = null;
			$this->_data->album = null;
			$this->_data->introtext = null;
			$this->_data->fulltext = null;
			$this->_data->horaires_prix = null;
			$this->_data->link = null;
			$this->_data->article_id = null;
			$this->_data->icon = null;
			$this->_data->icon_label = null;
			$this->_data->glat = null;
			$this->_data->glng = null;
			$this->_data->gzoom = null;
			$this->_data->catid = null;
			$this->_data->created_by = null;
			$this->_data->published = null;
			$this->_data->access = 0;
			$this->_data->checked_out = null;
			$this->_data->metadesc = null;
			$this->_data->metakey = null;
			$this->_data->metadata = null;
			$this->_data->hits = 0;
			$this->_data->version = 0;
			$this->_data->modified = null;
			$this->_data->modified_by = 0;
			$this->_data->created = null;
			$this->_data->publish_up = null;
			$this->_data->publish_down = null;
			$this->_data->ordering = 0;		
			$this->_data->attribs = null;	
			$this->_data->index_marqueur = 0;	
			$this->_data->language = null;
			$this->_data->classements = null;
			$this->_data->labels = null;
			$this->_data->pictos = null;
			$this->_data->cat_params = '{}';
		}
		
		if (JString::strlen($this->_data->fulltext) > 1) {
			$this->_data->text = $this->_data->introtext . "<hr id=\"system-readmore\" />" . $this->_data->fulltext;
		} else {
			$this->_data->text = $this->_data->introtext;
		}
		
		$metadatas = substr($this->_data->metadata, 2, -2);
		$metadatas = explode('","', $metadatas);
		foreach ( $metadatas as $metadata)
		{
			$metadata = explode('"="', $metadata);
			switch ($metadata[0])
			{
				case 'robots':
					$this->_data->robots = str_replace('\"', '"', $metadata[1]);
					break;
				case 'author':
					$this->_data->author = str_replace('\"', '"', $metadata[1]);
					break;
				case 'rights':
					$this->_data->rights = str_replace('\"', '"', $metadata[1]);
					break;
				case 'xreference':
					$this->_data->xreference = str_replace('\"', '"', $metadata[1]);
			}
		}
		
		return $this->_data;
	}

	function getCustom()
	{
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		return $this->_datacustom;
	}

	function getLabel()
	{
		if (empty( $this->_label )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 2) AND (published = 1) ORDER BY ordering ';
			$this->_label = $this->_getList( $query );
		}

		return $this->_label;
	}

	function getClassement()
	{
		if (empty( $this->_classement )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 1) AND (published = 1) ORDER BY ordering ';
			$this->_classement = $this->_getList( $query );
		}

		return $this->_classement;
	}

	function getPicto()
	{
		if (empty( $this->_picto )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 3) AND (published = 1) ORDER BY ordering ';
			$this->_picto = $this->_getList( $query );
		}

		return $this->_picto;
	}

	function getMarqueurs()
	{
		if (empty( $this->_list ))
		{
			$query = $this->_buildQuery();
			$this->_list = $this->_getList( $query );
		}

		return $this->_list;
	}

	function store($data)
	{
		$user		=  JFactory::getUser();
		$row 		=  $this->getTable('GMapFP', 'GMapFPTable');
		$nullDate	= $this->_db->getNullDate();

		$selections	= JRequest::getVar( 'classements', array(), 'post', 'array' );
		$classements = implode(',', $selections);
		$selections = JRequest::getVar( 'labels', array(), 'post', 'array' );
		$labels 	= implode(',', $selections);
		$selections = JRequest::getVar( 'pictos', array(), 'post', 'array' );
		$pictos 	= implode(',', $selections);

		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		$row->classements = $classements;
		$row->labels = $labels;
		$row->pictos = $pictos;

		// sanitise id field
		$row->id = (int) $row->id;

		// Get details variables from the request
		$details	= JRequest::getVar( 'details', array(), 'post', 'array');
		$row->bind($details);

		$isNew = true;
		// Are we saving from an item edit?
		if ($row->id) {
			$isNew = false;
			$datenow = JFactory::getDate();
			$row->modified 		= $datenow->toMySQL();
			$row->modified_by 	= $user->get('id');
		}

		if ($row->created && strlen(trim( $row->created )) <= 10) {
			$row->created 	.= ' 00:00:00';
		}

		$config = JFactory::getConfig();
		$tzoffset = $config->getValue('config.offset');
		$date = JFactory::getDate($row->created, $tzoffset);
		$row->created = $date->toMySQL();

		// Append time if not added to publish date
		if (strlen(trim($row->publish_up)) <= 10) {
			$row->publish_up .= ' 00:00:00';
		}

		$date = JFactory::getDate($row->publish_up, $tzoffset);
		$row->publish_up = $date->toMySQL();

		// Handle never unpublish date
		if (trim($row->publish_down) == JText::_('Never') || trim( $row->publish_down ) == '')
		{
			$row->publish_down = $nullDate;
		}
		else
		{
			if (strlen(trim( $row->publish_down )) <= 10) {
				$row->publish_down .= ' 00:00:00';
			}
			$date = JFactory::getDate($row->publish_down, $tzoffset);
			$row->publish_down = $date->toMySQL();
		}

		// Increment the content version number
		$row->version++;

		$metadata = $data['metadata'];
		if (is_array($metadata))
		{
			$txt = array();
			foreach ($metadata as $k => $v) {
				$v = str_replace('"', '\"', $v);
				$txt[] = "\"$k\"=\"$v\"";
			}
			$row->metadata = '{'.implode(",", $txt).'}';
		}

		// Prepare the content for saving to the database
		GMapFPsHelper::saveGMapfpPrep( $row );

		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}

		// attribut le n 1  ordering et dcale les autres n
		if (!$row->reorder()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		
		//traite les champs perso. Notament ceux qui accepte des balise html
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE type = 2 OR type = 1';
		$this->_db->setQuery( $query );
		$editeurs = $this->_db->loadColumn();

		$mes_valeurs = array();
		foreach ($data as $key => $value) {
			if (substr($key, 0, 11) == 'perso_field') {
				//si checkbox, ou list, ou radio buton, ou ...
				$search = array("\r", "\n", "\t", "\0", " ", "\x0B");
				if (is_array($value)) $value = implode("\r\n", str_replace($search, '', $value));
				//si editeur
				if (in_array(substr($key, 12), $editeurs)) {
					$value = JRequest::getVar( $key, '', 'post', 'string', JREQUEST_ALLOWRAW );
					$value = str_replace( '<br>', '<br />', $value );
				}
				$mes_valeurs[] = '`field_'.substr($key, 12).'` = '.$this->_db->quote($value);
			}
		}
		if ($mes_valeurs) {
			$query = 'UPDATE `#__gmapfp` '.
				' SET '.implode(',', $mes_valeurs).
				' WHERE id = '.$row->id;
			$this->_db->setQuery( $query );
			if (!$this->_db->query())
			{
				die(print_r($this->_db->getErrorMsg()));
			}
		}

		return $row->id;
	}

	function delete()
	{
		$config = JComponentHelper::getParams('com_gmapfp');
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row = $this->getTable('GMapFP', 'GMapFPTable');

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				// efface l'image principale lier au lieux
				if ($config->get('gmapfp_del_img')) {
					//rcupre et vrifi que l'image principale n'est pas utilise par un autre id
					$query = ' SELECT img FROM #__gmapfp '.
							'  WHERE id = '.$cid;
					$this->_db->setQuery( $query );
					$result = $this->_db->loadObject();
					
					$query = ' SELECT id FROM #__gmapfp '.
							'  WHERE img = \''.$result->img.'\'';
					$list = $this->_getList( $query );

					if ((count($list)==1) && ($result->img!='blank.png')) {
						unlink(COM_GMAPFP_IMAGES_FOLDER."/".$result->img);
						unlink(COM_GMAPFP_IMAGES_FOLDER."/thumbsArt/".$result->img);
						unlink(COM_GMAPFP_IMAGES_FOLDER."/thumbsGMap/".$result->img);
					}
				}
				//efface la gallerie d'image d'un lieu
				if ($config->get('gmapfp_del_galerie')) {
					$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.DS.'GA'.$cid.DS.'thumbs');
					$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$cid);
				}
				//efface l'enregistrement du lieux
				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				};
			}						
		}
		return true;
	}
	
	function rrmdir($dir) { 
		if (is_dir($dir)) { 
			$objects = scandir($dir); 
			foreach ($objects as $object) { 
				if ($object != "." && $object != "..") { 
					if (filetype($dir."/".$object) == "dir") rmdir($dir."/".$object); else unlink($dir."/".$object); 
				} 
			} 
			reset($objects); 
			rmdir($dir); 
		} 
	} 

	function move($direction)
	{
		$row = $this->getTable('GMapFP', 'GMapFPTable');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		//if (!$row->move( $direction, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
		if (!$row->move( $direction, ' true AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{
		$row = $this->getTable('GMapFP', 'GMapFPTable');

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}
		$row->reorder();

		return true;
	}

    function getImages()
    {
        jimport( 'joomla.filesystem.file' );
		$images     = array ();
		$id 		= JRequest::getVar('cid');
		if (is_array($id)) $id = (int)$id[0]; else $id = (int)$id;
		if ($id==0) return false;
		
		$basePath = COM_GMAPFP_IMAGES_FOLDER.DS.'GA'.$id;
		// Cre le rpertoire s'il n'exist pas
		$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
		if (!JFolder::exists($basePath)) {
			JFolder::create($basePath);
			JFile::write($basePath.DS."index.html", $buffer);
		}
		if (!JFolder::exists($basePath.DS.'thumbs')) {
			JFolder::create($basePath.DS.'thumbs');
			JFile::write($basePath.DS.'thumbs'.DS."index.html", $buffer);
		}
        // Get the list of files and folders from the given folder
        $fileList   = JFolder::files($basePath);

        // Iterate over the files if they exist
        if ($fileList !== false) {
            foreach ($fileList as $file)
            {
                if (is_file($basePath.'/'.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html') {
                    $tmp = new JObject();
                    $tmp->name = $file;
                    $tmp->path_relative = COM_GMAPFP_IMAGES_HTTP.'/GA'.$id;
                    $tmp->path = $basePath.'/'.$file;
                    $tmp->size = filesize($tmp->path);
                    $tmp->size = round($tmp->size/1024, 2);

                    $ext = strtolower(JFile::getExt($file));
                    switch ($ext)
                    {
                        // Image
                        case 'jpg':
                        case 'png':
                        case 'gif':
                        case 'xcf':
                        case 'odg':
                        case 'bmp':
                        case 'jpeg':
                            $info = @getimagesize($tmp->path);
                            $tmp->width     = @$info[0];
                            $tmp->height    = @$info[1];
                            $tmp->type      = @$info[2];
                            $tmp->mime      = @$info['mime'];

                            if (($info[0] > 60) || ($info[1] > 60)) {

								if ($tmp->width > $tmp->height) {
									$percentage = (60 / $tmp->width);
								} else {
									$percentage = (60 / $tmp->height);
								}
						
								//gets the new value and applies the percentage, then rounds the value
								$tmp->width = round($tmp->width * $percentage);
								$tmp->height = round($tmp->height * $percentage);
                            }
                 			//lecture des infos exif du fichier image
							$xml = substr($file, 0, -(strlen(JFile::getExt($file))+1));
							$xml .= '.xml';

							if (JFile::exists($basePath.'/infos/'.$xml)) {
								$xml_str = file_get_contents($basePath.'/infos/'.$xml);
								$xml_data = new SimpleXMLElement($xml_str);
									$tmp->titre = (string) $xml_data->titre;
									$tmp->description = (string) $xml_data->description;
							} else {
									$tmp->titre = '';
									$tmp->description = '';
							}
                 			$images[] = $tmp;
                            break;
                    }
                }
            }
        }
        return $images;
    }

	public function checkin($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();

			// Get an instance of the row to checkin.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user->get('id') && !$user->authorise('core.admin', 'com_checkin'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKIN_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row in.
			if (!$table->checkin($pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	public function checkout($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();

			// Get an instance of the row to checkout.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user->get('id'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKOUT_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row out.
			if (!$table->checkout($user->get('id'), $pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}
}
?>
