<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Août 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );


class GMapFPModelGMapFPs extends JModel
{
	var $_data = null;

	var $_total = null;

	var $_pagination = null;

		function __construct()
		{
			parent::__construct();
			
			$mainframe = JFactory::getApplication(); 
			$option    = JRequest::getCMD('option'); 
			
			$limit = $mainframe->getUserStateFromRequest( $option.'limit', 'limit', $mainframe->getCfg('list_limit'), 'int');
			$limitstart = $mainframe->getUserStateFromRequest( $option.'limitstart', 'limitstart', 0, 'int' );	

			// In case limit has been changed, adjust limitstart accordingly
			$limitstart = ($limit != 0 ? (floor($limitstart / $limit) * $limit) : 0);

			$this->setState('limit', $limit);
			$this->setState('limitstart', $limitstart);
			
		}
		
	function getCustom()
	{
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		return $this->_datacustom;
	}

	function getlistville()
	{
		$query = 'SELECT DISTINCT ville' .
				' FROM #__gmapfp' .
				' ORDER BY ville';
		return $this->_getList( $query );
	}
	
	function getlistdepartement()
	{
		$query = 'SELECT DISTINCT departement' .
				' FROM #__gmapfp' .
				' ORDER BY departement';
		return $this->_getList( $query );
	}
	
	function _buildQuery()
	{
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = ' SELECT a.*, b.title, c.name AS auteur, c.email AS auteur_mail, ag.title AS access_level, l.title AS language_title, e.name AS editor'.
			' FROM #__gmapfp a '.
			' LEFT JOIN #__categories b ON b.id = a.catid'.
			' LEFT JOIN #__users c ON c.id = a.created_by'.
			' LEFT JOIN #__users e ON e.id = a.checked_out'.
			' LEFT JOIN #__viewlevels AS ag ON ag.id = a.access'.
			' LEFT JOIN #__languages AS l ON l.lang_code = a.language'.
			$where.
			$orderby
		;

		//die(print_r($query));
		return $query;
	}

	function _buildContentWhere()
	{
		$mainframe 	= JFactory::getApplication(); 
		$option    	= JRequest::getCMD('option'); 
		$user		= JFactory::getUser();
		$db			= JFactory::getDBO();
		
        $filtreville 		= $mainframe->getUserStateFromRequest( $option.'filtreville', 		'filtreville', 			'- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' -', 		'string' );
        $filtredepartement 	= $mainframe->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', 	'- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' -', 	'string' );
        $filtrecategorie 	= $mainframe->getUserStateFromRequest( $option.'filtrecategorie', 	'filtrecategorie', 		0, 	'int' );
        $filtreauteur 		= $mainframe->getUserStateFromRequest( $option.'filtreauteur', 		'filtreauteur', 		0, 	'int' );
		$filtrelangue	 	= $mainframe->getUserStateFromRequest( $option.'filtrelangue', 		'filtrelangue', 		0, 	'string' );
		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		$groups		= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

		if ($search) {
			$where[] = 'LOWER(a.nom) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

        if ($filtreville<>'- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' -') {
            $where[] = 'ville = \''.addslashes($filtreville).'\'';
        }           

		if ($filtredepartement<>'- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' -') {
			$where[] = 'departement = \''.addslashes($filtredepartement).'\'';
		}

        if ($filtrecategorie<>0) {
            $where[] = 'a.catid = \''.addslashes($filtrecategorie).'\'';
        }

        if ($filtreauteur<>0) {
            $where[] = 'a.created_by = '.$filtreauteur;
        }

        if ($filtrelangue<>'0') {
            $where[] = 'a.language = "'.$filtrelangue.'"';
        }

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function _buildContentOrderBy()
	{
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY  a.ordering '.$filter_order_Dir;
		} else {
			if ($filter_order) {
				$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , a.catid, a.ordering ';
			}else{
				$orderby 	= ' ORDER BY a.catid, a.ordering ';
			};
		}

		return $orderby;
	}

	function getData()
	{
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }

        return $this->_data;
	}

	function getTotal()
	{
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

        return $this->_total;
	}

	function getPagination()
	{
		if (empty($this->_pagination))
		{
			jimport('joomla.html.pagination');
			$this->_pagination = new JPagination( $this->getTotal(), $this->getState('limitstart'), $this->getState('limit') );
		}

		return $this->_pagination;
	}		

	public function getAuthors() {
		// Create a new query object.
		$db = $this->getDbo();
		$query = $db->getQuery(true);

		// Construct the query
		$query->select('u.id AS value, u.name AS text');
		$query->from('#__users AS u');
		$query->join('INNER', '#__gmapfp AS c ON c.created_by = u.id');
		$query->group('u.id, u.name');
		$query->order('u.name');

		// Setup the query
		$db->setQuery($query->__toString());

		// Return the result
		return $db->loadObjectList();
	}

}
