<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Aot 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class GMapFPViewChamps extends JView
{
	function display($tpl = null)
	{
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		$controller = JRequest::getWord('controller');
		$this->state= $this->get('State');
		$params 	= JComponentHelper::getParams('com_gmapfp'); 

		switch (JRequest::getWord('layout')){
			case 'liste': 
				require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
				$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_MANAGER' ), 'champs' );
				if ($canDo->get('core.create')) {
					JToolBarHelper::addNewX();
				}
				if (($canDo->get('core.edit'))) {
					JToolBarHelper::editListX();
					if ($params->get('gmapfp_compa_trad_joom25', 0)) 
						JToolBarHelper::customX('traduire', 'copy', 'copy', JText::_( 'GMAPFP_TRADUIRE' ), true);
				}
				if ($canDo->get('core.edit.state')) {
					JToolBarHelper::divider();
					JToolBarHelper::publishList();
					JToolBarHelper::unpublishList();
				}
				if ( $canDo->get('core.delete')) {
					JToolBarHelper::divider();
					JToolBarHelper::deleteList();
				}
			
				// Get data from the model
				$champs		=  $this->get('List');
				break;
			case 'traduire' :
				// Get data from the model
				$champs		= $this->get('DataChamp');
				
				//cres la liste des types de champs
				$model = $this->getModel('champs');
				
				$champ_traduction=$model->getTraductionChamp($champs->id, JRequest::getString('langue', ''));
				$this->assignRef('champ_traduction', $champ_traduction);
	
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_TRADUIRE' ).': <small>[ ' . JText::_( 'GMAPFP_EDIT' ).' ]</small>', 'champs' );
				JToolBarHelper::apply('traduire_apply');
				JToolBarHelper::save('traduire_save');
				JToolBarHelper::customX('traduire_delete', 'delete', 'delete', JText::_( 'JTOOLBAR_DELETE' ), false);
				JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
				break;
			default :
				// Get data from the model
				$champs		= $this->get('Data');
				$isNew		= ($champs->id < 1);
				
				if ($isNew) {
					$champs->nom = '';//JRequest::getString('nom');
					$champs->description = JRequest::getString('description');
					$champs->filtrer = JRequest::getInt('filtrer');
					$champs->filtre_label = JRequest::getString('filtre_label');
					$champs->recherche = JRequest::getInt('recherche');
					$champs->type = JRequest::getInt('type');
					$champs->parametres = JRequest::getString('parametres');
					$champs->position = JRequest::getInt('position');
					$champs->for_cat = JRequest::getInt('for_cat');
					$champs->catid = JRequest::getInt('catid');
					$champs->form_separator = JRequest::getString('form_separator');
					$champs->view_separator = JRequest::getString('view_separator');
					$champs->published = JRequest::getInt('published');
					$champs->access = JRequest::getInt('access');
					$champs->ordering = JRequest::getInt('ordering');
				}
	
				//cres la liste des types de champs
				$model = $this->getModel('champs');
				
				$list_champs=$model->getListChamps($champs->type);
				$this->assignRef('list_champs', $list_champs);
				$position_champs=$model->getPositionChamps($champs->position);
				$this->assignRef('position_champs', $position_champs);

				$listcategories = JHtml::_('category.options', 'com_gmapfp');
				if (!empty($listcategories))
				{
					if (!is_array($champs->catid)) $champs->catid = explode(',', $champs->catid);
					$lists['catid']	= JHTML::_('select.genericlist',   $listcategories, 'catid[]', 'class="inputbox" size="5" multiple="multiple"', 'value', 'text', $champs->catid, '' );
				}
	
				$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
				JToolBarHelper::title(   JText::_( 'GMAPFP_CHAMPS_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'champs' );
				JToolBarHelper::apply();
				JToolBarHelper::save();
				JToolBarHelper::save2new();
				if ($isNew)  {
					JToolBarHelper::cancel();
				} else {
					// for existing items the button is renamed `close`
					JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
				}
		}
		JHTML::_('behavior.tooltip');

		$this->assignRef('champs', $champs);
		
		$pageNav =  $this->get( 'Pagination' );				
		$this->assignRef('pageNav', $pageNav);

		$filter_order 		= $mainframe->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd');
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word');
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;
		$this->assignRef('lists', $lists);

		parent::display($tpl);

	}
}
