<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Aot 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class GMapFPViewClassements extends JView
{
	function display($tpl = null)
	{
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		$controller = JRequest::getWord('controller');
		$this->state= $this->get('State');


		$list = array();

		if (JRequest::getWord('task')=='view') 
		{
			require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
			$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
			JToolBarHelper::title(   JText::_( 'GMAPFP_CLASSEMENTS_MANAGER' ), 'classement' );
			if ($canDo->get('core.create')) {
				JToolBarHelper::addNewX();
			}
			if (($canDo->get('core.edit'))) {
				JToolBarHelper::editListX();
			}
			if ($canDo->get('core.edit.state')) {
				JToolBarHelper::divider();
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
			}
			if ( $canDo->get('core.delete')) {
				JToolBarHelper::divider();
				JToolBarHelper::deleteList();
			}
		
			// Get data from the model
			$classements	=  $this->get('List');
			$pagination 		=  $this->get( 'Pagination' );

			$filter_order 		= $mainframe->getUserStateFromRequest( $option.$controller.'filter_order', 'filter_order', 'nom', 'cmd');
			$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.$controller.'filter_order_Dir', 'filter_order_Dir', '', 'word');
			$lists['order_Dir'] = $filter_order_Dir;
			$lists['order'] = $filter_order;
		
			$this->assignRef('pagination', $pagination);

		} else {
			// Get data from the model
			$classements	= $this->get('Data');
			$isNew			= ($classements->id < 1);
	
			$text = $isNew ? JText::_( 'GMAPFP_NEW' ) : JText::_( 'GMAPFP_EDIT' );
			JToolBarHelper::title(   JText::_( 'GMAPFP_CLASSEMENTS_MANAGER' ).': <small>[ ' . $text.' ]</small>', 'classement' );
			JToolBarHelper::apply();
			JToolBarHelper::save();
			if ($isNew)  {
				JToolBarHelper::cancel();
			} else {
				// for existing items the button is renamed `close`
				JToolBarHelper::cancel( 'cancel', 'JTOOLBAR_CLOSE' );
			}

			//creation de la liste des images
			jimport( 'joomla.filesystem.folder' );
			$imageFiles = JFolder::files( JPATH_SITE.'/images/gmapfp/classements' );
			$directory	= JURI::base().'..'.'/images/gmapfp/classements/';
			$javascript	= 'onchange="changeDisplayImage('."'".$directory."'".');"';
			$images 	= array(  JHTML::_('select.option',  '', '- '. JText::_( 'Select Image' ) .' -' ) );
			$extensions = "bmp|gif|jpg|jpeg|png";
			foreach ( $imageFiles as $file ) {
			   if ( preg_match( "#$extensions#i", $file ) ) {
					$images[] = JHTML::_('select.option',  $file);
				}
			}
			$lists['images'] = JHTML::_('select.genericlist',  $images, 'img', 'class="inputbox required" size="1" '. $javascript, 'value', 'text', $classements->img );

			//Cration de la liste des langues
			jimport('joomla.language.helper');
			$List_langue['*'] = JText::_('JALL_LANGUAGE');
			$List_langue = array_merge($List_langue, JLanguageHelper::createLanguageList($classements->language, constant('JPATH_SITE'), true, true));

			$lists['language'] = JHtml::_('select.genericlist', $List_langue, 'language',
				array(
					'list.attr' => false,
					'list.select' => $classements->language
				)
			);
			
			//Cration de la liste des types
			$types 		= array();
			$types[] 	= JHTML::_('select.option',  '', '- '. JText::_( 'GMAPFP_SELECT_TYPE' ) .' -' );
			$types[] 	= JHTML::_('select.option',  1, JText::_( 'GMAPFP_CLASSEMENTs' ) );
			$types[] 	= JHTML::_('select.option',  2, JText::_( 'GMAPFP_LABELs' ) );
			$types[] 	= JHTML::_('select.option',  3, JText::_( 'GMAPFP_PICTOs' ) );
			$lists['types'] = JHTML::_('select.genericlist',  $types, 'cat', 'class="inputbox required" size="1" ', 'value', 'text', $classements->cat );
		}
		JHTML::_('behavior.tooltip');

		$this->assignRef('classements', $classements);
		$this->assignRef('lists', $lists);
		
		$pageNav =  $this->get( 'Pagination' );				
		$this->assignRef('pageNav', $pageNav);

		$this->assignRef('lists', $lists);

		parent::display($tpl);

	}
}
