<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.91pro
	* Creation date: Aot 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class GMapFPViewGMapFPs extends JView
{
	function display($tpl = null)
	{
		$this->document->addStyleSheet('components/com_gmapfp/views/general.css');
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 

		JHTML::_('behavior.tooltip');

		// Get data from the model
		$items		=  $this->get( 'Data');
		$custom		=  $this->get( 'Custom');
		$total		=  $this->get( 'Total');
		$pageNav 	=  $this->get( 'Pagination' );
		$this->state= $this->get('State');

		$filtrevilles = array();
		$filtrevilles[] = JHTML::_('select.option', '- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' -' );
				foreach($this->get('listville') as $temp) {
					$filtrevilles[] = JHTML::_('select.option', $temp->ville );
				}

		$filtredepartements = array();
		$filtredepartements[] = JHTML::_('select.option', '- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' -' );
				foreach($this->get('listdepartement') as $temp) {
					$filtredepartements[] = JHTML::_('select.option', $temp->departement );
				}

		$filtreauteurs = array();
		$filtreauteurs[] = JHTML::_('select.option', 0, JText::_( 'JOPTION_SELECT_AUTHOR' ) );
				foreach($this->get('Authors') as $temp) {
					$filtreauteurs[] = JHTML::_('select.option', $temp->value, $temp->text );
				}
		
		$filtrelangues = array_merge(array(JHTML::_('select.option', 0, JText::_( 'JOPTION_SELECT_LANGUAGE' ) )), JHtml::_('contentlanguage.existing', true, true));

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir', 	'filter_order_Dir', 	'', 											'word');
		$search				= $mainframe->getUserStateFromRequest( $option.'search', 			'search', 				'',												'string' );
		$filtreville 		= $mainframe->getUserStateFromRequest( $option.'filtreville', 		'filtreville', 			'-- '.JText::_( 'GMAPFP_VILLE' ).' --', 		'string' );
		$filtredepartement 	= $mainframe->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', 	'-- '.JText::_( 'GMAPFP_DEPARTEMENT' ).' --', 	'string' );
		$filtrecategorie 	= $mainframe->getUserStateFromRequest( $option.'filtrecategorie', 	'filtrecategorie', 		0, 	'int' );
		$filtreauteur	 	= $mainframe->getUserStateFromRequest( $option.'filtreauteur', 		'filtreauteur', 		0, 	'int' );
		$filtrelangue	 	= $mainframe->getUserStateFromRequest( $option.'filtrelangue', 		'filtrelangue', 		0, 	'string' );

		$lists['ville'] 		= JHTML::_('select.genericlist', $filtrevilles, 'filtreville', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtreville );
		$lists['departement'] 	= JHTML::_('select.genericlist', $filtredepartements, 'filtredepartement', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtredepartement );
		$lists['categorie'] 	= JHTML::_('list.category',  'filtrecategorie', $option, intval( $filtrecategorie ), 'onchange="form.submit()"');
		$lists['auteur'] 		= JHTML::_('select.genericlist', $filtreauteurs, 'filtreauteur', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtreauteur );
		$lists['langue'] 		= JHTML::_('select.genericlist', $filtrelangues, 'filtrelangue', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtrelangue );
		
		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;
		
		$this->assignRef('custom',	$custom);
		$this->assignRef('lists', 	$lists);
		$this->assignRef('items',	$items);
		$this->assignRef('pageNav', $pageNav);

		$this->addToolbar();

		parent::display($tpl);

	}

	protected function addToolbar()
	{
		require_once JPATH_COMPONENT.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions($this->state->get('filter.category_id'));
		$user	= JFactory::getUser();

		JToolBarHelper::title(   JText::_( 'GMAPFP_LIEUX_MANAGER' ), 'lieux' );
		if ($canDo->get('core.create')) {
			JToolBarHelper::addNewX();
		}
		if (($canDo->get('core.edit'))) {
			JToolBarHelper::editListX();
			JToolBarHelper::divider();
		}
		if ($canDo->get('core.create')) {
			JToolBarHelper::customX( 'copy', 'copy.png', 'copy_f2.png', 'JTOOLBAR_SAVE_AS_COPY' );
		}
		if (($canDo->get('core.edit'))) {
			JToolBarHelper::customX( 'user', 'restore.png', 'restore_f2.png', 'JGLOBAL_USERNAME' );
			JToolBarHelper::divider();
		}

		if ($canDo->get('core.edit.state')) {
			if ($this->state->get('filter.state') != 2){
				JToolBarHelper::publishList();
				JToolBarHelper::unpublishList();
				JToolBarHelper::divider();
			}
		}
		if ( $canDo->get('core.delete')) {
			JToolBarHelper::deleteList();
			JToolBarHelper::divider();
		}
		if ($canDo->get('core.admin')) {
			$bar =  JToolBar::getInstance('toolbar');
			$bar->appendButton( 'Popup', 'options', 'Preferences', 'index.php?option=com_gmapfp&controller=configuration&task=configuration', 875, 550 );
			//JToolBarHelper::preferences('com_gmapfp', '620', '750');
			JToolBarHelper::divider();
		}
	}

}
