<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.87pro
	* Creation date: Mai 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

class GMapFPsControllerGmapfpContact extends GMapFPsController
{
	function __construct()
	{
		parent::__construct();

	}

	function submit()
	{
		$mainframe = JFactory::getApplication(); 
		$Itemid    = JRequest::getInt('Itemid'); 
		
		$sent = false;
        $params = clone($mainframe->getParams('com_gmapfp'));

		JRequest::checkToken() or jexit( JText::_('JINVALID_TOKEN') );

		$db			= JFactory::getDBO();
		$SiteName	= $mainframe->getCfg('sitename');

		$default	= JText::_('GMAPFP_EMAIL_RECU_DE').' '.$SiteName;
		$contactId	= JRequest::getInt( 'id',			0,			'post' );
		$name		= JRequest::getVar( 'nom',			'',			'post' );
		$email		= JRequest::getVar( 'email',		'',			'post' );
		$subject	= JRequest::getVar( 'subject',		$default,	'post' );
		$emailCopy	= JRequest::getInt( 'email_copy', 	0,			'post' );
		$redirect	= JRequest::getVar( 'redirect', 	'',			'post' );

		 // load the contact details
		$model		= &$this->getModel('gmapfp');
		$qOptions[]	= $contactId;
		$contact_array	= $model->getGMapFPList( $qOptions );
		$contact	= $contact_array[0];
		$body		= '';
		$page_link	= substr(JUri::base(),0,-1).JRoute::_(GMapFPHelperRoute::getArticleRoute($contact->slug, $contact->catslug), false);

		//traite les champs perso s'il exist
		if (JFile::exists(JPATH_COMPONENT."/helpers/mail/email_fields.xml")) {
			$language = JFactory::getLanguage();
			$language->load('com_gmapfp_mail', JPATH_COMPONENT."/helpers/mail/");
			$xml_str = file_get_contents(JPATH_COMPONENT."/helpers/mail/email_fields.xml");
			$xml_data = simplexml_load_string($xml_str);
			foreach ($xml_data->div1->children() as $child) {
				$body .= JText::_( $child->attributes()->send )."\n";
				$variable = (string)$child->children()->attributes()->name;
				$body .= JRequest::getVar( $variable,		'',			'post' )."\n";
			}
			foreach ($xml_data->div2->children() as $child) {
				$body .= JText::_( $child->attributes()->send )."\n";
				$variable = (string)$child->children()->attributes()->name;
				$body .= JRequest::getVar( $variable,		'',			'post' )."\n";
			}
		} else {
			$body		.= JRequest::getVar( 'message',		'',			'post' );
		}

		// Input validation
		if  (!$this->_validateInputs( $contact, $email, $subject, $body ) ) {
			JError::raiseWarning( 0, $this->getError() );
			return false;
		}

		//gestion du captcha 
		$user   = JFactory::getUser();
		if ($params->get('gmapfp_afficher_captcha')&&!$user->get('gid')) { 
			if(count($_POST)>0){

				switch ($params->get('captcha_type')) {
				case 1 :
					require_once(JPATH_COMPONENT.'/libraries/recaptcha/recaptchalib.php');
					$resp = recaptcha_check_answer ($params->get('gmapfp_recaptcha_key_private'),
												$_SERVER["REMOTE_ADDR"],
												$_POST["recaptcha_challenge_field"],
												$_POST["recaptcha_response_field"]);
					
					if (!$resp->is_valid) {
					// What happens when the CAPTCHA was entered incorrectly
					$msg = "The reCAPTCHA wasn't entered correctly. Go back and try it again." .
						 "(reCAPTCHA said: " . $resp->error . ")";
							JError::raiseWarning(0, $msg);
							$link = JRoute::_($redirect, false);
							$this->setRedirect($link, "");
							return false;
							//$captacha=false;
					}
					break;
				default :
					if(isset($_SESSION['gmapfp-captcha-code'])) {
						if ($_SESSION['gmapfp-captcha-code'] != @$_POST['keystring']){
							JError::raiseWarning(0, JText::_('GMAPFP_CAPTCHA'));
							$link = JRoute::_($redirect, false);
							$this->setRedirect($link, "");
							return false;
							//$captacha=false;
						}
					}
				}
			}
			unset($_SESSION['gmapfp-captcha-code']);
		};

		$MailFrom 	= $mainframe->getCfg('mailfrom');
		$FromName 	= $mainframe->getCfg('fromname');

		// Prepare email body
		$bodymail 	= JText::_('GMAPFP_EMAIL_RECU_DE').' '.$name."\n";
		$bodymail 	.= JText::_('GMAPFP_EMAIL_RECU_PAR').' '.$page_link."\n";
		$bodymail 	.= "\r\n\r\n".stripslashes($body);

		$mail = JFactory::getMailer();
		$mail->addRecipient( $contact->email );
		$mail->setSender( array( $email, $name ) );
		$mail->setSubject( $FromName.': '.$subject );
		$mail->setBody( $bodymail );

		$sent = $mail->Send();

		// check whether email copy function activated
		if ( $emailCopy and $sent)
		{
			$copyText 		= JText::_('GMAPFP_COPIE_DE').' '.$SiteName.' '.$contact->nom;
			$copyText 		.= "\r\n\r\n".$body;
			$copySubject 	= JText::_('GMAPFP_COPIE_DE')." ".$subject;

			$mail = JFactory::getMailer();

			$mail->addRecipient( $email );
			$mail->setSender( array( $MailFrom, $FromName ) );
			$mail->setSubject( $copySubject );
			$mail->setBody( $copyText );
			$sent = $mail->Send();
		}
		if ($sent) {
			$msg = JText::_( 'GMAPFP_EMAIL_MERCI');
		} else {
			$msg = JText::_( 'GMAPFP_SUBMIT_ERROR' );
		}

		$link = JRoute::_($redirect, false);
		$this->setRedirect($redirect, $msg);
	}

	function _validateInputs( $contact, $email, $subject, $body )
	{
		$mainframe 	= JFactory::getApplication(); 
		$session 	= JFactory::getSession();

		$sessionCheck 	= 1 ;
		$sessionName	= $session->getName();
		if  ( $sessionCheck ) {
			if ( !isset($_COOKIE[$sessionName]) ) {
				$this->setError( JText::_('JERROR_ALERTNOAUTHOR') );
				return false;
			}
		}

		// test to ensure that only one email address is entered
		$check = explode( '@', $email );
		if ( strpos( $email, ';' ) || strpos( $email, ',' ) || strpos( $email, ' ' ) || count( $check ) > 2 ) {
			$this->setError( JText::_( 'GMAPFP_EMAIL_VALID', true ) );
			return false;
		}

		return true;
	}

}
?>
