<?php
/**
 * JComments plugin for standart gmapfp objects support
 *
 * @version 10pro
 * @package JComments
 * @author Fabrice4821 (www.gmapfp.org)
 * @license GNU/GPL: http://www.gnu.org/copyleft/gpl.html
 **/

class jc_com_gmapfp extends JCommentsPlugin
{
	function getObjectInfo($id, $language = null)
	{
		$db = JCommentsFactory::getDBO();
		$article = null;
		$link = null;

			require_once(JPATH_ROOT.DS.'components'.DS.'com_gmapfp'.DS.'helpers'.DS.'route.php');

			$query = 'SELECT a.id, a.nom, a.created_by, a.access,' .
					' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
					' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
					' FROM #__gmapfp AS a' .
					' LEFT JOIN #__categories AS cc ON cc.id = a.catid' .
					' WHERE a.id = ' . intval($id);
			$db->setQuery( $query );
			$article = $db->loadObject();

			if (!empty($article)) {
				$user = JFactory::getUser();

				if (JCOMMENTS_JVERSION == '1.5') {
					$checkAccess = $article->access <= $user->get('aid', 0);
				
					if ($checkAccess) {
						$link = JRoute::_(GMapFPHelperRoute::getArticleRoute($article->slug, $article->catslug));
					} else {
						$link = JRoute::_("index.php?option=com_user&task=register");
					}
				} else {
					$authorised = JAccess::getAuthorisedViewLevels($user->get('id'));
					$checkAccess = in_array($article->access, $authorised);

					if ($checkAccess) {
						$link = JRoute::_(GMapFPHelperRoute::getArticleRoute($article->slug, $article->catslug));
					} else {
						$returnURL = JRoute::_(GMapFPHelperRoute::getArticleRoute($article->slug));

						$menu = JFactory::getApplication()->getMenu();
						$active = $menu->getActive();
						$ItemId = $active->id;
						$link = JRoute::_('index.php?option=com_users&view=login&Itemid=' . $ItemId);
						$uri = new JURI($link);
						$uri->setVar('return', base64_encode($returnURL));
						$link = $uri->toString();
					}
				}
			}

		$info = new JCommentsObjectInfo();

		if (!empty($article)) {
			$info->title = $article->nom;
			$info->access = $article->access;
			$info->userid = $article->created_by;
			$info->link = $link;
		}

		return $info;
	}
}
?>