<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.101pro
	* Creation date: Novembre 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();
jimport('joomla.application.component.model');

class GMapFPsModelEditLieux extends JModel
{
	var $_list;
	var $_label;
	var $_classement;
	var $_picto;

	function __construct()
	{
		parent::__construct();
		$document	= JFactory::getDocument();

		$array = JRequest::getVar('cid',  0, '', 'array');
		$this->setId((int)$array[0]);
		
		//Insertion des enttes GMapFP si non dj fait.
		if (!defined( '_JOS_GMAPFP_CSS' ))
		{
			/** verifi que la fonction n'est dfini qu'une faois */
			define( '_JOS_GMAPFP_CSS', 1 );
	
			$document->addCustomTag( '<link rel="stylesheet" href="'.JURI::base().'components/com_gmapfp/views/gmapfp/gmapfp.css" type="text/css" />'); 
		}
	}

	function _buildQuery()
	{
		$query = ' SELECT * '
			. ' FROM #__gmapfp_marqueurs where published = 1 '
		;

		return $query;
	}

	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
		$this->_datacustom = null;
	}

	function getChamps($id_lieu = '', $view = array())
	{
		$champ = array ();
		$catid_field = array ();
		
 		//filtre par langue
		$app	= JFactory::getApplication();
        $params	= clone($app->getParams('com_gmapfp'));
		$tag	= JFactory::getLanguage()->getTag();
        $db		= JFactory::getDBO();
		$join = '';
		$case = '';
		$parametres = ', a.parametres, a.nom';
		if ($app->isSite() && $app->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='(c.langue = ' . $db->Quote($tag).'OR c.langue IS NULL)';
			$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
			$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as nom, '.
                ' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres ';
			$parametres = '';
		}
		$wheres[] ='a.published = 1';
		
		$query = ' SELECT a.alias, a.description, a.position, a.for_cat, a.catid, a.ordering, a.type, a.form_separator, a.id '.$parametres.
				$case.
				' FROM #__gmapfp_extension_type as a '.
				$join.
                ' WHERE ' . implode( '  AND ', $wheres ).
				' ORDER BY a.ordering';
		$this->_db->setQuery( $query );
		$fields = $this->_db->loadObjectList();

		if ($fields) {
			$query = ' SELECT * '.
					' FROM #__gmapfp '.
					' WHERE id = '.$id_lieu;
			$this->_db->setQuery( $query );
			$values = @$this->_db->loadAssoc();
			if (!$values and !$params->get('choix_categorie', 0)) {
				$tmp = $params->get('catids');
				$values['catid'] = $tmp[0];
				unset($tmp);
			}
			
			$editor = JFactory::getEditor();
			foreach ($fields as $field) {
				$display_none = "";
				if  (!($view and in_array($field->id, $view))) {
					$display_none = 'style = "display:none;"';
				} else {
					if ($field->for_cat) {
						$catids = explode(',', $field->catid);
						foreach ($catids as $catid)
							if  ($view and in_array($field->id, $view)) 
								$catid_field['field_catid_'.$field->id][] = 'cat'.$catid;
						if (!in_array($values['catid'], $catids))
							$display_none = 'style = "display: none;"';
					}
				};
				switch ($field->type) {
					case 0 : // champ text
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<input class="inputbox" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.@$values['field_'.$field->id].'" />
							</td>
						</tr>
						';
						break;
					case 1 : // champ textarea
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<textarea rows="4" cols="32" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" >'.(@$values['field_'.$field->id]).'</textarea>
							</td>
						</tr>
						';
						break;
					case 2 : // champ editor
						if (GMAPFP_ANDROID) {
							$editeur = '<textarea class="inputbox" rows="6" cols="65" id="perso_field_'.$field->id.'" name="perso_field_'.$field->id.'">'.htmlspecialchars(@$values['field_'.$field->id], ENT_COMPAT, 'UTF-8').'</textarea>';
						}else{
							$editeur = $editor->display('perso_field_'.$field->id, htmlspecialchars(@$values['field_'.$field->id], ENT_COMPAT, 'UTF-8'), '600', '300', '75', '20', false, 'perso_field_'.$field->id);
						}

						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
							'.$editeur.'
							</td>
						</tr>
						';
						break;
					case 3 : // champ checkbox
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'checked'; else $check = '';
							$temp .= '<input class="inputbox" style="float: none;" type="checkbox" name="perso_field_'.$field->id.'[]" id="perso_field_'.$field->id.'" value="'.strstr($parametre, '::', 1)."\n".'" '.$check.'>&nbsp;'.substr(strstr($parametre, '::', 0),2).$field->form_separator."\n";
						}
						$temp .= '
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 4 : // champ radiobuton
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								';
						$parametres = explode("\n", $field->parametres);
						foreach($parametres as $parametre){
							if (strstr($parametre, '::', 1) == str_replace("\n", "", @$values['field_'.$field->id])) $check = 'checked'; else $check = '';
							$temp .= '<input class="inputbox" style="float: none;" type="radio" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" value="'.strstr($parametre, '::', 1).'" '.$check.'>&nbsp;'.substr(strstr($parametre, '::', 0),2).$field->form_separator."\n";
						}
						$temp .= '
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 5 : // champ list 1 choix
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.' size="1">';
						$parametres = explode("\n", $field->parametres);
						foreach($parametres as $parametre){
							if (trim(strstr($parametre, '::', 1)) == str_replace("\n", "", @$values['field_'.$field->id])) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1).'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 6 : // champ list multi choix
						$temp = '
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<select name="perso_field_'.$field->id.'[]" id="perso_field_'.$field->id.'" multiple size="4">';
						$parametres = explode("\r\n", $field->parametres);
						$checkeds = explode("\r\n", @$values['field_'.$field->id]);
						foreach($parametres as $parametre){
							if (in_array( strstr($parametre, '::', 1), $checkeds)) $check = 'selected="selected"'; else $check = '';
							$temp .= "\n".'<option class="inputbox" value="'.strstr($parametre, '::', 1)."\n".'" '.$check.'>'.substr(strstr($parametre, '::', 0),2).'</option>';
						}
						$temp .= '
								</select>
							</td>
						</tr>
						';
						$champ[$field->position][] = $temp;
						break;
					case 7 : // champ text readonly
						$champ[$field->position][]='
						<tr  class="disable" '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								<input class="inputbox" readonly="readonly" type="text" name="perso_field_'.$field->id.'" id="perso_field_'.$field->id.'" size="50" value="'.$field->parametres.'" />
							</td>
						</tr>
						';
						break;
					case 8 : // champ text d'information
						$champ[$field->position][]='
						<tr '.$display_none.' id="field_catid_'.$field->id.'">
							<td width="110" class="key">
								<label for="perso_field_'.$field->id.'">
									'.$field->nom.'
								</label>
							</td>
							<td>
								'.$field->parametres.'
							</td>
						</tr>
						';
						break;
				}
			}
		}
		$champ['json'] = json_encode($catid_field);
		return $champ;
	}
	
	function &getData()
	{
		// Load the data si pas tache "nouveau lieu"
		if (empty( $this->_data) and $this->get('state')->task!='add') {
			$query = ' SELECT c.*, v.name AS last_editor FROM #__gmapfp AS c '.
					'  LEFT JOIN #__users AS v ON v.id = c.modified_by' .
					'  WHERE c.id = '.$this->_id;
			$this->_db->setQuery( $query );
			$this->_data = $this->_db->loadObject();
		}
		if (!$this->_data) {
			$createdate = JFactory::getDate();
			$this->_data = new stdClass();
			$this->_data->id = 0;
			$this->_data->nom = null;
			$this->_data->alias = null;
			$this->_data->adresse = null;
			$this->_data->adresse2 = null;
			$this->_data->codepostal = null;
			$this->_data->ville = null;
			$this->_data->departement = null;
			$this->_data->pay = null;
			$this->_data->email = null;
			$this->_data->web = null;
			$this->_data->img = null;
			$this->_data->album = null;
			$this->_data->introtext = null;
			$this->_data->fulltext = null;
			$this->_data->horaires_prix = null;
			$this->_data->link = null;
			$this->_data->article_id = null;
			$this->_data->icon = null;
			$this->_data->icon_label = null;
			$this->_data->glat = null;
			$this->_data->glng = null;
			$this->_data->gzoom = null;
			$this->_data->catid = null;
			$this->_data->created_by = null;
			$this->_data->published = null;
			$this->_data->access = 0;
			$this->_data->checked_out = null;
			$this->_data->metadesc = null;
			$this->_data->metakey = null;
			$this->_data->metadata = null;
			$this->_data->hits = 0;
			$this->_data->version = 0;
			$this->_data->modified = null;
			$this->_data->modified_by = 0;
			$this->_data->created = $createdate->toUnix();
			$this->_data->publish_up = $createdate->toUnix();
			$this->_data->publish_down = "0000-00-00 00:00:00";
			$this->_data->ordering = 0;		
			$this->_data->attribs = null;	
			$this->_data->index_marqueur = 0;	
			$this->_data->language = null;
			$this->_data->classements = null;
			$this->_data->labels = null;
			$this->_data->pictos = null;
		}
		
		if (JString::strlen($this->_data->fulltext) > 1) {
			$this->_data->text = $this->_data->introtext . "<hr id=\"system-readmore\" />" . $this->_data->fulltext;
		} else {
			$this->_data->text = $this->_data->introtext;
		}
		$result = $this->_data;
		return $result;
	}

	function &getClassements()
	{
		if (empty( $this->_label )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 2) AND (published = 1) ORDER BY ordering ';
			$this->_label = $this->_getList( $query );
		}

		if (empty( $this->_classement )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 1) AND (published = 1) ORDER BY ordering ';
			$this->_classement = $this->_getList( $query );
		}

		if (empty( $this->_picto )) {
			$query = ' SELECT * FROM #__gmapfp_classements WHERE (cat = 3) AND (published = 1) ORDER BY ordering ';
			$this->_picto = $this->_getList( $query );
		}
		$lists['labels'] = $this->_label;
		$lists['classements'] = $this->_classement;
		$lists['pictos'] = $this->_picto;
		return $lists;
	}

	function &getCustom()
	{
		// Load the data
		if (empty( $this->_datacustom )) {
			$query = ' SELECT * FROM #__gmapfp_params_custom_fields  ';
			$this->_datacustom = $this->_getList( $query );
		}

		$result = $this->_datacustom;
		return $result;
	}

	function &getMarqueurs()
	{
		if (empty( $this->_list ))
		{
			$query = $this->_buildQuery();
			$this->_list = $this->_getList( $query );
		}

		$result = $this->_list;
		return $result;
	}

	function &getExistingSubmit($created_by, $created, $nom)
	{
		$query = " SELECT id "
			. " FROM #__gmapfp "
			. " WHERE created_by='".$created_by."'"
			. " and nom='".$nom."'"
			. " and created>='".$created."'"
		;
		
		$result = array_key_exists('0', $this->_getList( $query ));
		return $result;
	}

	function &getUser($id)
	{
		$query = ' (SELECT created_by '
			. ' FROM #__gmapfp '
			. ' WHERE id='.$id.')'
		;
		$query = ' SELECT username, email '
			. ' FROM #__users '
			. ' WHERE id='.$query
		;
        $this->_db->setQuery( $query );
        $user = $this->_db->loadObject();

		return $user;
	}

	function store($data)
	{
		$post = $data;
		// Check for request forgeries
		JRequest::checkToken() or jexit( 'Invalid Token' );

		$mainframe 	= JFactory::getApplication(); 
		$params 	= $mainframe->getParams('com_gmapfp');
		$row 		= $this->getTable('GMapFP', 'GMapFPTable');
		$user		= JFactory::getUser();
		$nullDate	= $this->_db->getNullDate();
    	$_layout 	= JRequest::getVar('layout', "", '', 'string');
		$datenow 	= JFactory::getDate();

		//dpublie sur modification par un utilisateur
		if ($params->get('gmapfp_unpiblish_after_update', 0)) {
			$data['published'] = 0;
		}
		
		// Bind the form fields to the table
		if (!$row->bind($data)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		// Prepare the content for saving to the database
		$this->saveGMapfpPrep( $row );

		// sanitise id field
		$row->id = (int) $row->id;

		$isNew = true;
		// Are we saving from an item edit?
		if ($row->id) {
			$isNew = false;
			$row->modified 		= $datenow->toMySQL();
			$row->modified_by 	= $user->get('id');
		}

		if (!intval($row->created))
		{
			$row->created = $datenow->toMySQL();
		}
		$date_created = JFactory::getDate($row->created);

		// Append time if not added to publish date
		if (!intval($row->publish_up))
		{
			$row->publish_up = $datenow->toMySQL();
		}

		// Handle never unpublish date
		if (trim($row->publish_down) == JText::_('GMAPFP_NEVER') || trim( $row->publish_down ) == '')
		{
			$row->publish_down = $nullDate;
		}
		else
		{
			if (!intval($row->publish_down))
			{
				$row->publish_down = $datenow->toMySQL();
			}
		}

		//traitement spcifique au formulaire de soumission
		if ($_layout=='soumission'){
			//fin de publication automatique
			if (((int)$params->get('gmapfp_temps_publication', 0))>0){
				$temps = (int)$params->get('gmapfp_temps_publication');
				$date = JFactory::getDate($row->publish_up);
				$date = $date->toUnix() + ($temps*3600*24);
				$row->publish_down = date('Y-m-d H:i:s', $date);
			}
			//forage publication automatique
			if ($params->get('gmapfp_submit_validation_admin', 0)){
				$row->published = true;
			}
		}

		// Increment the content version number
		$row->version++;

		// Make sure the record not already exists
		$date_created = $date_created->toUnix() - 4;
		$date_created = JFactory::getDate($date_created);
		$date_created = $date_created->toMySQL();
		$Field_exist = $this->getExistingSubmit($row->created_by, $date_created, $row->nom);	

		if (($Field_exist)and(!$row->id)) return true;
		// Make sure the record is valid
		if (!$row->check()) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}
		
		// Store the web link table to the database
		if (!$row->store()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}

		//traite les champs perso. Notament ceux qui accepte des balise html
		$query = ' SELECT id FROM #__gmapfp_extension_type '.
				'  WHERE type = 2 OR type = 1';
		$this->_db->setQuery( $query );
		$editeurs = $this->_db->loadColumn();

		$mes_valeurs = array();
		foreach ($post as $key => $value) {
			if (substr($key, 0, 11) == 'perso_field') {
				//si checkbox, ou list, ou radio buton, ou ...
				$search = array("\r", "\n", "\t", "\0", " ", "\x0B");
				if (is_array($value)) $value = implode("\r\n", str_replace($search, '', $value));
				//si editeur
				if (in_array(substr($key, 12), $editeurs)) {
					$value = JRequest::getVar( $key, '', 'post', 'string', JREQUEST_ALLOWRAW );
					$value = str_replace( '<br>', '<br />', $value );
				}
				$mes_valeurs[] = '`field_'.substr($key, 12).'` = '.$this->_db->quote($value);
			}
		}
		if ($mes_valeurs) {
			$query = 'UPDATE `#__gmapfp` '.
				' SET '.implode(',', $mes_valeurs).
				' WHERE id = '.$row->id;
			$this->_db->setQuery( $query );
			if (!$this->_db->query())
			{
				die(print_r($this->_db->getErrorMsg()));
			}
		}

		//dtecte la catgorie si besoin
		if ($params->get('gmapfp_submit_envoie_mail_admin', 0) or $params->get('gmapfp_submit_envoie_mail_user_builder', "")!="") {
			$query = ' SELECT title'.
					' FROM #__categories'.
					' WHERE id='.$row->catid;
			$this->_db->setQuery( $query );
			$categorie = $this->_db->loadColumn();
		}
		
		//envoie d'un message d'avertissement au contact dsign
		if ($params->get('gmapfp_submit_envoie_mail_admin', 0)) {
			//$sendmail = $this->sendmail($row->id);
			require_once (JPATH_COMPONENT.'/helpers/send_mail.php');
			if ($_layout=='soumission') { 
				GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_NEW_SUBMIT'), JText::sprintf('GMAPFP_NEW_SUBMIT2', $row->nom, $categorie[0]), !$params->get('gmapfp_temps_publication'), $params->get('gmapfp_submit_envoie_mail_link', 0));
			} else {
				if ($isNew) {
					GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_NEW_LIEU_SUBMIT'), JText::sprintf('GMAPFP_NEW_LIEU_SUBMIT2', $row->nom, $categorie[0]), 0, $params->get('gmapfp_submit_envoie_mail_link', 0));
				} else {
					GMapFPSend_Mail::sendmail($row->id, JText::_('GMAPFP_UPDATE_LIEU_SUBMIT'), JText::sprintf('GMAPFP_UPDATE_LIEU_SUBMIT2', $row->nom, $categorie[0]), 0, $params->get('gmapfp_submit_envoie_mail_link', 0));
				}
			}
		}

		//envoie d'un message de confirmation ou de remerciement
		if ($params->get('gmapfp_submit_envoie_mail_user_builder', "") and $_layout=='soumission') {
			require_once (JPATH_COMPONENT.'/helpers/send_mail.php');
			$champ = $params->get('gmapfp_submit_envoie_mail_user_builder');
			GMapFPSend_Mail::sendmail_remerciement($row->$champ, $row->id, $row->nom, $categorie[0]);
		}

		// attribut le n 1  ordering et dcale les autres n
		if (!$row->reorder()) {
			$this->setError( $this->_db->getErrorMsg() );
			return false;
		}
		
		$result = $row->id.':'.$row->alias;
		return $result;
	}

	function saveGMapFPPrep( &$row )
	{
		// Get submitted text from the request variables
		$text_horaires_prix = JRequest::getVar( 'text_horaires_prix', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$text_message		= JRequest::getVar( 'text_message', '', 'post', 'string', JREQUEST_ALLOWRAW );
		$text_link			= JRequest::getVar( 'text_link', '', 'post', 'string', JREQUEST_ALLOWRAW );

		// Clean text for xhtml transitional compliance
		$text_horaires_prix		= str_replace( '<br>', '<br />', $text_horaires_prix );
		$text_message		= str_replace( '<br>', '<br />', $text_message );
		$text_link		= str_replace( '\\', '/', $text_link );

		// Search for the {readmore} tag and split the text up accordingly.
		$pattern = '#<hr\s+id=("|\')system-readmore("|\')\s*\/*>#i';
		$tagPos	= preg_match($pattern, $text_message);

		if ( $tagPos == 0 )
		{
			$row->introtext	= $text_message;
		} else
		{
			list($row->introtext, $row->fulltext) = preg_split($pattern, $text_message, 2);
		}

		$row->horaires_prix	= $text_horaires_prix;
		$row->link	= $text_link;

		//sauvegardel'id de l'utilisateur
		if (!$row->created_by) {
			$user = JFactory::getUser();
			$row->created_by = $user->get('id');
		}

		return true;
	}
	
    function getImages()
    {
        jimport( 'joomla.filesystem.file' );
		$images     = array ();
		$id 		= (int)JRequest::getVar('cid');
		if ($id==0) return false;
		$basePath = COM_GMAPFP_IMAGES_FOLDER.DS.'GA'.$id;
//die(print_r($basePath));
		// Cre le rpertoire s'il n'exist pas
		$buffer = "<html>\n<body bgcolor=\"#FFFFFF\">\n</body>\n</html>";
		if (!JFolder::exists($basePath)) {
			JFolder::create($basePath);
			JFile::write($basePath.DS."index.html", $buffer);
		}
		if (!JFolder::exists($basePath.DS.'thumbs')) {
			JFolder::create($basePath.DS.'thumbs');
			JFile::write($basePath.DS.'thumbs'.DS."index.html", $buffer);
		}
        // Get the list of files and folders from the given folder
        $fileList   = JFolder::files($basePath);
//die(print_r('ok23'));

        // Iterate over the files if they exist
        if ($fileList !== false) {
            foreach ($fileList as $file)
            {
                if (is_file($basePath.DS.$file) && substr($file, 0, 1) != '.' && strtolower($file) !== 'index.html') {
                    $tmp = new JObject();
                    $tmp->name = $file;
                    $tmp->path_relative = COM_GMAPFP_IMAGES_HTTP.'/GA'.$id;
                    $tmp->path = str_replace(DS, '/', JPath::clean($basePath.DS.$file));
                    $tmp->size = filesize($tmp->path);
                    $tmp->size = round($tmp->size/1024, 2);

                    $ext = strtolower(JFile::getExt($file));
                    switch ($ext)
                    {
                        // Image
                        case 'jpg':
                        case 'png':
                        case 'gif':
                        case 'xcf':
                        case 'odg':
                        case 'bmp':
                        case 'jpeg':
                            $info = @getimagesize($tmp->path);
                            $tmp->width     = @$info[0];
                            $tmp->height    = @$info[1];
                            $tmp->type      = @$info[2];
                            $tmp->mime      = @$info['mime'];

                            if (($info[0] > 60) || ($info[1] > 60)) {

								if ($tmp->width > $tmp->height) {
									$percentage = (60 / $tmp->width);
								} else {
									$percentage = (60 / $tmp->height);
								}
						
								//gets the new value and applies the percentage, then rounds the value
								$tmp->width = round($tmp->width * $percentage);
								$tmp->height = round($tmp->height * $percentage);
                            }
                 			//lecture des infos exif du fichier image
							$xml = substr($file, 0, -(strlen(JFile::getExt($file))+1));
							$xml .= '.xml';

							if (JFile::exists($basePath.DS.'infos'.DS.$xml)) {
								$xml_str = file_get_contents($basePath.DS.'infos'.DS.$xml);
								$xml_data = new SimpleXMLElement($xml_str);
									$tmp->titre = (string) $xml_data->titre;
									$tmp->description = (string) $xml_data->description;
							} else {
									$tmp->titre = '';
									$tmp->description = '';
							}
                 			$images[] = $tmp;
                            break;
                    }
                }
            }
        }
        return $images;
    }
	public function checkin($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();
			if (!$user->get('id')) $user_id = 1;
				else $user_id = $user->get('id');

			// Get an instance of the row to checkin.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user_id && !$user->authorise('core.admin', 'com_checkin'))
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKIN_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row in.
			if (!$table->checkin($pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}

	public function checkout($pk = null)
	{
		// Only attempt to check the row in if it exists.
		if ($pk)
		{
			$user = JFactory::getUser();
			if (!$user->get('id')) $user_id = 1;
				else $user_id = $user->get('id');

			// Get an instance of the row to checkout.
			$table = $this->getTable('GMapFP', 'GMapFPTable');
			if (!$table->load($pk))
			{
				$this->setError($table->getError());
				return false;
			}

			// Check if this is the user having previously checked out the row.
			if ($table->checked_out > 0 && $table->checked_out != $user_id)
			{
				$this->setError(JText::_('JLIB_APPLICATION_ERROR_CHECKOUT_USER_MISMATCH'));
				return false;
			}

			// Attempt to check the row out.
			if (!$table->checkout($user_id, $pk))
			{
				$this->setError($table->getError());
				return false;
			}
		}

		return true;
	}
}
?>
