<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.101pro
	* Creation date: Novembre 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.model' );


class GMapFPsModelGestionLieux extends JModel
{
	var $_data = null;
	var $_total = null;

		function __construct()
		{
			parent::__construct();
			
			//rcupration des id cochs
			$array = JRequest::getVar('cid',  0, '', 'array');
			$this->setId((int)$array[0]);
			
		}
		
	function setId($id)
	{
		// Set id and wipe data
		$this->_id		= $id;
		$this->_data	= null;
	}

	function getlistville()
	{
		$query = 'SELECT DISTINCT ville' .
				' FROM #__gmapfp' .
				' ORDER BY ville';
		$result = $this->_getList( $query );
		return $result;
	}
	
	function getlistdepartement()
	{
		$query = 'SELECT DISTINCT departement' .
				' FROM #__gmapfp' .
				' ORDER BY departement';
		$result = $this->_getList( $query );
		return $result;
	}
	
	function getlistpays()
	{
		$query = 'SELECT DISTINCT pay' .
				' FROM #__gmapfp' .
				' ORDER BY pay';
		$result = $this->_getList( $query );
		return $result;
	}
	
	function _buildQuery()
	{
		// Get the WHERE and ORDER BY clauses for the query
		$where		= $this->_buildContentWhere();
		$orderby	= $this->_buildContentOrderBy();

		$query = ' SELECT a.*, b.title, l.name AS editor '.
			' FROM #__gmapfp AS a '.
			' LEFT JOIN #__categories AS b ON b.id = a.catid' .
			' LEFT JOIN #__users AS l ON l.id = a.checked_out' .
			$where.
			$orderby
		;
		//die(print_r($query));
		return $query;
	}

	function _buildContentWhere()
	{
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 
		//$config 	=& JComponentHelper::getParams('com_gmapfp'); //que les paramtres du composant
		$app = JFactory::getApplication('site');
		$config = $app->getParams(); // tous les paramtres du composant avec ceux du menu
		//gestion des droits
		require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions();

		$db			= JFactory::getDBO();
		
        $filtreville 		= $mainframe->getUserStateFromRequest( $option.'filtreville', 		'filtreville', 			'0', 	'string' );
        $filtredepartement 	= $mainframe->getUserStateFromRequest( $option.'filtredepartement', 'filtredepartement', 	'0', 	'string' );
        $filtrepay 			= $mainframe->getUserStateFromRequest( $option.'filtrepay', 		'filtrepay', 			'0', 	'string' );
        $filtrecategorie 	= $mainframe->getUserStateFromRequest( $option.'filtrecategorie', 	'filtrecategorie', 		'0', 	'int' );

		
		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );
		$search				= $mainframe->getUserStateFromRequest( $option.'search',			'search',			'',				'string' );
		$search				= JString::strtolower( $search );

		$where = array();

		//filtre par rapport au user
		if ($canDo->get('core.edit.own') && !$canDo->get('core.edit')) {
			$user		= & JFactory::getUser();
			$where[] = ' a.created_by = '.$user->get('id').' ';
		}

		//filtre les catgories slectionnes
		if ($cats_id = $config->get('gmapf_categories_selected', 0)) {
			$where_or = array();
			foreach ($cats_id as $cat_id) {
				$where_or[] = 'catid = '.$cat_id;
			}
			$where[] = '('.implode(' or ',$where_or).')';
		}
		if ($search) {
			$where[] = 'LOWER(a.nom) LIKE '.$db->Quote( '%'.$db->getEscaped( $search, true ).'%', false );
		}

        if ($filtreville<>'0') {
            $where[] = 'a.ville = \''.addslashes($filtreville).'\'';
        }           

		if ($filtredepartement<>'0') {
			$where[] = 'a.departement = \''.addslashes($filtredepartement).'\'';
		}

		if ($filtrepay<>'0') {
			$where[] = 'a.pay = \''.addslashes($filtrepay).'\'';
		}

        if ($filtrecategorie<>'0') {
            $where[] = 'a.catid = \''.addslashes($filtrecategorie).'\'';
        }

		$where 		= ( count( $where ) ? ' WHERE '. implode( ' AND ', $where ) : '' );

		return $where;
	}

	function _buildContentOrderBy()
	{
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCMD('option'); 

		$filter_order		= $mainframe->getUserStateFromRequest( $option.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir	= $mainframe->getUserStateFromRequest( $option.'filter_order_Dir',	'filter_order_Dir',	'',				'word' );

		if ($filter_order == 'a.ordering'){
			$orderby 	= ' ORDER BY  a.ordering '.$filter_order_Dir;
		} else {
			if ($filter_order) {
				$orderby 	= ' ORDER BY '.$filter_order.' '.$filter_order_Dir.' , catid, a.ordering ';
			}else{
				$orderby 	= ' ORDER BY catid, a.ordering ';
			};
		}

		return $orderby;
	}

	function getTotal()
	{
		// Lets load the content if it doesn't already exist
		if (empty($this->_total))
		{
			$query = $this->_buildQuery();
			$this->_total = $this->_getListCount($query);
		}

        $result = $this->_total;
		return $result;
	}

	function move($direction)
	{
		$row =& $this->getTable('GMapFP', 'GMapFPTable');
		if (!$row->load($this->_id)) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		//if (!$row->move( $direction, ' catid = '.(int) $row->catid.' AND published >= 0 ' )) {
		if (!$row->move( $direction, ' true AND published >= 0 ' )) {
			$this->setError($this->_db->getErrorMsg());
			return false;
		}

		return true;
	}

	function saveorder($cid = array(), $order)
	{
		$row = $this->getTable('GMapFP', 'GMapFPTable');
		//$groupings = array();

		// update ordering values
		for( $i=0; $i < count($cid); $i++ )
		{
			$row->load( (int) $cid[$i] );
			// track categories
			//$groupings[] = $row->catid;

			if ($row->ordering != $order[$i])
			{
				$row->ordering = $order[$i];
				if (!$row->store()) {
					$this->setError($this->_db->getErrorMsg());
					return false;
				}
			}
		}

		$row->reorder();

		return true;
	}

	function getData()
	{
        // Lets load the data if it doesn't already exist
        if (empty( $this->_data ))
        {
            $query = $this->_buildQuery();
            $this->_data = $this->_getList( $query, $this->getState('limitstart'), $this->getState('limit'));
        }

        $result = $this->_data;
		return $result;
	}

	function delete()
	{
		$config = JComponentHelper::getParams('com_gmapfp');
		$cids = JRequest::getVar( 'cid', array(0), 'post', 'array' );

		$row = $this->getTable('GMapFP', 'GMapFPTable');

		if (count( $cids ))
		{
			foreach($cids as $cid) {
				$result = '';
				if ($config->get('gmapfp_del_img')) {
					//rcupre l'image principale
					$query = ' SELECT img FROM #__gmapfp '.
							'  WHERE id = '.$cid;
					$this->_db->setQuery( $query );
					$result = $this->_db->loadObject();
				}

				if (!$row->delete( $cid )) {
					$this->setError( $row->getErrorMsg() );
					return false;
				}else{
					if ($result) {
						//vrifi que l'image principale n'est pas utilise par un autre id
						$query = ' SELECT id FROM #__gmapfp '.
								'  WHERE img = \''.$result->img.'\'';
						$list = $this->_getList( $query );
						if ((count($list)>1).($result->img!='blank.png')) {
							unlink(JPATH_SITE.$config->get('gmapfp_chemin_img')."/".$result->img);
							unlink(JPATH_SITE.$config->get('gmapfp_chemin_img')."/thumbsArt/".$result->img);
							unlink(JPATH_SITE.$config->get('gmapfp_chemin_img')."/thumbsGMap/".$result->img);
						}
					}
					if ($config->get('gmapfp_del_galerie')) {
						$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.DS.'GA'.$cid.DS.'thumbs');
						$this->rrmdir(COM_GMAPFP_IMAGES_FOLDER.'/GA'.$cid);
					}
					$query = 'DELETE FROM `#__gmapfp_extension_value` '.
						'WHERE id_gmapfp = '.$cid;
					$this->_db->setQuery( $query );
					$this->_db->query();
				}
			}						
		}
		return true;
	}
	
	function rrmdir($dir) { 
		if (is_dir($dir)) { 
			$objects = scandir($dir); 
			foreach ($objects as $object) { 
				if ($object != "." && $object != "..") { 
					if (filetype($dir."/".$object) == "dir") rmdir($dir."/".$object); else unlink($dir."/".$object); 
				} 
			} 
			reset($objects); 
			rmdir($dir); 
		} 
		return true;
	} 

}
