<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.116pro
	* Creation date: Aot 2015
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();
jimport('joomla.application.component.model');

class GMapFPsModelGMapFP extends JModel
{
	private $_catid = null;
	public $_result2 = null;
	
	private $_cat_parent = null;
	private $_cat_items = null;
	
	private $ajax = false;
	private $ajax_fields_filters = '';
	private $params = '';
	
	private $DataFilterList = null;
	private $log_instance = null;

    function __construct() 
    { 
        parent::__construct(); 
		$app = JFactory::getApplication('site');
		if ($app->getName()=='site') {
			$params = $app->getParams();
		} else {
			$params = JComponentHelper::getParams('com_gmapfp'); 
		}

		if ($params->get('gmapfp_log', 0)) {
			jimport('joomla.error.log');
			$this->log_instance = JLog::getInstance('GMapFP_'.JFactory::getDate()->toFormat('%Y_%m_%d').'.php');
		}

        $this->_catid = $params->get('catid', 0);
        $this->_id = $params->get('id', JRequest::getVar('id', 0, '', 'int')); 

        $this->_id_perso = '';
		$this->_total   = null; 
        $this->_result  = null; 
        $this->_result2 = null; 
        $this->_result_personnalisation = null; 
        $this->_num_marqueurs = 0;

        JHTML::_( 'behavior .mootools' );

	}
	
	function set_id($value)
	{
		$this->_id = $value;
		return true;
	}
	
	function set_ajax($value)
	{
		$this->ajax = $value;
		return true;
	}
	function set_ajax_fields_filters($value)
	{
		$this->ajax_fields_filters[] = $value;
		return true;
	}
	function get_ajax_fields_filters()
	{
		return $this->ajax_fields_filters;
	}
	
	function enfants_catid($id)
	{
		$app = JFactory::getApplication();
		$params = $app->getParams();

		$ids[] = $id;
		if ($params->get('recursive', 1)) {
			//renvoie tous les enfants de $id tri par parent et ordre alphabtique
			$count_ids = count($ids);
			
			for ($i = 0; $i < $count_ids; $i++) {
				if ($this->_enfant($ids[$i]))
					$ids = array_merge(array_slice($ids, 0, $i+1), $this->_enfant($ids[$i]), array_slice($ids, $i+1));
				$count_ids = count($ids);
			}
		}

		return $ids;
	}

	function _enfant($id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT id" .
				"\n FROM #__categories" .
				"\n WHERE parent_id = ".$id .
				"\n AND extension = 'com_gmapfp'" .
				"\n AND published = true" .
				"\n ORDER BY title";
    	$db->setQuery( $query );
		$result = $db->loadResultArray();
		return $result;
	}
	
	function define_gmapfp() 
	{
		$mainframe	= JFactory::getApplication();
		$Itemid	   	= JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
		$key 		= $params->get('gmapfp_google_key');
		$doc		= JFactory::getDocument();
        $lang		= JFactory::getLanguage(); 
        $tag_lang=$lang->getTag();
		if (($tag_lang!='en-AU') AND ($tag_lang!='en-GB') AND ($tag_lang!='pt-BR') AND ($tag_lang!='pt-PT') AND ($tag_lang!='zh-CN') AND ($tag_lang!='zh-TW'))
			{$tag_lang=(substr($lang->getTag(),0,2)); };
		$Base_URL	= JURI::base();
        
        //Insertion des enttes GMapFP si non dj fait.
        if (!defined( '_JOS_GMAPFP_CSS' ))
        {
            /** verifi que la fonction n'est dfini qu'une faois */
            define( '_JOS_GMAPFP_CSS', 1 );
    
            $doc->addStyleSheet( $Base_URL.'components/com_gmapfp/views/gmapfp/gmapfp.css'); 
        }
        
        if (!defined( '_JOS_GMAPFP_LIGHTBOX' ))
        {
            /** verifi que la fonction n'est dfini qu'une faois */
            define( '_JOS_GMAPFP_LIGHTBOX', 1 );    
            
            $doc->addStyleSheet( $Base_URL.'components/com_gmapfp/floatbox/floatbox.css');
            $doc->addScript( $Base_URL.'components/com_gmapfp/floatbox/floatbox.js');
        }
        
        if (!defined( '_JOS_GMAPFP_APIV3' ))
        {
            /** verifi que la fonction n'est dfini qu'une faois */
            define( '_JOS_GMAPFP_APIV3', 1 );
			//&region=GB //pour ameliorer la zone de recherche d'une adresse
			$librarie = array();
			if ($params->get('gmapfp_auto_complete', 1)) 	$librarie[] = 'places';
			if ($params->get('gmapfp_plus_info', 1) or $params->get('gmapfp_enable_pano_photos', 1)) 		$librarie[] = 'panoramio';
			if ($params->get('gmapfp_plus_info', 1) or $params->get('gmapfp_enable_weather', 1)) 		$librarie[] = 'weather';
			$libraries= "";
			if (count($librarie) > 0) {
				$libraries = '&libraries=';
				$libraries .= implode(',', $librarie);
			}
			$http = substr($Base_URL, 0, strpos($Base_URL, '://'));
            $doc->setMetaData( "viewport", "initial-scale=1.0, user-scalable=no");
            $doc->addScript( $http.'://maps.googleapis.com/maps/api/js?language='.$tag_lang.'&key='.$key.$libraries);
            $doc->addScript( $Base_URL.'components/com_gmapfp/libraries/map.js');

			//clustering
			if ($params->get('gmapfp_clustering', 1)) {
				$doc->addScriptDeclaration( "var base_url_gmapfp = '".substr($Base_URL,0,-1)."/images/gmapfp/markerclusterer/';"."\n");
				$doc->addScript( $Base_URL.'components/com_gmapfp/libraries/markerclusterer.js', 'text/javascript', true);
				$doc->addScript( $Base_URL.'components/com_gmapfp/libraries/style_clusters.js', 'text/javascript', true);
			}

			//ajax
			if ($this->ajax) {
				$recentre = '';
				if ($params->get('gmapfp_ajax_recentre', 0)) $recentre = 'bounds_GMapFP = new google.maps.LatLngBounds();';
				$doc->addCustomTag( '<script type="text/javascript">
				
				var GMapFP_Request_Variable = new Array();
				var myRequest = false;
				var gmapfp_filtres;
				var gmapfp_filtres_list;
				var gmapfp_reset_all_filters = false;

				function displayAjax(myURL) {
					 // Clear myRequest
					 myRequest = false;
					 // For browsers: Safari, Firefox, etc. use one XML model
					 if (window.XMLHttpRequest) {
						  myRequest = new XMLHttpRequest();
						  if (myRequest.overrideMimeType) {
							   myRequest.overrideMimeType(\'text/xml\');
						  }
					 } else if (window.ActiveXObject) {
						  // For browsers: IE, version 6 and before, use another model
						  try {
							   myRequest = new
									ActiveXObject("Msxml2.XMLHTTP");
						  } catch (e) {
							   try {
									myRequest = new
										 ActiveXObject("Microsoft.XMLHTTP");
							   } catch (e) {}
						  }
					 }
					 // Make sure the request object is valid
					 if (!myRequest) {
						  alert(\'Error: Cannot create XMLHTTP object\');
						  return false;
					 }
					 
					 // Link to display function activated when result returned
					 myRequest.onreadystatechange = displayReturn;
					 // Open the URL request
					 myRequest.open(\'GET\', myURL, true);
					 // Send request
					 myRequest.send(null);
				}

				function displayReturn() {
					 // Check to make sure result came through, 4=complete
					 if (myRequest.readyState == 4) {
						  // Check HTTP status code
						  if (myRequest.status == 200) {
							   // Display the responseText
								result = eval(\'(\'+myRequest.responseText+\')\');
								places = result[0];
								gmapfp_filtres  = result[1];
								if (gmapfp_filtres) gmapfp_filtres_list = result[2];
								if (places[0]) {
									document.getElementById("aucune_info").style.display = \'none\';
								} else {
									document.getElementById("aucune_info").style.display = \'block\';
								}
								marker_precedent = 0;
								infowindow = new Array();
								'.$recentre.'
								marker = new Array();
								if (gmapfp_update_select_of_filters()) gmapfp_update_select_of_filters();
								initialise_gmapfp();
								document.body.style.cursor  = "default";
								if (gmapfp_reset_all_filters) GMapFP_reset_filters_contenu();
								if (GMapFP_init_fieds_direction) GMapFP_init_fieds_direction();
								GMapFP_disable_filter(false);
						  } else {
							   alert(\'There was a problem with the request.\');
						  }
					 }
				}
				
				
				</script>');
			}
			if ($params->get('gmapfp_geolocalisation', 1)) 	{
				$geo_bp = '';
				$doc->addScript( $Base_URL.'components/com_gmapfp/libraries/geometa.js');
				if ($params->get('gmapfp_geolocalisation_bp', 1))
					$geo_bp = '
						function GMapFP_Geolocal(num) {
							if (canPrepareGeolocation) {
								document.getElementById("info_geolocalisation" + num).style.display = "block";
								canPrepareGeolocation = false;
								prepareGeolocation();
								doGeolocation();
							}
						}
					';
				$doc->addCustomTag( '<script type="text/javascript"> 
					var GMapFP_num = new Array(); 
					var GMapFP_active_map = new Array(); 
					var GMapFP_active_bounds = new Array(); 
					var canPrepareGeolocation = true;
					'.$geo_bp.'
				</script>');
				$doc->addCustomTag( '<script type="text/javascript">
					  function positionError(err) {
						var msg;
						switch(err.code) {
						  case err.UNKNOWN_ERROR:
							msg = "'.JText::_('GMAPFP_GEOLOCAL_ENABLE_FIND').'";
							break;
						  case err.PERMISSION_DENINED:
							msg = "'.JText::_('GMAPFP_GEOLOCAL_PERMISSION_DENIED').'";
							break;
						  case err.POSITION_UNAVAILABLE:
							msg = "'.JText::_('GMAPFP_GEOLOCAL_UNKNOWN').'";
							break;
						  case err.BREAK:
							msg = "'.JText::_('GMAPFP_GEOLOCAL_ATTEMPT_FIND').'";
							break;
						  default:
							msg = "'.JText::_('GMAPFP_GEOLOCAL_NOT_SUPPORTED').'";
						}
						for (i = 0; i <= GMapFP_num.length - 1; i++) {
							document.getElementById(\'info_geolocalisation\' + GMapFP_num).innerHTML = msg;
						}
					  }

					  function positionSuccess(position) {
						// Centre the map on the new location
						var coords = position.coords || position.coordinate || position;
						var latLng = new google.maps.LatLng(coords.latitude, coords.longitude);
						var markerTitle = \''.JText::_('GMAPFP_GEOLOCAL_WHY_THERE').'\';
						
						for (i = 0; i <= GMapFP_num.length - 1; i++) {
							document.getElementById(\'info_geolocalisation\' + GMapFP_num[i]).innerHTML = \''.JText::_('GMAPFP_GEOLOCAL_LOOKING_FOR').' <strong>\' +
								coords.latitude + \', \' + coords.longitude + \'</strong>...\';
							if (document.getElementById(\'select_from\' + GMapFP_num[i])) {
								//document.getElementById(\'select_from\' + GMapFP_num[i]).options[document.getElementById(\'select_from\' + GMapFP_num[i]).options.length] = new Option(\''.JText::_('GMAPFP_GEOLOCAL_MY_POSITION').'\', coords.latitude + "," + coords.longitude + ",0");
							}
							if (!geoloca_ajout_otpion) {
								geoloca_ajout_otpion = true;
								eval(\'document.getElementById("select_from\' + GMapFP_num[i] + \'").remove(0);\');
								coordonnees = coords.latitude + "," + coords.longitude + ",0";
								eval(\'$$("#select_from\' + GMapFP_num[i] + \'").grab(new Option("'.JText::_('GMAPFP_GEOLOCAL_MY_POSITION').'", coordonnees), "top");\');
							}
						}

						// And reverse geocode.
						(new google.maps.Geocoder()).geocode({latLng: latLng}, function(resp) {
							  var place = "'.JText::_('GMAPFP_GEOLOCAL_SOMEWHERE').'";
							  if (resp[0]) {
								  var bits = [];
								  for (var i = 0, I = resp[0].address_components.length; i < I; ++i) {
									  var component = resp[0].address_components[i];
									  if (contains(component.types, \'political\')) {
										  bits.push(\'<strong>\' + component.long_name + \'</strong>\');
										}
									}
									if (bits.length) {
										place = bits.join(\' > \');
									}
									markerTitle = "\'" + resp[0].formatted_address + "\'";
								}
								for (i = 0; i <= GMapFP_num.length - 1; i++) {
									document.getElementById(\'info_geolocalisation\' + GMapFP_num[i]).innerHTML = \''.JText::_('GMAPFP_GEOLOCAL_YOU_ARE').'\' + place;
								}
							for (i = 0; i <= GMapFP_num.length - 1; i++) {
								myCarteGMapFP = GMapFP_active_map[i];
								myboundsGMapFP = GMapFP_active_bounds[i];
								//myCarteGMapFP.setCenter(latLng);
								myboundsGMapFP.extend(latLng);
								myCarteGMapFP.fitBounds(myboundsGMapFP);
								var image_marker = new google.maps.MarkerImage(
									"'.JURI::root().'images/gmapfp/marqueurs/cible.png",
									new google.maps.Size(32, 32),
									new google.maps.Point(0,0),
									new google.maps.Point(16, 16)
								);
								var marker = new google.maps.Marker({
									map: myCarteGMapFP,
									position: latLng,
									title: markerTitle,
									icon: image_marker
								});
							}
						});
					  }
					
				</script>');

			}
        }
    }

    function hit()
    {
		$mainframe = JFactory::getApplication(); 

        if ($this->_id)
        {
            $article =  $this->getTable('GMapFP', 'GMapFPTable');
            $article->hit($this->_id);
            return true;
        }
        return false;
    }

    function getCustom()
    {
        $query = 'SELECT id, nom' .
                ' FROM #__gmapfp_params_custom_fields';
        $results = $this->_getList( $query );
        return $results;
    }
    
    function getClassements($cat)
    {
        $db = JFactory::getDBO();
        $query = ' SELECT id, nom, img' .
                ' FROM #__gmapfp_classements'.
				' WHERE published = 1'.
				' AND cat = '.$cat.
				' ORDER BY ordering';
        $db->setQuery( $query );
        $results = $db->loadObjectList('id');
        return $results;
    }
    
	function getDataFilterList($search_module = false)
	{
		if ($search_module or empty($this->DataFilterList)) {
			$mainframe	 = JFactory::getApplication(); 
			$params		= clone($mainframe->getParams('com_gmapfp'));
			$db 		= JFactory::getDBO();
			$wheres 	= array ();
			$now    = $mainframe->get('requestTime');
			$nullDate = $db->getNullDate();

			//filtre par langue
			$tag = JFactory::getLanguage()->getTag();
			$join = '';
			$case = '';
			$parametres = ', a.parametres, a.nom as label, a.filtre_label as filtre_label';
			if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='(c.langue = ' . $db->Quote($tag).' OR c.langue IS NULL)';
				$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
				$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as label, '.
					' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres, '.
					' CASE WHEN CHAR_LENGTH(c.filtre_label) THEN c.filtre_label ELSE a.filtre_label END as filtre_label ';
				$parametres = '';
			}
			
			// Filter by access level.
				$user	= JFactory::getUser();
				$groups	= implode(',', $user->getAuthorisedViewLevels());
				$wheres[] = '(a.access IN ('.$groups.') or (a.access = ""))';
			//}
			
			$wheres[] = 'a.published = 1';
			$wheres[] = 'a.filtrer >= 1';
			
			//ne garde que les champs pouvant tre filtr
			$where_ors[] = 'a.type = 0';
			$where_ors[] = 'a.type = 3';
			$where_ors[] = 'a.type = 4';
			$where_ors[] = 'a.type = 5';
			$where_ors[] = 'a.type = 6';
			$wheres[] = '('.implode( '  OR ', $where_ors ).')';

			//filtre par catgories
			if ($filtre = $params->get('catid', '')) {
				$wheres[] = '((a.for_cat = 1 AND (a.catid LIKE "'.$filtre.',%"'.' OR a.catid LIKE "%,'.$filtre.',%"'.' OR a.catid LIKE "%,'.$filtre.'"'.' OR a.catid = "'.$filtre.'")) OR a.for_cat = 0)';
				unset ($filtre);
			}

			//fait la liste des types prrenseigns
			$query = ' SELECT a.id, a.nom, a.alias, a.type, a.filtrer '.$parametres.
					$case.
					' FROM #__gmapfp_extension_type as a'.
					$join.
					' WHERE ' . implode( '  AND ', $wheres ).
					' ORDER BY a.ordering';


			$db->setQuery( $query );
			$results = $db->loadObjectList();

			// n'affiche que les valeurs utilises dans la table principale
			$wheres = array();
			$wheres[] = 'a.published = 1';
			$wheres[] = 'c.published = 1';
			
			// Filter by access level.
				$user	= JFactory::getUser();
				$groups	= implode(',', $user->getAuthorisedViewLevels());
				$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
				$wheres[] ='(c.access IN ('.$groups.') or (c.access = ""))';
			//}

			$wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
			$wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

			// Filter by language
			if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
				$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
				$wheres[] ='c.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
			}

			if (!$search_module && $this->_catid) {
				$_catids = $this->enfants_catid($this->_catid);
				foreach ($_catids as $_catid)
				{
					$wheresOr[] = 'a.catid = '.$_catid.'';
				}
				$wheres[] = '('.implode( "\n OR ", $wheresOr).')';
			};
			
			foreach ($results as $key => $result) {
				$old_parameters = explode("\r\n", $result->parametres);
				$query = ' SELECT DISTINCT field_'.$result->id.
					' FROM #__gmapfp as a'.
					' LEFT OUTER JOIN #__categories AS c on a.catid = c.id'.
					' WHERE '.implode( '  AND ', $wheres );
				$db->setQuery( $query );
				$field_datas = $db->loadObjectList();
			
				$values = array();
				foreach ($field_datas as $field) {
					$temps = 'field_'.$result->id;
					if (trim($field->$temps, " \t\n\r\0\x0B") != '')
						$values = array_merge($values, explode("\r\n",$field->$temps));
				}
				unset ($temps, $field_datas);
				$values = array_unique($values);

				$parametres = array();
				foreach ($values as $value) {
					if ($value != '')
						foreach ( $old_parameters as $old_parameter ) {
							if ( strpos( $old_parameter, $value.'::') ===0 ) {
								$parametres[] = $old_parameter;
							}
						}
				}
				$results[$key]->parametres = implode("\r\n",$parametres);
				unset($values, $value);
			}
			if (!$search_module) $this->DataFilterList = $results;
			return $results;
		} else
			return $this->DataFilterList;
	}

	/* $hide contient les nom des champs  ne pas intgrer*/
	function getFilterList($option, $Itemid, $hide=array(), $only_array=false)
	{
		$mainframe	= JFactory::getApplication();
        $config		= clone($mainframe->getParams('com_gmapfp'));
		$lists		= array ();
		$search		= array ();
        $db = JFactory::getDBO();

		if ($this->ajax) $action = 'GMapFP_Ajax_Request_Filter(this);'; else $action = 'form.submit();';
		
		$results = '';
		if (!in_array('utilisateur', $hide))
			$results = $this->getDataFilterList();

		if ($results) {
			foreach ($results as $result) {
				switch ($result->type) {
					case 3:
					case 4:
					case 5:
					case 6:
						$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'string' );
						if  ($result->filtrer == 1) {
							$valeurs = array();
								$cn = 0;
								$params = explode("\r\n", $result->parametres);
								foreach($params as $param) {
									$cn++;
									$valeurs[iconv('UTF-8', 'ASCII//TRANSLIT//IGNORE', substr(strstr($param, '::', 0),2))] = JHTML::_('select.option', strstr($param, '::', 1), substr(strstr($param, '::', 0),2) );
								}
								ksort($valeurs);
								array_unshift($valeurs, JHTML::_('select.option', '', '-- '.$result->filtre_label.' --' ));
							if ($only_array) {
								$tmp_list2 = array();
								foreach ($valeurs as $tmp_list) {
									$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
								}
								$lists['_field_'.$result->id] = '['.implode(', ', $tmp_list2).']';
								unset($tmp_list, $tmp_list2, $valeurs);
							}else
							if ($cn>1) {
								$lists['_field_'.$result->id] = JHTML::_('select.genericlist', $valeurs, 'filtre_field_'.$result->id, 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtre );
							}
						} else {
							$cn = 0;
							$MonTableau = "";
							$MonTableau2 = "";
							$params = explode("\r\n", $result->parametres);
							foreach($params as $param) {
								//die(print_r($param));
								$MonTableau .= "myArray".$result->id."[".$cn."] = '".str_replace("'", "\'", $param)."';"."\r\n";
								$MonTableau2 .= "myArrayResult".$result->id."[".$cn."] = '".($cn + 1)."';"."\r\n";
								$cn++;
							}
							$ma_list = '<div onkeydown="return moveSelection'.$result->id.'()">';
							$ma_list .= "<label>".$result->filtre_label."</label><br />\r\n";
							$old_valeur = '';
							if ($filtre) $old_valeur = $params[$filtre - 1];
							$ma_list .= '<input type="text" autocomplete="off" id="text_field_'.$result->id.'" onkeyup="window.setTimeout(\'refreshList'.$result->id.'();\', 10); return getGMapFPEnterKey'.$result->id.'()" onblur="getGMapFPValueKey'.$result->id.'()" value="'.$old_valeur.'"/>'."\r\n";
							$ma_list .= '<div id="liste'.$result->id.'" class="gmapfp_list_intel"></div>'."\r\n";
							$ma_list .= '<input type="hidden" name="filtre_field_'.$result->id.'" id="filtre_field_'.$result->id.'" value="'.$filtre.'"/>'."\r\n";
							$ma_list .= '<script type="text/javascript">
								 <!--
									var selIndex'.$result->id.' = 0;
									var nbMatch'.$result->id.' = 0;
									var myArray'.$result->id.' = new Array();
									var myArrayResult'.$result->id.' = new Array();
									var content'.$result->id.' = "";
									var old'.$result->id.' = "";
									var old_filtre'.$result->id.' = "'.$old_valeur.'";
								';
							$ma_list .= $MonTableau;
							$ma_list .= $MonTableau2;
							unset ($ma_list2);
							$ma_list .= " 	function fillInput".$result->id."(i)
 	{
   document.getElementById('text_field_".$result->id."').value = myArray".$result->id."[i];
   document.getElementById('filtre_field_".$result->id."').value = myArrayResult".$result->id."[i];
   document.getElementById('liste".$result->id."').style.display= 'none';
   document.getElementById('text_field_".$result->id."').focus();
			document.adminForm_GMapFP_filtre.submit();
 	}
 	function refreshList".$result->id."()
 	{
   if(document.getElementById('text_field_".$result->id."').value != old".$result->id.")
   {
   	old".$result->id."=document.getElementById('text_field_".$result->id."').value;
   document.getElementById('filtre_field_".$result->id."').value = '';
   	document.getElementById('liste".$result->id."').innerHTML = '';
   	if (document.getElementById('text_field_".$result->id."').value.length > 0)
   	{
     nbMatch".$result->id." = 0;
     content".$result->id."='';
     for (var i=0; i < myArray".$result->id.".length; i++)
     {
     	if (myArray".$result->id."[i].slice(0, document.getElementById('text_field_".$result->id."').value.length).toUpperCase() == document.getElementById('text_field_".$result->id."').value.toUpperCase())
     	{
       nbMatch".$result->id."++;
       content".$result->id." += '<div name=\"' + myArrayResult".$result->id."[i] + '\" id=\"gmapfp_list".$result->id."_index' + nbMatch".$result->id." + '\" class=\"result\" onclick=\"fillInput".$result->id."(' + i + ')\">' + myArray".$result->id."[i] + '</div>';
     	}
     }
     if (nbMatch".$result->id.")
     {
     	document.getElementById('liste".$result->id."').innerHTML = content".$result->id.";
     	document.getElementById('liste".$result->id."').style.display = 'block';
     	selIndex".$result->id."=0;
     }
     else
     	document.getElementById('liste".$result->id."').style.display = 'none';
   	}
   	else
   	{
     document.getElementById('liste".$result->id."').style.display = 'none';
   	}
   }
 	}
 	function moveSelection".$result->id."()
 	{
   if (event.keyCode == 40)
   {
   	if (selIndex".$result->id." > 0 && selIndex".$result->id." < nbMatch".$result->id.")
   	{
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_nofocus ';
   	}
   	if (selIndex".$result->id." < nbMatch".$result->id.")
   	{
     selIndex".$result->id."++;
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_focus ';
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").focus();
   	}
   	return false;
   }
   else if (event.keyCode == 38)
   {
   	if (selIndex".$result->id." > 1)
   	{
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_nofocus ';
   	}
   	if (selIndex".$result->id." > 1 && selIndex".$result->id." <= nbMatch".$result->id.")
   	{
     selIndex".$result->id."--;
     document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").className = 'gmapfp_intel_focus ';
   	}
   	return false;
   }
   return getGMapFPEnterKey".$result->id."();
 	}
 	function getGMapFPEnterKey".$result->id."()
 	{
   if (event.keyCode == 13)
   {
   	if (selIndex".$result->id." > 0)
   	{
     document.getElementById('text_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").innerText;
     document.getElementById('filtre_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").getAttribute('name');
     document.getElementById('liste".$result->id."').style.display = 'none';
     old".$result->id."=document.getElementById('gmapfp_list".$result->id."_index' + selIndex".$result->id.").innerText
	 			document.adminForm_GMapFP_filtre.submit();
   	}
   	return false;
   }
   else
   {
   	return true;
   }
 	}
 	function getGMapFPValueKey".$result->id."()
 	{
			setTimeout('getGMapFPValueKeyOK".$result->id."()', 500);
	}
 	function getGMapFPValueKeyOK".$result->id."()
 	{
		if (document.getElementById('liste".$result->id."').style.display == 'block' && document.getElementById('filtre_field_".$result->id."').value == '')
		{
			document.getElementById('filtre_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index1').getAttribute('name');
     		document.getElementById('liste".$result->id."').style.display = 'none';
   			document.getElementById('text_field_".$result->id."').value = document.getElementById('gmapfp_list".$result->id."_index1').innerText;
		}
		if (document.getElementById('text_field_".$result->id."').value == '')
		{
			document.getElementById('filtre_field_".$result->id."').value = '';
		}
		if (document.getElementById('text_field_".$result->id."').value != old_filtre".$result->id.")
		{
		document.adminForm_GMapFP_filtre.submit();
		}
	}

 -->
 </script>
";
							$ma_list .= "</div>"."\r\n";
							$lists['_field_'.$result->id] = $ma_list;
						}
						break;
					case 0:
						//die(print_r($result));
						$valeurs = array();
						$user	= JFactory::getUser();
						$groups	= implode(',', $user->getAuthorisedViewLevels());
        				$params = clone($mainframe->getParams('com_gmapfp'));
						$tag = JFactory::getLanguage()->getTag();
						
						$valeurs[] = JHTML::_('select.option', '', '-- '.$result->filtre_label.' --' );
							$cn = 0;
							$doublon_filtre ='';
							$wheres[] = array();
							$wheres = $this->_getWhereFilters('10');
							$wheres[] ='published = 1';
							$wheres[] ='(access IN ('.$groups.') or (access = ""))';
							if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0))
								$wheres[] ='language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
							if ($this->_catid) {
								$_catids = $this->enfants_catid($this->_catid);
								foreach ($_catids as $_catid)
								{
									$wheresOr[] = 'catid = '.$_catid.'';
								}
								$wheres[] = '('.implode( "\n OR ", $wheresOr).')';
								unset ($wheresOr);
							};
							//die(print_r($wheres));
							$query = ' SELECT id, field_'.$result->id.' as valeur'.
									' FROM #__gmapfp'.
                					' WHERE ' . implode( '  AND ', $wheres ).
									' ORDER BY cast(field_'.$result->id.' AS signed)';
									//' ORDER BY field_'.$result->id;
							$db->setQuery( $query );
							$params = $db->loadObjectList();
							if ($params)
								foreach($params as $param) {
									$mon_texte = trim(mb_strtoupper($param->valeur, 'UTF-8'));
									if ($mon_texte != $doublon_filtre) {
										$cn++;
										$valeurs[] = JHTML::_('select.option', $param->valeur, $param->valeur );
										$doublon_filtre=$mon_texte;
									}
								}
						$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'string' );
						if ($only_array) {
							$tmp_list2 = array();
							foreach ($valeurs as $tmp_list) {
								$tmp_list2[] = "['".$tmp_list->value."', '".str_replace("'", "\'", $tmp_list->text)."']";
							}
							$lists['_field_'.$result->id] = '['.implode(', ', $tmp_list2).']';
							unset($tmp_list, $tmp_list2, $valeurs);
						}else
						if ($cn>1) {
							$lists['_field_'.$result->id] = JHTML::_('select.genericlist', $valeurs, 'filtre_field_'.$result->id, 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtre );
						}
				}
			}
		}

        if (!in_array('classement', $hide) and $config->get('gmapfp_filtre_classement', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_CLASSEMENT_FILTRE' ).' --' );
					$cn = 0;
					foreach($this->getlistclassement(1) as $temp) {
						if ($temp['nom']) {
							$cn++;
							$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
						};
					}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_classement', 'filtre_classement', '', 'string' );

			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_classement'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_classement'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_classement', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('label', $hide) and $config->get('gmapfp_filtre_label', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_LABEL_FILTRE' ).' --' );
					$cn = 0;
					foreach($this->getlistclassement(2) as $temp) {
						if ($temp['nom']) {
							$cn++;
							$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
						};
					}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_label', 'filtre_label', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_label'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_label'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_label', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('picto', $hide) and $config->get('gmapfp_filtre_picto', 1)) {
			$filtreclassements = array();
			$filtreclassements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_PICTO_FILTRE' ).' --' );
					$cn = 0;
					foreach($this->getlistclassement(3) as $temp) {
						if ($temp['nom']) {
							$cn++;
							$filtreclassements[] = JHTML::_('select.option', $temp['id'], $temp['nom'] );
						};
					}
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_picto', 'filtre_picto', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtreclassements as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_picto'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtreclassements);
			}else
			if ($cn>1) {
				$lists['_picto'] = JHTML::_('select.genericlist', $filtreclassements, 'filtre_picto', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtreclassement );
			}
		}

        if (!in_array('ville', $hide) and $config->get('gmapfp_filtre_ville', 1)) {
			$filtrevilles = array();
			$filtrevilles[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistville() as $temp) {
						if ($temp['ville']) {
							$mon_texte = trim(mb_strtoupper($temp['ville'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtrevilles[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtreville = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_ville', 'filtre_ville', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrevilles as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_ville'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrevilles);
			}else
			if ($cn>1) {
				$lists['_ville'] = JHTML::_('select.genericlist', $filtrevilles, 'filtre_ville', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtreville );
			}
		}

        if (!in_array('departement', $hide) and $config->get('gmapfp_filtre_departement', 1)) {
			$filtredepartements = array();
			$filtredepartements[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistdepartement() as $temp) {
						if ($temp['departement']) {
							$mon_texte = trim(mb_strtoupper($temp['departement'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtredepartements[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtredepartement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_departement', 'filtre_departement', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtredepartements as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_departement'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtredepartements);
			}else
			if ($cn>1) {
				$lists['_departement'] = JHTML::_('select.genericlist', $filtredepartements, 'filtre_departement', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtredepartement );
			}
		}

        if (!in_array('pays', $hide) and $config->get('gmapfp_filtre_pays', 1)) {
			$filtrepayss = array();
			$filtrepayss[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					foreach($this->getlistpays() as $temp) {
						if ($temp['pay']) {
							$mon_texte = trim(mb_strtoupper($temp['pay'], 'UTF-8'));
							if ($mon_texte!=$doublon_filtre) {
								$cn++;
								$filtrepayss[] = JHTML::_('select.option', $temp['id'], $mon_texte );
								$doublon_filtre=$mon_texte;
							}
						};
					}
			$filtrepays = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_pay', 'filtre_pay', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrepayss as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_pay'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrepayss);
			}else
			if ($cn>1) {
				$lists['_pay'] = JHTML::_('select.genericlist', $filtrepayss, 'filtre_pay', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtrepays );
			}
		}

        if (!in_array('categories', $hide) and $config->get('gmapfp_filtre_categories', 1)) {
			$filtrecategories = array();
			$filtrecategories[] = JHTML::_('select.option', '', '-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --' );
					$cn = 0;
					$doublon_filtre ='';
					if ($this->getlistcategorie()) {
						foreach($this->getlistcategorie() as $temp) {
							if ($temp->title!=$doublon_filtre) {
								$cn++;
								$filtrecategories[] = JHTML::_('select.option', $temp->id, $temp->title );
								$doublon_filtre = $temp->title;
							};
						}
					};
			$filtrecategorie = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_catid', 'filtre_catid', '', 'string' );
			if ($only_array) {
				$tmp_list2 = array();
				foreach ($filtrecategories as $tmp_list) {
					$tmp_list2[] = '['.(int)$tmp_list->value.", '".str_replace("'", "\'", $tmp_list->text)."']";
				}
				$lists['_catid'] = '['.implode(', ', $tmp_list2).']';
				unset($tmp_list, $tmp_list2, $filtrecategories);
			}else
			if ($cn>1) {
				$lists['_catid'] = JHTML::_('select.genericlist', $filtrecategories, 'filtre_catid', 'size="1" class="inputbox" onchange="'.$action.'"', 'value', 'text', $filtrecategorie );
			}
		}

        if (!in_array('search', $hide) and $config->get('gmapfp_filtre_search', 1)) {
			$search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
			$search['search_gmapfp'] = $search_gmapfp;
		}
		return array($lists, $search);
	}
	
    function getChamps($id)
    {
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
        $db = JFactory::getDBO();

 		//filtre par langue
		$mainframe	= JFactory::getApplication();
        $params		= clone($mainframe->getParams('com_gmapfp'));
		$tag = JFactory::getLanguage()->getTag();
		$join = '';
		$case = '';
		$parametres = ', a.parametres, a.nom as label';
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='(c.langue = ' . $db->Quote($tag).' OR c.langue IS NULL)';
			$join = ' LEFT OUTER JOIN #__gmapfp_extension_lang AS c on a.id = c.typeid';
			$case = ', CASE WHEN CHAR_LENGTH(c.nom) THEN c.nom ELSE a.nom END as label, '.
                ' CASE WHEN CHAR_LENGTH(c.parametres) THEN c.parametres ELSE a.parametres END as parametres ';
			$parametres = '';
		}
		
		$wheres[] ='a.published = 1';
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

       $db = JFactory::getDBO();
        $query = ' SELECT a.alias, a.description, a.position, a.for_cat, a.catid, a.ordering, a.type, a.view_separator, a.id'.$parametres.
                $case.
                ' FROM #__gmapfp_extension_type as a'.
        		$join.
                ' WHERE ' . implode( '  AND ', $wheres ).
				' ORDER BY a.ordering';
        $db->setQuery( $query );
        $results = $db->loadObjectList('id');
		//die(print_r($query));

		if ($results)
		foreach ($results as $key => $result) {
			$query = ' SELECT id, `field_'.$key.'`, catid'.
					' FROM #__gmapfp'.
					' WHERE id = '.$id;
			$db->setQuery( $query );
			$valeur = $db->loadRow();
			$results[$key]->valeur = '';
			if(!$result->for_cat or in_array($valeur[2], explode(',' ,$result->catid)) )
			switch ($result->type) {
				case 0 :
				case 1 :
				case 2 :
					$results[$key]->valeur = $valeur[1];
					break;
				case 3 :
				case 4 :
				case 5 :
				case 6 :
					$monTableauIndexs = explode("\n", trim($valeur[1]));
					if (count($monTableauIndexs)) {
						$monTableauValeurs = array();
						foreach (explode("\n", $results[$key]->parametres) as $monTableauValeur) {
							$monTableauValeurs[substr($monTableauValeur, 0, strpos($monTableauValeur, '::', 0))] = substr(strstr($monTableauValeur, '::', 0),2);
						}
						$valeur = array();
						foreach ($monTableauIndexs as $monTableauIndex) {
							$monTableauIndex = trim($monTableauIndex);
							if ($monTableauIndex!='' && array_key_exists($monTableauIndex, $monTableauValeurs)) {
								$valeur[] = $monTableauValeurs[$monTableauIndex];
							}
						}
						$results[$key]->valeur = implode("\n", $valeur);
					}
					break;
				case 7 :
				case 8 :
					$results[$key]->valeur = $results[$key]->parametres;
					break;
			}
		}
       return $results;
    }
    
    function _getWhereFilters($param)
    {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params = clone($mainframe->getParams('com_gmapfp'));
		$wheres = array();

		if ($this->ajax and $param == -1) {
			$filtreville = '';
			$filtredepartement = '';
			$filtrepays = '';
			$filtrecategorie = '';
			$where_cats = array();
			if ($this->ajax_fields_filters)
			foreach ($this->ajax_fields_filters as $ajax_filter) {
				//if (substr($ajax_filter, strpos($ajax_filter, '=') + 1) != '0')
					switch (substr($ajax_filter, 0, 3)) {
						case 'vil' :
							$wheres[] = 'a.ville = \''.addslashes($this->_getVilleByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'dep' :
							$wheres[] = 'a.departement = \''.addslashes($this->_getDepartementByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'pay' :
							$wheres[] = 'a.pay = \''.addslashes($this->_getPaysByID(substr($ajax_filter, strpos($ajax_filter, '=') + 1))).'\'';
							break;
						case 'cat' :
							$where_cats[] = 'a.catid = \''.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'\'';
							break;
						case 'cla' :
							$wheres[] = '(a.classements LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.classements LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.classements LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.classements = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
						case 'lab' :
							$wheres[] = '(a.labels LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.labels LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.labels LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.labels = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
						case 'pic' :
							$wheres[] = '(a.pictos LIKE "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.pictos LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.' OR a.pictos LIKE "%,'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).',%"'.' OR a.pictos = "'.substr($ajax_filter, strpos($ajax_filter, '=') + 1).'"'.')';
							break;
					}
			}
			if ($where_cats) $wheres[] = '('.implode(' or ',$where_cats).')';
		} else {
			$filtreville = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_ville', 'filtre_ville', '', 'string' );
			$filtredepartement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_departement', 'filtre_departement', '', 'string' );
			$filtrepays = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_pay', 'filtre_pay', '', 'string' );
			$filtrecategorie = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_catid', 'filtre_catid', '', 'int' );
			$filtreclassement = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_classement', 'filtre_classement', '', 'int' );
			$filtrelabel = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_label', 'filtre_label', '', 'int' );
			$filtrepicto = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_picto', 'filtre_picto', '', 'int' );
        
			if (($filtreville<>'') and ($param != 6))
				$wheres[] = 'a.ville = \''.addslashes($this->_getVilleByID($filtreville)).'\'';
			if (($filtredepartement<>'') and ($param != 7))
				$wheres[] = 'a.departement = \''.addslashes($this->_getDepartementByID($filtredepartement)).'\'';
			if (($filtrepays<>'') and ($param != 8))
				$wheres[] = 'a.pay = \''.addslashes($this->_getPaysByID($filtrepays)).'\'';
			if (($filtrecategorie<>'') and ($param != 9))
				$wheres[] = 'a.catid = \''.$filtrecategorie.'\'';
			if (($filtreclassement<>''))
				$wheres[] = '(a.classements LIKE "'.$filtreclassement.',%"'.' OR a.classements LIKE "%,'.$filtreclassement.'"'.' OR a.classements LIKE "%,'.$filtreclassement.',%"'.' OR a.classements = "'.$filtreclassement.'"'.')';
			if (($filtrelabel<>''))
				$wheres[] = '(a.labels LIKE "'.$filtrelabel.',%"'.' OR a.labels LIKE "%,'.$filtrelabel.'"'.' OR a.labels LIKE "%,'.$filtrelabel.',%"'.' OR a.labels = "'.$filtrelabel.'"'.')';
			if (($filtrepicto<>''))
				$wheres[] = '(a.pictos LIKE "'.$filtrepicto.',%"'.' OR a.pictos LIKE "%,'.$filtrepicto.'"'.' OR a.pictos LIKE "%,'.$filtrepicto.',%"'.' OR a.pictos = "'.$filtrepicto.'"'.')';
		}

		//traitement des filtres customs
		$results = $this->getDataFilterList();
		if ($results)
			foreach ($results as $result) {
				if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'result->id = '.$result->id));
				$filtre = '';
				if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'ajax = '.$this->ajax));
				if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'ajax_fields_filters = '.$this->ajax_fields_filters));
				if ($this->ajax and $this->ajax_fields_filters) {
					foreach ($this->ajax_fields_filters as $ajax_filter) {
				if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'ajax_filter = '.$ajax_filter));
						if (substr($ajax_filter, 0, strpos($ajax_filter, '=')) == 'field_'.$result->id) {
							$filtre = substr($ajax_filter, strpos($ajax_filter, '=') + 1);
							if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'filtre = '.$filtre));
							break;
						}
					}
				} else {
					$filtre = $mainframe->getUserStateFromRequest( $option.$Itemid.'filtre_field_'.$result->id, 'filtre_field_'.$result->id, '', 'string' );
				}
				if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/result','message' => 'filtre = '.$filtre.' / Result->type = '.$result->type));
				if ($filtre <> '') {
					if ($result->type == '0') {
						if ($param != 10) $wheres[] = 'a.field_'.$result->id.' = "'.$filtre.'"';
					} else {
						$wheres[] = '(a.field_'.$result->id.' LIKE "'.$filtre.'\r\n%"'.' OR a.field_'.$result->id.' LIKE "%\n'.$filtre.'\r\n%"'.' OR a.field_'.$result->id.' LIKE "%\r\n'.$filtre.'"'.' OR a.field_'.$result->id.' = "'.$filtre.'"'.')';
					}
				}   
			}
		if ($params->get('gmapfp_log', 0) and $wheres) $this->log_instance->addEntry(array('category' => 'GMapFP:_getWhereFilters/wheres','message' => 'Ajax = '.($this->ajax and $param == -1).' __ '.implode(',', $wheres)));
        //die(print_r($wheres));
		if (@$wheres) {return $wheres;}else{return false;};
    }

    function _getWhereQuery()
    {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $db     = JFactory::getDBO();
        $params = clone($mainframe->getParams('com_gmapfp'));
		$search_gmapfp = '';

		//debug
		if ($params->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places/_getWhereQuery','message' => '$this->ajax = '.$this->ajax));
        //detection de la prsence de JoomFish
        $file = JPATH_ADMINISTRATOR.'/components/com_joomfish/joomfish.php';
        //if(!file_exists($file)) {
        if(true) {
        //Recherche directe dans la base de donne. Pas possible avec JoomFish car traduction faite a la restitution des donnes dans la base.
			if ($this->ajax and $this->ajax_fields_filters) {
				foreach ($this->ajax_fields_filters as $ajax_filter) {
					if (substr($ajax_filter, 0, 6) === 'search') {
						$search_gmapfp = substr($ajax_filter, strpos($ajax_filter, '=') + 1);
						if ($params->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places/_getWhereQuery','message' => 'champ search detect = '.$ajax_filter.' / '.substr($ajax_filter, 0, 6).' / '.$search_gmapfp));
						break;
					}
				}
			} else {
				$search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
			}
			$search_gmapfp = JString::strtolower($search_gmapfp);
            if ($search_gmapfp) {
				$words = explode( ' ', $search_gmapfp );
				$wheres1 = array();
				
				//recherche des champs pesro  utiliser pour la recherche pas mots cls
				$query = 'SELECT id' .
						' FROM #__gmapfp_extension_type' .
						' WHERE recherche = 1';
				$db->setQuery( $query );
				$result_champs_persos = $db->loadObjectList('id');
				
				foreach ($words as $word) {
					$word		= $db->Quote( '%'.$db->getEscaped( $word, true ).'%', false );
					$wheres2 	= array();
					$wheres2[] 	= 'a.nom LIKE '.$word;
					$wheres2[] 	= 'a.introtext LIKE '.$word;
					$wheres2[] 	= 'a.fulltext LIKE '.$word;
					$wheres2[] 	= 'a.adresse LIKE '.$word;
					$wheres2[] 	= 'a.adresse2 LIKE '.$word;
					$wheres2[] 	= 'a.codepostal LIKE '.$word;
					$wheres2[] 	= 'a.ville LIKE '.$word;
					$wheres2[] 	= 'a.departement LIKE '.$word;
					$wheres2[] 	= 'a.pay LIKE '.$word;
					$wheres2[] 	= 'a.horaires_prix LIKE '.$word;
					$wheres2[] 	= 'b.title LIKE '.$word;
					$wheres2[] 	= 'a.metakey LIKE '.$word;
					$wheres2[] 	= 'a.metadesc LIKE '.$word;
					if ($result_champs_persos)
						foreach ($result_champs_persos as $champ_perso => $value) {
							$wheres2[] 	= 'a.field_'.$champ_perso.' LIKE '.$word;
						}
					$wheres1[] 	= implode( ' OR ', $wheres2 );
				}
				$wheres[] = '(' . implode( ') AND (', $wheres1 ) . ')';
            }
        };

        $result = $this->_getWhereFilters(-1);
        if ($result)
            $wheres[] = implode( "\n  AND ", $result);
        if (!empty($wheres)) {return $wheres;}else{return false;};
    }

    function _getQuery()
    {
		$mainframe	= JFactory::getApplication();
		$itemid 	= JRequest::getInt('Itemid', 	0);
        $params		= $mainframe->getParams('com_gmapfp');

        $tri = $params->get('orderby_pri');

		$tag = JFactory::getLanguage()->getTag();

        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();
		$wheres = array();

		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';
        
        switch ($tri) {
        case 'alpha' :
            $order = "\n ORDER BY a.nom";
            break;
        case 'ralpha' :
            $order = "\n ORDER BY a.nom DESC";
            break;
        case 'ville' :
            $order = "\n ORDER BY a.ville, a.nom";
            break;
        case 'rville' :
            $order = "\n ORDER BY a.ville DESC, a.nom DESC";
            break;
        case 'pays' :
            $order = "\n ORDER BY a.pay, a.departement, a.ville, a.nom";
            break;
        case 'rpays' :
            $order = "\n ORDER BY a.pay DESC, a.departement DESC, a.ville DESC, a.nom DESC";
            break;
        case 'paysvilles' :
            $order = "\n ORDER BY a.pay, a.ville, a.nom";
            break;
        case 'rpaysvilles' :
            $order = "\n ORDER BY a.pay DESC, a.ville DESC, a.nom DESC";
            break;
        case 'order' :
            $order = "\n ORDER BY a.ordering";
            break;
        case 'order_by' :
            $order = "\n ORDER BY ".$params->get('gmapfp_order_by', 'a.nom');
            break;
        case 'created_date' :
            $order = "\n ORDER BY a.created, a.nom";
            break;
        case 'published_date' :
            $order = "\n ORDER BY a.publish_up, a.nom";
            break;
        case 'modifed_date' :
            $order = "\n ORDER BY a.modified, a.nom";
            break;
        default :
            $order = "";
            break;
        }

        $select = 'a.*, b.title, b.description as cat_description, b.alias as catalias ,'.
		//ligne spcial JoomFish
				' a.id as key1, b.id as key2, m.id as key3, v.id as key4, c.id as key5,'.
				' a.id as key1, b.id as key2, m.id as key3, '.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, '.
				' v.email as author_email,  v.name as author, '.
				' c.catid as article_id, b.params as cat_params, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug, '.
                ' CONCAT(c.introtext, c.fulltext) as article_text, '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '.
                ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(\':\', b.id, b.alias) ELSE b.id END as catslug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'INNER JOIN #__categories AS b on a.catid = b.id';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c on a.article_id = c.id';
        $joins[] = 'LEFT OUTER JOIN #__users AS v ON v.id = a.created_by';

        $wheres[] = 'a.published = 1';
        $wheres[] = '(m.published = 1 or m.published is NULL)';
        
		// Filter by access level.
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
			$wheres[] ='(b.access IN ('.$groups.') or (b.access = ""))';
		//}

        $wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		// Filter by language
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
			$wheres[] ='b.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'a.catid = '.$_catid.'';
            }
            $wheres[] = '('.implode( "\n OR ", $wheresOr).')';
        };

        $autorise_filtre = true;
		if (!empty($this->_id))
        {
            $wheres[] = 'a.id = '.$this->_id.'';
        	$autorise_filtre = false; //si affichage d'un id de place demander, n'active pas les filtre car demande module ou autre.
        };

        //recupre les infos des filtre si actif 
        if ((($params->get('gmapfp_filtre')==1) and $autorise_filtre) or $this->ajax) {
			$result = $this->_getWhereQuery();
            if ($result)
                $wheres[] = implode( "\n  AND ", $result);
        }

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres ).
                $order;
// die(print_r($query));
        return $query;
    }

    function getQuery_Cat_Displayed()
    {
		$mainframe = JFactory::getApplication(); 
        $params = clone($mainframe->getParams('com_gmapfp'));
		$tag 	= JFactory::getLanguage()->getTag();
        $tri = $params->get('orderby_pri');

        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
		$wheres[] ='(b.access IN ('.$groups.') or (b.access = ""))';
        
		// Filter by language
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
			$wheres[] ='b.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}
        
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $order = "\n ORDER BY b.title ";

        $select = 'b.id, m.url as m_url, b.alias as catalias, b.title, '.
                  'b.params as cat_params ';
		$from   = '#__gmapfp AS a';
        $joins[] = 'INNER JOIN #__categories AS b on a.catid = b.id';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';

        $wheres[] = 'a.published = 1';
        
        $wheres[] = '( a.publish_up = "" OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = "" OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'a.catid = '.$_catid.'';
            }
            $wheres[] = '('.implode( "\n OR ", $wheresOr).')';
        };

        if (!empty($this->_id))
        {
            $wheres[] = 'a.id = '.$this->_id.'';
        };

        //recupre les infos des filtre si actif 
        if ($params->get('gmapfp_filtre')==1) {
            $result = $this->_getWhereQuery();
            if ($result)
                $wheres[] = implode( "\n  AND ", $result);
        }

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres ).
				"\n GROUP BY b.title".
                $order;

        return $this->_getList( $query );
    }
	
    function getCats_Items()
	{
		if(!count($this->_cat_items))
		{
			$app = JFactory::getApplication();
			$menu = $app->getMenu();
			$active = $menu->getActive();
			$params = new JRegistry();
			if($active)
			{
				$params->loadString($active->params);
			}

			$options = array();
			$options['countItems'] = 0;
			$categories = JCategories::getInstance('GMapFP', $options);
			$this->_cat_parent = $categories->get($params->get('catid', 'root'));
			if(is_object($this->_cat_parent))
			{
				$this->_cat_items = $this->_cat_parent->getChildren();
			} else {
				$this->_cat_items = false;
			}
		}

		return $this->_cat_items;
	}

	public function getCats_Parent()
	{
		if(!is_object($this->_cat_parent))
		{
			$this->getCats_Items();
		}
		return $this->_cat_parent;
	}

	function getCatInfos($element, $id)
	{
		$db	= JFactory::getDBO();
		$query = "SELECT ".$element.
				"\n FROM #__categories" .
				"\n WHERE id = ".$id;
    	$db->setQuery( $query );
		$result = $db->loadResultArray();
		return $result;
	}

    function getPersonnalisation($id='')
    {
		if (!empty($id)) {$this->_id_perso = $id;};
        $db = JFactory::getDBO();
        $query = "SELECT *" .
                "\n FROM #__gmapfp_personnalisation" .
                "\n WHERE id = '".$this->_id_perso."'";

        if (empty($this->_result_personnalisation))
        {
            $db->setQuery( $query );
            $this->_result_personnalisation = $db->loadObject();
        }
        
		return @$this->_result_personnalisation;
    }
    
    function getTotal()
    {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');

        // Lets load the content if it doesn't already exist
        if (empty($this->_total))
        {
			$query = $this->_getQuery();

            //detection de la prsence de JoomFish
            $file = JPATH_ADMINISTRATOR.'/components/com_joomfish/joomfish.php';
            if(file_exists($file)) {
            //Recherche directe dans le resultat de la requete pour JoomFish car traduction faite a la restitution des donnes dans la base.
                $this->_total = $this->_getList( $query );
                $search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
                $search_gmapfp = JString::strtolower($search_gmapfp);
                if ($search_gmapfp) {
                    $Resultat_filtre = 0;
                    foreach ($this->_total as $result) {
                        if ((!(strpos(JString::strtolower($result->nom),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->introtext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->fulltext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse2),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->ville),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->departement),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->pay),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->email),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->web),$search_gmapfp)===false))) {
                            $Resultat_filtre ++;
                        }
                    };
                    $this->_total=$Resultat_filtre;
                }else{
                    $this->_total = $this->_getListCount($query);
                };
            }else{
                $this->_total = $this->_getListCount($query);
            };
        }
        return $this->_total;
    }
    
    function _getQueryPlugin( $options, $where_field='' )
    {
		$mainframe 	= JFactory::getApplication(); 
        $db         = JFactory::getDBO();
        $now    	= $mainframe->get('requestTime');
        $nullDate 	= $db->getNullDate();

        foreach ($options as $option)
        {
            $wheresOr[]= 'a.id = \''.$option.'\'';
        }
        $wheres[]="(".implode( "\n OR ", $wheresOr ).")";
		if (!empty($where_field)) {$wheres[]=$where_field;}

        $select = 'a.*, b.title, b.description as cat_description, b.alias as catalias ,'.
		//ligne spcial JoomFish
				' a.id as key1, b.id as key2, m.id as key3, v.id as key4, c.id as key5,'.
				' a.id as key1, b.id as key2, m.id as key3, '.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, '.
				' v.email as author_email,  v.name as author, '.
				' c.catid as article_id, b.params as cat_params, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug, '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '.
                ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(\':\', b.id, b.alias) ELSE b.id END as catslug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'INNER JOIN #__categories AS b on a.catid = b.id';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c on a.article_id = c.id';
        $joins[] = 'LEFT OUTER JOIN #__users AS v ON v.id = a.created';

        $wheres[] = 'a.published = 1';
        $wheres[] = '(m.published = 1 or m.published is NULL)';
        
		// Filter by access level.
		//if ($access = $this->getState('filter.access')) {
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
			$wheres[] ='(b.access IN ('.$groups.') or (b.access = ""))';
		//}

        $wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres );
        return $query;
    }
    
    function _getQueryPluginCatid( $options, $where_field='' )
    {
        $db         = JFactory::getDBO();

        foreach ($options as $option)
        {
			$wheresOr[]= 'a.catid = \''.$option.'\'';
        }
        $wheres[]="(".implode( "\n OR ", $wheresOr ).")";
		if (!empty($where_field)) {$wheres[]=$where_field;}

        $select = 'a.*, b.title, c.catid as article_id, b.alias as catalias,'.
		//ligne spcial JoomFish
				' a.id as key1, b.id as key2, m.id as key3, c.id as key5,'.
                ' m.url as m_url, m.marker_width as m_width, m.marker_height as m_height, m.centre_x as m_x, m.centre_y as m_y, m.url_shadow as m_shadow, m.shadow_width as m_s_width, m.shadow_height as m_s_height, b.params as cat_params, '.
                ' (SELECT d.alias FROM #__categories AS d WHERE d.id=c.catid) as article_alias , '.
                ' (SELECT d.id FROM #__categories AS d WHERE d.id=c.catid) as article_id , '.
                ' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(\':\', a.id, a.alias) ELSE a.id END as slug, '.
                ' CASE WHEN CHAR_LENGTH(b.alias) THEN CONCAT_WS(\':\', b.id, b.alias) ELSE b.id END as catslug, '.
                ' CASE WHEN CHAR_LENGTH(c.alias) THEN CONCAT_WS(\':\', c.id, c.alias) ELSE c.id END as article_slug ';
        $from   = '#__gmapfp AS a';
        $joins[] = 'INNER JOIN #__categories AS b on a.catid = b.id';
        $joins[] = 'LEFT OUTER JOIN #__gmapfp_marqueurs AS m on a.index_marqueur = m.id';
        $joins[] = 'LEFT OUTER JOIN #__content AS c on a.article_id = c.id';

        $wheres[] = 'a.published = 1';

		// Filter by access level.
		//if ($access = $this->getState('filter.access')) {
			$user	= JFactory::getUser();
			$groups	= implode(',', $user->getAuthorisedViewLevels());
			$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';
			$wheres[] ='(b.access IN ('.$groups.') or (b.access = ""))';
		//}

        $query = "SELECT " . $select .
                "\n FROM " . $from .
                "\n " . implode ( ' ', $joins ) .
                "\n WHERE " . implode( "\n  AND ", $wheres );

        return $query;
    }
    
    function getGMapFPList( $options=array() )
    {
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $db        = JFactory::getDBO();

        if (empty($this->_result2))
        {
            $query  = $this->_getQuery();
			$this->_result2 = $this->_getList( $query );
			// die(print_r($query));

            //detection de la prsence de JoomFish
            $file = JPATH_ADMINISTRATOR.'/components/com_joomfish/joomfish.php';
            if(file_exists($file)) {
            //Recherche directe dans le resultat de la requete pour JoomFish car traduction faite a la restitution des donnes dans la base.
                $search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
                $search_gmapfp = JString::strtolower($search_gmapfp);
                if ($search_gmapfp) {
                    $Resultat_filtre = array();
                    foreach ($this->_result2 as $result) {
                        if ((!(strpos(JString::strtolower($result->nom),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->introtext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->fulltext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse2),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->ville),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->departement),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->pay),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->email),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->web),$search_gmapfp)===false))) {
                            $Resultat_filtre[] = $result;
                        }
                    };
                    $this->_result2=$Resultat_filtre;
                }
            };
        }
        return @$this->_result2;
    }
    
    function getView()
    {
		$mainframe	= JFactory::getApplication(); 
		$option		= JRequest::getCmd('option'); 
		$map_layout = JRequest::getCmd('layout', ''); 
		$flag		= JRequest::getInt('flag', '');
		$Itemid		= JRequest::getInt('Itemid');
		$doc		= JFactory::getDocument();


        if (empty($this->_result)) {
            $query  = $this->_getQuery();
            $this->_result = $this->_getList( $query );
            
            //detection de la prsence de JoomFish
            $file = JPATH_ADMINISTRATOR.'/components/com_joomfish/joomfish.php';
            if(file_exists($file)) {
            //Recherche directe dans le resultat de la requete pour JoomFish car traduction faite a la restitution des donnes dans la base.
                $search_gmapfp = $mainframe->getUserStateFromRequest( $option.$Itemid.'search_gmapfp', 'search_gmapfp', '',    'string' );
                $search_gmapfp = JString::strtolower($search_gmapfp);
                if ($search_gmapfp) {
                    $Resultat_filtre = array();
                    foreach ($this->_result as $result) {
                        if ((!(strpos(JString::strtolower($result->nom),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->introtext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->fulltext),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->adresse2),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->ville),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->departement),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->pay),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->email),$search_gmapfp)===false)or!(strpos(JString::strtolower($result->web),$search_gmapfp)===false))) {
                            $Resultat_filtre[] = $result;
                        }
                    };
                    $this->_result=$Resultat_filtre;
				}
            };
        };

		//tri par ordre alphabtique pour la liste itinraire
		$direction = array();
		foreach ($this->_result as $row) {
			if ((real)$row->glat && (real)$row->glng)
				$direction[strtolower($row->nom)] = array((real)$row->glat.','.(real)$row->glng.','.(int)$row->id, $row->nom);
		}
		ksort($direction);

		//optimisation de la taille mmoire
		$aucune_info = true;
		if ($this->_result) $aucune_info = false;
		if ($map_layout == "item_carte" or $flag or $map_layout == "print_article") {
			$map    = $this->getCarte($this->_result, $direction, 0, 0, 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, $aucune_info);
		} else {
			$map    = $this->getCarte('', $direction, 0, 0, 0, '', '', '', '', 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, 0, $aucune_info);
		};

		// ajout du lien de contenu des infos des places pour la carte
		if ($map_layout) $map_layout = '&map_layout='.$map_layout;
		if ($flag) $flag = '&flag='.$flag; else $flag = '';
		if ($id = JRequest::getInt('id', '')) $flag .= '&id='.$id;
		if ($catid = JRequest::getInt('catid', '')) $flag .= '&catid='.$catid;
		$lng = '';
		$tmp = JURI::getInstance();
		$base = $tmp->getHost();
		if (@$_GET['lang'] and $base<>'localhost' and $base<>'127.0.0.1') $lng = '&lang='.$_GET['lang'];
		unset($tmp, $base);
		$link = JRoute::_(JURI::base().'index.php?option=com_gmapfp&view=gmapfp&format=raw&layout=places'.$map_layout.$flag.'&Itemid='.$Itemid.$lng.'&rand='.rand(), false);
		$doc->addScript($link);

        return $map;
    }

    //Integration des donnes du plugin
    function getViewPlugin($ids, $num, $Hmap='0', $Lmap='0', $Zmap='0', $Itin='0', $bar_PSM='0', $bar_z_nav='0', $Ech='0', $click_over='0', $MZoom='0', $ZZoom='0', $map_phy='0', $map_nor='0', $map_sat='0', $map_hyb='0', $map_choix='0', $kml_file='0', $map_earth='0', $map_centre_lng='0', $map_centre_lat='0', $plugcatids='0', $More='0', $map_centre_id='0', $where='', $plus_detail='0')
    {
        //rechercher du centrage d'un id
        if ($map_centre_id!=0) {
            $map_centre_ids[]=$map_centre_id;
            $query  = $this->_getQueryPlugin($map_centre_ids);
            $result = $this->_getList( $query );
            $map_centre_lng = $result[0]->glng;
            $map_centre_lat = $result[0]->glat;
            if ($Zmap==0) {
                $Zmap = $result[0]->gzoom;
            };
        }

        //rechercher des lieux par id
        if ($ids!=0) {
            $query  = $this->_getQueryPlugin($ids, $where);
            $result = $this->_getList( $query );
            foreach($result as $lieu) {
                $rows[] = $lieu;
            };
        }
        //recherche des catgories des groupes de catgories
        if ($plugcatids!=0) {
			$catids = array();
            foreach ($plugcatids as $plugcatid) {
				$catids = array_merge($catids, $this->enfants_catid($plugcatid));
            };
        }else{
            $catids = array();
        };

        //recherche des lieux par catgorie
        if (!empty($catids)) {
            $query  = $this->_getQueryPluginCatid($catids, $where);
            $result = $this->_getList( $query );
            foreach($result as $lieu) {
                $rows[] = $lieu;
            };
        }
        
        //Isolation des id des lieux du plugin
        if (!(@$rows)) {
            $language = JFactory::getLanguage();
            $language->load('com_gmapfp');
            JError::raiseWarning(0, JText::_('GMAPFP_MAUVAIS_ID_PLUGIN'));
            return(JText::_('GMAPFP_MAUVAIS_ID_PLUGIN'));
        }else{
            //tri par ordre alphabtique pour la liste itinraire
			$direction = array();
            foreach ($rows as $row) {
				if ((real)$row->glat && (real)$row->glng)
					$direction[strtolower($row->nom)] = array((real)$row->glat.','.(real)$row->glng.','.(int)$row->id, $row->nom);
			}
			ksort($direction);

			//appel de la carte
			$map    = $this->getCarte($rows, $direction, $map_centre_lat, $map_centre_lng, 1, $num, $Hmap, $Lmap, $Zmap, $Itin, $bar_PSM, $bar_z_nav, $Ech, $click_over, $MZoom, $ZZoom, $map_phy, $map_nor, $map_sat, $map_hyb, $map_choix, $kml_file, $map_earth, $More, false, $plus_detail);
	
			// ajout du lien de contenu des infos des places pour la carte
			$ids_link = '';
			if ($ids) $ids_link = '&map_ids='.implode(',', $ids);
			$catids_link = '';
			if ($catids) $catids_link = '&map_cats='.implode(',', $catids);
			$where_link = '';
			if ($where) $where_link = '&map_where='.$where;
			$click_over_link = '';
			if ($click_over) $click_over_link = '&map_click_over='.$click_over;
			$plus_detail_link = '';
			if ($plus_detail) $plus_detail_link = '&map_plus_detail='.$plus_detail;
			
			$doc	= JFactory::getDocument();
			$doc->addCustomTag( '<script type="text/javascript" src="'.JURI::base().'/index.php?option=com_gmapfp&view=gmapfp&format=raw&layout=places&map_num='.$num.$ids_link.$catids_link.$where_link.$click_over_link.$plus_detail_link.'&rand='.rand().'"></script>');
	
			return $map;
        };
    }
    
    function getCarte ($rows, $direction, $glat_plugin, $glng_plugin, $plugin, $num = '', $Hmap = '', $Lmap = '', $Zmap = '',  $Itin='0', $bar_PSM='0', $bar_z_nav='0', $Ech='0', $event_control='0', $MZoom='0', $ZZoom='0', $map_phy='0', $map_nor='0', $map_sat='0', $map_hyb='0', $map_choix='0', $kml_file='0', $map_earth='0', $More='0', $aucune_info=false, $plus_detail='0')
    {
		$this->define_gmapfp();

		include 'components/com_gmapfp/libraries/map_v3.php';
		return $carte;
    }

	function make_places($num, $values = '')
	{
		$mainframe 	= JFactory::getApplication();
		$config 	= $mainframe->getParams('com_gmapfp');//parametre de l'item
		$itemid 	= JRequest::getInt('Itemid', 0);
		$option		= JRequest::getCMD('option'); 
		$Base_URL	= JURI::base(false);
		$rows		= array();
		
		//debug
		if ($config->get('gmapfp_log', 0) and $values) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places','message' => '$values = '.$values));
		if ($config->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places','message' => '$this->ajax = '.$this->ajax));
		if ($config->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places','message' => '$itemid = '.$itemid));

		//test si plugin
		if ($num) {
			$ids    = explode(',', JRequest::getString('map_ids', '')); 
			$catids = explode(',', JRequest::getString('map_cats', '')); 
			$where	= JRequest::getVar('map_where', ''); 
			$event_control	= JRequest::getInt('map_click_over', ''); 
			$plus_detail	= JRequest::getInt('map_plus_detail', ''); 

			//rechercher des lieux par id
			if ($ids!=0) {
				$query  = $this->_getQueryPlugin($ids, $where);
				$result = $this->_getList( $query );
				foreach($result as $lieu) {
					$rows[] = $lieu;
				};
			}
			//recherche des lieux par catgorie
			if ($catids!=0) {
				$query  = $this->_getQueryPluginCatid($catids, $where);
				$result = $this->_getList( $query );
				foreach($result as $lieu) {
					$rows[] = $lieu;
				};
			}
		} else {
			$this->ajax_fields_filters = '';
			if ($values = substr($values, 1, -1)) { // si ajax
				$values = explode(',', $values);
				foreach ($values as $value) {
					if ($config->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places','message' =>'$value = '.$value.'/'.substr($value, 7)));
					$this->ajax_fields_filters[] = substr($value, 7);
				}
			};

			$query  = $this->_getQuery();
			$rows = $this->_getList( $query );
			//debug
			if ($config->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:make_places','message' =>'$query = '.$query));
		}
		
		// si plugin, utilise les paramtre du plugin si dfini
		if ($num and $event_control!='0') 
			$event_control = $event_control - 1;
		else
			$event_control = $config->get('gmapfp_eventcontrol');
		if ($num and $plus_detail!='0') 
			$plus_detail = $plus_detail - 1;
		else
			$plus_detail = $config->get('gmapfp_plus_detail');

		$_layout 	= JRequest::getVar('map_layout', "", '', 'string');
		$flag       = JRequest::getInt('flag',      ($_layout=="article"));
	
		if (($plus_detail==0)||($flag==1)) {
			$plus_detail = '';
			$read_more = false;
		} else {
			if ($plus_detail==1 || $event_control==1) {
				$plus_detail = '<h4>'.JTEXT::_("GMAPFP_CLIQUER_POUR_ARTICLE").'</h4>';
				$read_more = false;
			} else {
				$plus_detail = '';
				$read_more = true;
			}
		}

		$points = array();
		$cesure = $config->get('gmapfp_taille_bulle_cesure');
		$marqueurs = $this->getmarqueurs();
		foreach($rows as $row){
			// si marqueur de la catgorie, recherche le.
			if (empty($row->m_url)) {
				$marqueur_id = 1;
				if (property_exists(json_decode($row->cat_params), 'default_marqueur_categories'))
					$marqueur_id = json_decode($row->cat_params)->default_marqueur_categories;
				if (is_array($marqueur_id)) $marqueur_id = $marqueur_id[0];
				if (array_key_exists((int)$marqueur_id, $marqueurs)) 
					$marueur_info = $marqueurs[(int)$marqueur_id];
				else
					$marueur_info = $marqueurs[1];
				if ($marueur_info->id) {
					$row->m_url = $marueur_info->url;
					$row->m_height = $marueur_info->marker_height;
					$row->m_width = $marueur_info->marker_width;
					$row->m_x = $marueur_info->centre_x;
					$row->m_y = $marueur_info->centre_y;
					$row->m_shadow = $marueur_info->url_shadow;
					$row->m_s_height = $marueur_info->shadow_height;
					$row->m_s_width = $marueur_info->shadow_width;
				}
			}
			$point = array();
			if (($row->glat<>"")&&($row->glng<>"")) {
				$point[] = $row->id;
				$point[] = $row->glat;
				$point[] = $row->glng;
				$point[] = 1000 + $this->_num_marqueurs;
	
				$image = '';
				if (@$row->img) {
					$image = $Base_URL.substr(COM_GMAPFP_IMAGES_HTTP_RELATIVE, 1).'/thumbsGMap/'.$row->img;
					$image = "<img src='".$image."'>";
				}
				if (@$row->introtext) {
					$intro=trim($row->introtext);
					$intro = str_replace(chr(10), '',$intro);
					$intro = str_replace(chr(13), '<BR />',$intro);
				}else{$intro='';};
				if (@$row->fulltext) {
					$message=trim($row->fulltext);
					$message = str_replace(chr(10), '',$message);
					$message = str_replace(chr(13), '<BR />',$message);
				}else{$message='';};
	
				if ($config->get('gmapfp_html_bubble')){
					$text = addslashes($intro.$message);
				}else{
					$text = strip_tags(addslashes($intro.$message),"<BR>");
				}
	
				$nom  = htmlspecialchars(trim($row->nom));
	
				$link4=substr(trim($row->link),0,4);
				$link5=substr(trim($row->link),0,5);
				$link9=substr(trim($row->link),0,9);
				$linkmap=trim($row->link);
				if ($link4=="www.") {$linkmap="http://".$linkmap;};
						
				if(!class_exists('GMapFPHelperRoute')) require_once (JPATH_SITE . '/components/com_gmapfp/helpers/route.php');
	
				if ((empty($row->link))||($row->link='')) {
					if ($config->get('target')==0) {
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catslug).'&tmpl=component', false);
					}else{
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catslug), false);
					};
					$choix=1;
				} else {
					if (($link5=="http:")||($link4=="www.")||($link9=="index.php")) {
						$map_link=$linkmap;
						if (($link5=="http:")||($link4=="www.")) {$choix=0;}else{$choix=1;};
					} else {
						if(!class_exists('ContentHelperRoute')) require_once (JPATH_SITE . '/components/com_content/helpers/route.php');  
						if ($config->get('target')==0) {
							$map_link=JRoute::_(ContentHelperRoute::getArticleRoute($row->article_slug, $row->article_id.':'.$row->article_alias, 0));
							$map_link .= '?&tmpl=component';
						}else{
							 $map_link=JRoute::_(ContentHelperRoute::getArticleRoute($row->article_slug, $row->article_id.':'.$row->article_alias, 0));
						};
						$choix=1;
					};
				};
				if (@$row->icon) {
					if($config->get('target')==0) {
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catslug).'&tmpl=component&Itemid='.$itemid, false);
					}else{
						$map_link=JRoute::_(GMapFPHelperRoute::getArticleRoute($row->slug, $row->catslug).'&Itemid='.$itemid, false);
					};
				};
				if (empty($row->m_url)) $row->m_url = 'http://www.google.com/mapfiles/marker.png';
	
				$read_more_link = '';
				if ($read_more)
					switch ($config->get('target'))
					{
					case 1:
						// open in parent avec navigation
						$read_more_link="<a href='".$map_link."'  target='_parent'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					case 2:
						// open in nouvelle fentre avec barre de navigation
						$read_more_link="<a href='".$map_link."'  target='_self'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					case 3:
						// open in a popup window
						$read_more_link="<a href=# onclick='window.open(\\\"".$map_link."\\\", \\\"\\\", \\\"toolbar=no,location=no,status=no,menubar=no,scrollbars=yes,resizable=yes,width=".$config->get('gmapfp_largeur_lightbox', 1200).",height=".$config->get('gmapfp_hauteur_lightbox', 800)."\\\")'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					default:
						// open in lightbox
						//$read_more_link="<a class='lightboxgmafp' rev='width:90% height:80% disableScroll:true ' href='".$map_link."'>".JText::_('GMAPFP_READ_MORE')."</a>";
						$read_more_link ="<a href=# onclick='fb.start({ href: \\\"".$map_link."\\\", rev: \\\"width:".$config->get('gmapfp_largeur_lightbox', 1200)." height:".$config->get('gmapfp_hauteur_lightbox', 800)." scrolling:yes innerBorder:1\\\" });'>".JText::_('GMAPFP_READ_MORE')."</a>";
						break;
					}
				
				if ($flag and ($config->get('gmapfp_auto_ouvrir_titre', 1) > 0)) {
					if ($config->get('gmapfp_auto_ouvrir_titre', 1) == 2) {
						if (file_exists('components/com_gmapfp/bubble/bubbleadresseperso_v3.php')) {
							$bubble = include 'components/com_gmapfp/bubble/bubbleadresseperso_v3.php';
						} else {
							$bubble = include 'components/com_gmapfp/bubble/bubbleadresse.php';
						}
					} else {
						if (file_exists('components/com_gmapfp/bubble/bubblenomperso_v3.php')) {
							$bubble = include 'components/com_gmapfp/bubble/bubblenomperso_v3.php';
						} else {
							$bubble = include 'components/com_gmapfp/bubble/bubblenom.php';
						}
					}
				} else {
					switch ($config->get('affichage')) {
						case '0': //Complet
							$bubble = include 'components/com_gmapfp/bubble/bubble0.php';
							break;
						case '1': //Nom, photo, adresse
							$bubble = include 'components/com_gmapfp/bubble/bubble1.php';
							break;
						case '2': //Nom, photo, message
							$bubble = include 'components/com_gmapfp/bubble/bubble2.php';
							break;
						case '3': //Nom
							$bubble = include 'components/com_gmapfp/bubble/bubbledefault.php';
							break;
						default: //autre bulle a partir de V10.82
							if (file_exists('components/com_gmapfp/bubble/bubble'.$config->get('affichage').'.php')) {
								$bubble = include 'components/com_gmapfp/bubble/bubble'.$config->get('affichage').'.php';
							} else {
								$bubble = include 'components/com_gmapfp/bubble/bubbledefault.php';
							}
					}
				};
				$point[] = $bubble;
				$point[] = $map_link;
				$point[] = $choix;
				$point[] = $nom;
				$point[] = $row->catalias;
	
				//dimensionnel marqueur et ombre
				if (empty($row->m_height)) $row->m_height = 34;
				if (empty($row->m_width)) $row->m_width = 20;
				if (empty($row->m_x)) $row->m_x = 34;
				if (empty($row->m_y)) $row->m_y = 10;
				if (empty($row->m_shadow)) $row->m_shadow = $Base_URL.'components/com_gmapfp/images/blank.png';
				if (empty($row->m_s_height)) $row->m_s_height = 37;
				if (empty($row->m_s_width)) $row->m_s_width = 34;
				
				$point[] = array(str_replace ( '../', $Base_URL, $row->m_url), $row->m_width, $row->m_height, $row->m_x, $row->m_y, str_replace ( '../', $Base_URL, $row->m_shadow), $row->m_s_width, $row->m_s_height, 10, 34);
	
				$points[] = $point;
				$this->_num_marqueurs++;
			}
		}
		
		$filtres	= $this->getFilterList($option, $itemid, array(), true);
		
		return array($points, $num, $filtres);
	}

    function getmarqueurs()
    {
        $db     = JFactory::getDBO();

        $wheres[] = 'published = 1';
        $query = 'SELECT *' .
                ' FROM #__gmapfp_marqueurs' .
                ' WHERE ' . implode( '  AND ', $wheres );
    	$db->setQuery( $query );
		return $db->loadObjectList('id');
    }

    function getlistclassement($cat)
    {
        //global $mainframe, $option, $Itemid;
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

        /*if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(6);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);
*/
        $params = clone($mainframe->getParams('com_gmapfp'));

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.filtrable = 1';
        $wheres[] = 'a.cat = '.$cat;
        $wheres[] = 'a.published = 1';

        $query = 'SELECT a.nom, a.id' .
                ' FROM #__gmapfp_classements AS a' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.ordering';
        $results = $this->_getList( $query );
		//die(print_r($query));
        $tries=array();
        foreach ($results as $result) {
            $trie=array();
            $trie['id'] = $result->id;
            $trie['nom'] = $result->nom;
            $tries[]=$trie;
        };
		if ($params->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistclassement('.$cat.')-> query','message' =>$query));
        return $tries;
    }

    function getlistville()
    {
        //global $mainframe, $option, $Itemid;
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(6);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.catid = b.id';

        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'a.catid = '.$_catid.'';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.ville, a.id' .
                ' FROM #__gmapfp AS a, #__categories AS b' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.ville';
        $results = $this->_getList( $query );
		//die(print_r($results));
        $tries=array();
        foreach ($results as $result) {
            $trie=array();
            $trie['id'] = $result->id;
            $trie['ville'] = $result->ville;
            $tries[]=$trie;
        };
		if ($params->get('gmapfp_log', 0)) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> query','message' =>$query));
        return $tries;
    }

    function getlistdepartement()
    {
        //global $mainframe, $option, $Itemid;
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(7);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.catid = b.id';

        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'catid = '.$_catid.'';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.departement, a.id' .
                ' FROM #__gmapfp AS a, #__categories AS b' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.departement';
        $results = $this->_getList( $query );
        $tries=array();
        foreach ($results as $result) {
            $trie=array();
            $trie['id'] = $result->id;
            $trie['departement'] = $result->departement;
            $tries[]=$trie;
        };
        return $tries;
    }

    function getlistpays()
    {
        //global $mainframe, $option, $Itemid;
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(8);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.catid = b.id';

        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up = \'\' OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = \'\' OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'catid = '.$_catid.'';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $query = 'SELECT a.pay, a.id' .
                ' FROM #__gmapfp AS a, #__categories AS b' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY a.pay';
        $results = $this->_getList( $query );
        $tries=array();
        foreach ($results as $result) {
            $trie=array();
            $trie['id'] = $result->id;
            $trie['pay'] = $result->pay;
            $tries[]=$trie;
        };
        return $tries;
    }

    function getlistcategorie()
    {
        //global $mainframe, $option, $Itemid;
		$mainframe = JFactory::getApplication(); 
		$option    = JRequest::getCmd('option'); 
		$Itemid	   = JRequest::getInt('Itemid');
        $params		= clone($mainframe->getParams('com_gmapfp'));
        
		// Filter by language
		$tag = JFactory::getLanguage()->getTag();
        $db     = JFactory::getDBO();
		if ($mainframe->isSite() && $mainframe->getLanguageFilter() && $params->get('gmapfp_compa_trad_joom25', 0)) {
			$wheres[] ='a.language in (' . $db->Quote($tag) . ',' . $db->Quote('*') . ')';
		}

		// Filter by access level.
		$user	= JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(a.access IN ('.$groups.') or (a.access = ""))';

        if($this->ajax) 
			$result = $this->_getWhereFilters(-1);
		else
			$result = $this->_getWhereFilters(9);
		if ($params->get('gmapfp_log', 0) and $result) $this->log_instance->addEntry(array('category' => 'GMapFP:getlistville()-> Ajax','message' =>implode(', ',$result)));

        if ($result)
            $wheres[] = implode( "\n  AND ", $result);

        $params = clone($mainframe->getParams('com_gmapfp'));
		$user_where = $params->get('gmapfp_filtre_sql');
		if (!empty($user_where))
			$wheres[] = '('.$user_where.')';

        $wheres[] = 'a.published = 1';
        $wheres[] = 'a.catid = b.id';
        
        $db     = JFactory::getDBO();
        $now    = $mainframe->get('requestTime');
        $nullDate = $db->getNullDate();
        $wheres[] = '( a.publish_up = "" OR a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )';
        $wheres[] = '( a.publish_down = "" OR a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )';

		if ($this->_catid) {
        	$_catids = $this->enfants_catid($this->_catid);
            foreach ($_catids as $_catid)
            {
                $wheresOr[] = 'b.id = '.$_catid.'';
            }
            $wheres[] = '('.implode( " OR ", $wheresOr).')';
        };

        $user = JFactory::getUser();
		$groups	= implode(',', $user->getAuthorisedViewLevels());
		$wheres[] ='(b.access IN ('.$groups.') or (b.access = ""))';

        $query = 'SELECT b.id, b.title' .
                ' FROM #__gmapfp AS a, #__categories AS b' .
                ' WHERE ' . implode( '  AND ', $wheres ).
                ' ORDER BY b.title';
                //die(print_r($query ));
        $result = $this->_getList( $query );
		return $result;
    }

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getVilleByID($id)
    {
        $db = JFactory::getDBO();
        $query = 'SELECT a.ville' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->ville;
		else return false;
    }

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getDepartementByID($id)
    {
        $db = JFactory::getDBO();
        $query = 'SELECT a.departement' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->departement;
    	else return false;
}

//recherche de la ville correspondant  l'id (pour filtre suite Joom!Fish)
    function _getPaysByID($id)
    {
        $db = JFactory::getDBO();
        $query = 'SELECT a.pay' .
                ' FROM #__gmapfp AS a' .
                ' WHERE id=' . $id;
        $db->setQuery( $query );
        $result = $db->loadObject();
        if ($result)
			return $result->pay;
		else return false;
    }

	public function getCategory($catid=0)
	{
		$mainframe = JFactory::getApplication(); 
        $params = clone($mainframe->getParams('com_gmapfp'));
		if (!$catid) $catid = $params->get('catid');
	
        if($catid) {
			$db = JFactory::getDBO();
			$query = 'SELECT description, params' .
					' FROM #__categories ' .
					' WHERE id=' . $catid;
			$db->setQuery( $query );
			$result = $db->loadObject();
			$result->image = json_decode($result->params)->image;
			$result->marqueur = '';		
			if (property_exists(json_decode($result->params), 'default_marqueur_categories')) $result->marqueur = json_decode($result->params)->default_marqueur_categories;		
			return $result;
		}
		return false;
	}

}
?>
