<?php
	/*
	* GMapFP Component Google Map for Joomla! 1.7.x
	* Version 10.70pro
	* Creation date: Dcembre 2012
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

defined('_JEXEC') or die();

jimport( 'joomla.application.component.view' );

class GMapFPsViewGestionLieux extends JView
{
	function display($tpl = null)
	{
		$mainframe	= &JFactory::getApplication(); 
		$Itemid		= JRequest::getInt('Itemid'); 
		$option		= JRequest::getCMD('option'); 
		$document	= &JFactory::getDocument();
		$user   	= &JFactory::getUser();
		$params 	= &$mainframe->getParams();

		//gestion des droits
		require_once JPATH_COMPONENT_ADMINISTRATOR.'/helpers/gmapfp.php';
		$canDo	= GMapFPHelper::getActions();

		// Make sure you are logged in and have the necessary access rights
		if (!$canDo->get('core.create') and !$canDo->get('core.delete') and !$canDo->get('core.edit') and !$canDo->get('core.edit.state')) {
				$link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid, false);
				$returnURL = JRoute::_('index.php?',false);
				$fullURL = new JURI($link);
				$fullURL->setVar('return', base64_encode($returnURL));
				$link = $fullURL->toString();
				$mainframe->redirect($link);
			return;
		}

		// Get data from the model
		$items		= & $this->get( 'Data');
        $total      = & $this->get( 'Total' );
		
        // Parametres
        $params->def('nombre_articles',  20);

        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $default_limit = $params->get('nombre_articles');
        $limit = $mainframe->getUserStateFromRequest($option.$Itemid.'.limit', 'limit', $default_limit, 'int');

        JRequest::setVar('limit', (int) $limit);

        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);

		$document->addCustomTag('<link rel="stylesheet" href="'.$this->baseurl.'/components/com_gmapfp/views/editlieux/css/icon.css" type="text/css" media="screen" />');
		$document->addCustomTag('<link rel="stylesheet" href="'.$this->baseurl.'/components/com_gmapfp/views/editlieux/css/general.css" type="text/css" media="screen" />');

		$filtrevilles = array();
		$filtrevilles[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_VILLE_FILTRE' ).' --' );
				foreach($this->get('listville') as $temp) {
					$filtrevilles[] = JHTML::_('select.option', $temp->ville );
				}

		$filtredepartements = array();
		$filtredepartements[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_DEPARTEMENT_FILTRE' ).' --' );
				foreach($this->get('listdepartement') as $temp) {
					$filtredepartements[] = JHTML::_('select.option', $temp->departement );
				}
		
		$filtrepays = array();
		$filtrepays[] = JHTML::_('select.option', 0, '-- '.JText::_( 'GMAPFP_PAYS_FILTRE' ).' --' );
				foreach($this->get('listpays') as $temp) {
					$filtrepays[] = JHTML::_('select.option', $temp->pay );
				}
		
		$filtrecategories = array();
		$filtrecategories[] = JHTML::_('select.option', '0', '-- '.JText::_( 'GMAPFP_CATEGORIE_FILTRE' ).' --' );
		$cn = 0;
		$listcategories = JHtml::_('category.options', 'com_gmapfp');
		$Les_catid = $params->get('gmapf_categories_selected');
		foreach($listcategories as $temp) {
			if (empty($Les_catid)){
					$cn++;
					$filtrecategories[] = JHTML::_('select.option', $temp->value, $temp->text );
			} else {
				if (in_array($temp->value, $Les_catid, true)) {
					$cn++;
					$filtrecategories[] = JHTML::_('select.option', $temp->value, $temp->text );
				}
			}
		}

		$filter_order		= $mainframe->getUserStateFromRequest( $option.$Itemid.'filter_order',		'filter_order',		'a.ordering',	'cmd' );
		$filter_order_Dir 	= $mainframe->getUserStateFromRequest( $option.$Itemid.'filter_order_Dir', 	'filter_order_Dir', 	'', 											'word');
		$search				= $mainframe->getUserStateFromRequest( $option.$Itemid.'search', 			'search', 				'',												'string' );
		$filtreville 		= $mainframe->getUserStateFromRequest( $option.$Itemid.'filtreville', 		'filtreville', 			'-- '.JText::_( 'GMAPFP_VILLE' ).' --', 		'string' );
		$filtredepartement 	= $mainframe->getUserStateFromRequest( $option.$Itemid.'filtredepartement', 'filtredepartement', 	'-- '.JText::_( 'GMAPFP_DEPARTEMENT' ).' --', 	'string' );
		$filtrepay		 	= $mainframe->getUserStateFromRequest( $option.$Itemid.'filtrepay', 		'filtrepay', 			'-- '.JText::_( 'GMAPFP_PAYS' ).' --', 			'string' );
		$filtrecategorie 	= $mainframe->getUserStateFromRequest( $option.$Itemid.'filtrecategorie', 	'filtrecategorie', 		0, 	'string' );

		$lists['ville'] 		= JHTML::_('select.genericlist', $filtrevilles, 'filtreville', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtreville );
		$lists['departement'] 	= JHTML::_('select.genericlist', $filtredepartements, 'filtredepartement', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtredepartement );
		$lists['pays'] 			= JHTML::_('select.genericlist', $filtrepays, 'filtrepay', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtrepay );
		//$lists['categorie'] 	= JHTML::_('list.category',  'filtrecategorie', $option, intval( $filtrecategorie ), 'onchange="form.submit()"');
		$lists['categorie'] 	= JHTML::_('select.genericlist', $filtrecategories, 'filtrecategorie', 'size="1" class="inputbox" onchange="form.submit()"', 'value', 'text', $filtrecategorie );

		// table ordering
		$lists['order_Dir'] = $filter_order_Dir;
		$lists['order'] = $filter_order;

		// search filter
		$lists['search'] = $search;

		$this->assignRef('canDo', $canDo);
		$this->assignRef('lists', $lists);
		$this->assignRef('items',	$items);
		$this->assignRef('pagination', $pagination);
		$this->assignRef('params', $params);
		$this->assignRef('total', $total);

		JHtml::_('behavior.mootools');

		if ($this->params->get('menu-meta_description'))
			$document->setDescription($this->params->get('menu-meta_description'));
		if ($this->params->get('menu-meta_keywords'))
			$document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		if ($this->params->get('robots'))
			$document->setMetadata('robots', $this->params->get('robots'));

		parent::display($tpl);

	}
}
