<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.93pro
	* Creation date: Aout 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/
defined('_JEXEC') or die;

jimport( 'joomla.application.component.view');
jimport( 'joomla.html.pane' );

class GMapFPsViewGMapFP extends JView
{
	function display($tpl = null)
    {
		$mainframe = JFactory::getApplication(); 
		$Itemid    = JRequest::getInt('Itemid'); 
		$option    = JRequest::getCMD('option'); 
        $document  = JFactory::getDocument();
        $params = clone($mainframe->getParams('com_gmapfp'));
		
		//n'active ajax que s'il y a que la carte
		$ajax = ($params->get('gmapfp_filtre') and $params->get('gmapfp_ajax', 0) and $params->get('type_affichage', 0) == 2);
		
        $model      = $this->getModel(); 
		$model->set_ajax($ajax);
		$perso		= $model->getPersonnalisation($params->get('id_perso'));
        $lieux      = $model->getGMapFPList();
        $custom     = $model->getCustom();
		if (($params->get('show_description', 1) || $params->def('show_description_image', 1)) && $params->def('catid'))
			$category	= $model->getCategory();
		else $category = "";
		if ($params->get('gmapfp_filtre')) {
			$filtres		= $model->getFilterList($option, $Itemid, array());
	        $this->assignRef('filtres'		, $filtres);
		}
		//die(print_r($lists));
		$lists['classements']	= $model->getClassements(1);
		$lists['labels']		= $model->getClassements(2);
		$lists['pictos']		= $model->getClassements(3);
       	$map        = $model->getView();
		
        // Parametres
        $params->def('nombre_articles',         4);
        $params->def('show_headings',           1);
        $params->def('show_pagination',         1);
        $params->def('show_pagination_results', 1);
        $params->def('show_pagination_limit',   1);
        $params->def('filter',                  1);

        $limitstart = JRequest::getVar('limitstart', 0, '', 'int');
        $default_limit = $params->get('nombre_articles');
        $limit = $mainframe->getUserStateFromRequest($option.$Itemid.'.limit', 'limit', $default_limit, 'int');

        JRequest::setVar('limit', (int) $limit);

        $total      = $this->get( 'Total' );
        jimport('joomla.html.pagination');
        $pagination = new JPagination($total, $limitstart, $limit);

		//incremente le hit
		if (($this->getLayout() == 'article') && ($limitstart == 0))
		{
			$model = $this->getModel();
			$model->hit();
		}

        //ajout du fil d'actualit
        if($params->get('show_feed_link', 1) == 1)
        {
            $link   = '&format=feed&limitstart=';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
        }

		$lieu = array();
        $this->lieu = $lieu;	 
		
		/*
		 * Handle the breadcrumbs
		 */
		$app	= JFactory::getApplication();
		$menus	= $app->getMenu();
		$menu	= $menus->getActive();
		$pathway	= $mainframe->getPathway();
		$layout = '';
		if ($menu && array_key_exists('layout', $menu->query)) $layout = $menu->query['layout'];

		if (($this->getLayout() == 'article')&&($layout != 'article')) {
			if (@$lieux[0] and count($lieux) == 1)
				$pathway->addItem($lieux[0]->nom, '');
			else {
				JError::raiseError(404, JText::_('COM_GMAPFP_PLACE_NOT_FOUND'));
				return false;
			}
		}
		/********/

        $this->ajax = $ajax;	        
        $this->map = $map;	        
        $this->custom = $custom;
        $this->lieux = $lieux;
        $this->perso = $perso;
        $this->pagination = $pagination;
        $this->params = $params;
        $this->total = $total;
        $this->lists = $lists;
		$this->category = $category;

		if ($this->params->get('menu-meta_description'))
			$document->setDescription($this->params->get('menu-meta_description'));
		if ($this->params->get('menu-meta_keywords'))
			$document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		if ($this->params->get('robots'))
			$document->setMetadata('robots', $this->params->get('robots'));

        parent::display($tpl);
    }   

	function &getItem($index = 0, &$params)
	{
		jimport( 'joomla.html.parameter' );

		$item 		= $this->lieux[$index];

		// Get the page/component configuration and article parameters
		$item->params = clone($params);
		$aparams = new JParameter($item->attribs);

		// Merge article parameters into the page configuration
		$item->params->merge($aparams);

		return $item;
	}

	function &getChamps($index = 0, &$params = '')
	{
		jimport( 'joomla.html.parameter' );
        $model      = $this->getModel(); 

		$champ 		= $this->lieux[$index]->id;
		$champs     = $model->getChamps($champ);
		if (!$champs)  $champs = array();

		return $champs;
	}

	function getChampsHtml ($position, $pane ='')
	{
		$dispatcher	= JDispatcher::getInstance();
		$html = '';
		foreach ($this->champs as $champ)
			if ($champ->position == $position and $champ->valeur){
				$label = '';
				if ($position == 5 and $pane) $html .= $pane->startPanel($champ->label, $champ->alias);
					else $label = '<label>'.$champ->label.' : </label>';
				switch ($champ->type) {
					case 2:
					case 7:
					case 8:
						//traitement des plugins
						$article = new stdClass();
						$article->text = $champ->valeur; 
						$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp',& $article, & $this->params, 0)); 
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>'.$article->text.'</span></p>';
						break;
					case 3:
					case 6:
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>';
						$html .= str_replace ("\r\n",$champ->view_separator, $champ->valeur);
						$html .= '</span></p>';
						break;
					case 4:
					case 5:
					default:
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>'.$champ->valeur.'</span></p>';
				}
				if ($position == 5 and $pane) $html .= $pane->endPanel();

			}
		unset($champ, $article, $results);
		return $html;
	}
}
?>
