<?php
	/*
	* GMapFP Component Google Map for Joomla! 2.5.x
	* Version 10.93pro
	* Creation date: Aout 2013
	* Author: Fabrice4821 - www.gmapfp.org
	* Author email: webmaster@gmapfp.org
	* License GNU/GPL
	*/

jimport( 'joomla.application.component.view');
jimport( 'joomla.html.pane' );

class GMapFPsViewGMapFPContact extends JView
{
    function display($tpl = null)
    {
		$mainframe = JFactory::getApplication(); 
		$Itemid    = JRequest::getInt('Itemid'); 
		$option    = JRequest::getCMD('option'); 

        $document   = JFactory::getDocument();

        $params = clone($mainframe->getParams('com_gmapfp'));
        $model      = &$this->getModel(); 

		//n'active ajax que s'il y a que la carte
		$model->set_ajax(false);

        // Parametres
        $params->def('show_headings',           1);

        //ajout du fil d'actualit
        if($params->get('show_feed_link', 1) == 1)
        {
            $link   = '&format=feed&limitstart=';
            $attribs = array('type' => 'application/rss+xml', 'title' => 'RSS 2.0');
            $document->addHeadLink(JRoute::_($link.'&type=rss'), 'alternate', 'rel', $attribs);
            $attribs = array('type' => 'application/atom+xml', 'title' => 'Atom 1.0');
            $document->addHeadLink(JRoute::_($link.'&type=atom'), 'alternate', 'rel', $attribs);
        }

        $custom     = $model->getCustom();
		$perso		= $model->getPersonnalisation($params->get('id_perso'));
        $rows       = $model->getGMapFPList();
       	$map        = $model->getView();
		$lists['classements']	= $model->getClassements(1);
		$lists['labels']		= $model->getClassements(2);
		$lists['pictos']		= $model->getClassements(3);

		JHTML::_('behavior.formvalidation');

        $this->assignRef('lists'		, $lists);
        $this->assignRef('custom'       , $custom);
        $this->assignRef('map'          , $map );	        
        $this->assignRef('row'          , $rows[0]);
        $this->assignRef('perso'        , $perso);
        $this->assignRef('params'       , $params);

		if ($this->params->get('menu-meta_description'))
			$document->setDescription($this->params->get('menu-meta_description'));
		if ($this->params->get('menu-meta_keywords'))
			$document->setMetadata('keywords', $this->params->get('menu-meta_keywords'));
		if ($this->params->get('robots'))
			$document->setMetadata('robots', $this->params->get('robots'));

        parent::display($tpl);
    }   

	function &getItem(&$params)
	{
		jimport( 'joomla.html.parameter' );

		$item 		=& $this->row;
		// Get the page/component configuration and article parameters
		$item->params = clone($params);
		$aparams = new JParameter($item->attribs);

		// Merge article parameters into the page configuration
		$item->params->merge($aparams);

		return $item;
	}

	function &getChamps($index = 0, &$params = '')
	{
		jimport( 'joomla.html.parameter' );
        $model      = $this->getModel(); 

		$champ 		= $this->row->id;
        $champs     = $model->getChamps($champ);
		if (!$champs)  $champs = array();
		
		return $champs;
	}

	function getChampsHtml ($position, $pane ='')
	{
		$dispatcher	= JDispatcher::getInstance();
		$html = '';
		foreach ($this->champs as $champ)
			if ($champ->position == $position and $champ->valeur){
				$label = '';
				if ($position == 5 and $pane) $html .= $pane->startPanel($champ->label, $champ->alias);
					else $label = '<label>'.$champ->label.' : </label>';
				switch ($champ->type) {
					case 2:
					case 7:
					case 8:
						//traitement des plugins
						$article = new stdClass();
						$article->text = $champ->valeur; 
						$results = $dispatcher->trigger('onContentPrepare', array ('com_gmapfp',& $article, & $this->params, 0)); 
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>'.$article->text.'</span></p>';
						break;
					case 3:
					case 6:
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>';
						$html .= str_replace ("\r\n",$champ->view_separator, $champ->valeur);
						$html .= '</span></p>';
						break;
					case 4:
					case 5:
					default:
						$html .= '<p class="'.$champ->alias.'">'.$label.'<span>'.$champ->valeur.'</span></p>';
				}
				if ($position == 5 and $pane) $html .= $pane->endPanel();

			}
		unset($champ, $article, $results);
		return $html;
	}

}
?>
